#include <dce/pthread.h>
#include <iostream.hxx>
#include <string.h>
#include "types.hxx"
#include "vms_status.hxx"
#include "status.hxx"
#include "daerequest.hxx"
#include "dae1srequest.hxx"

Status Dae1sRequest::insert(daeTransfer_t *transfer_buffer, int position)
{
    daeTransfer_t array[4];
    int nBytes = nWords * sizeof(fort_i2);
    array[0] = busAddress;
    array[1] = accessMode;
    array[2] = transferMode;
    array[3] = nBytes;
    memcpy(transfer_buffer + position, array, 4*sizeof(daeTransfer_t));
    if (transferMode == Send)
    {
	int offset = 4;
	memcpy(transfer_buffer + position + offset, buffer, nBytes);
    }
    return Status();
}

Status Dae1sRequest::retrieve(daeTransfer_t *transfer_buffer, int position)
{
    if (transferMode == Receive)
    {
	int nBytes = nWords * sizeof(fort_i2);
//	int offset = 4;    // Don't get header on return
	int offset = 0;
    	memcpy(buffer, transfer_buffer + position + offset, nBytes);
    }
    return Status();
}

Dae1sRequest::Dae1sRequest(TransferMode t_mode, fort_i4 address, fort_i2* data, fort_i4 nwrds, AccessMode a_mode)
{
    transferMode = t_mode;
    busAddress = address; 
    buffer = data; 
    nWords = nwrds; 	// number of 16 bit words
    accessMode = a_mode;
}

Dae1sRequest::~Dae1sRequest()
{
}

// in units of daeTransfer_t
int Dae1sRequest::getTotalSize()
{
    int nBytes = nWords * sizeof(fort_i2);
    return 4 + (3 + nBytes)/sizeof(daeTransfer_t);
}

int Dae1sRequest::getSendSize()
{
    if (transferMode == Send)
    {
	return getTotalSize();
    }
    else
    {
	return 4;
    }
}

void Dae1sRequest::print(ostream& os)
{
    os << "Print\n";
    return;
}

ostream& operator<<(ostream& os, Dae1sRequest& request)
{
    request.print(os);
    return os; 
}
