//  Module:	DEBUG.HXX
//  
//  Function:	Debug and logging functions.
//		This supports the debugging/logging functions as defined in ICE-ERR-2.
//		
//  Author:	R.Brodie 9/6/94

#ifndef	    ICE_DEBUG_LOADED
#define	    ICE_DEBUG_LOADED 1

#include <iostream.hxx>
#include <fstream.hxx>
#include "status.hxx"
#include "set.hxx"

typedef Set<int> IntSet;

extern const int DEBUG_G_NONE, DEBUG_G_ALL, DEBUG_G_FIRST_NORMAL;   // Definitions in DEBUG.CXX
extern const int DEBUG_G_END;

extern ostream_withassign cdebug;

class g_debug_init					    // Initialization class.
    {
    friend int debug_on(int facname);
    friend Status set_debug(String externopts);
    
    public:
		g_debug_init(char* group_text_i, int& group_id, const int member_array[]); 
		g_debug_init(char* group_text_i, int& group_id); 
 		~g_debug_init(void) {};					   
		static Status set_debug_command(String command);	   
		static Set<int> find_debug_group(String grpname);

    private:
		static int min_group_free;
		static SPListZero<IntSet> debug_group;
		static SPList<String> debug_g_text;
		static Set<int> current_debug_set;
    };

class g_debug_dummy_class
    {
    public: g_debug_dummy_class(...){};
    };

int debug_on(int facname);					    // The debug API as defined in ICE-ERR-2.
Status set_debug(String debugopts);
Status set_debug_externopts(String imagename);

#endif //   ICE_DEBUG_LOADED
