//  Module:	EDESCRIP_DEFS.H
//  
//  Function:	Definition of enumerated types for errors
//		
//
//  Author:	R.Brodie 28/9/93.

#ifndef	    ICE_EDESCRIP_DEFS_LOADED   
#define	    ICE_EDESCRIP_DEFS_LOADED  1

#include <string.hxx>
#include "status.hxx"

const int MAX_ERROR_INDEX = 999;
const int MAX_ERROR_MODULES = 100;


                                                                                                                     
class edescrip
    {
    public:	edescrip::edescrip(int ic_p, String text_p, error_sc_type sc_p);
		edescrip::edescrip(int& ic_p, String text_p);
		 
    private:	int icode;
		String text;
		error_sc_type scode;  
		static int* fcode_ptr;

    friend class edescrip_module_init;
    friend void IceErrorObject::print(ostream& stream) const;
    friend int  IceErrorObject::Errlevel(void) const;
    };		

class edescrip_module_init
    {
    friend void IceErrorObject::print(ostream& stream) const;
    friend int  IceErrorObject::Errlevel(void) const;
    
    public:	edescrip_module_init(edescrip fac_array[]);	
    private:	
		static edescrip *all_edescrips[MAX_ERROR_MODULES];
		static int min_error_free;
    };

#endif	//  ICE_EDESCRIP_DEFS_LOADED
