#ifndef TYPES_HXX
#define TYPES_HXX

#include <dce/rpc.h>

#if defined(vms) || defined(__vms) || defined(VMS) || defined(__VMS)
#define WE_ARE_VMS	1
#endif

#if defined(unix) || defined(__unix) || defined(__unix__)
#define WE_ARE_UNIX	1
#endif

/*
 * general data types
 */

#include <dce/idlbase.h>

typedef idl_long_int fort_i4;		// 32 bit integer
typedef idl_short_int fort_i2;		// 16 bit integer
typedef idl_ushort_int ufort_i2;	// 16 bit unsigned integer

enum Boolean { False=0, True=1 };

// Used for passing string from Fortran
typedef struct
{
    fort_i4 length;
    char value[512];
} STRING;

typedef struct dae_context {
    unsigned_char_t *handle;	// string representation of client binding handle
    unsigned long id;		// unique identification number of context
    char *name;			// some deatils of the client (information only) passed in the open_dae() call
	} dae_context;


// Data type used for transferring data to DAE
typedef idl_long_int daeTransfer_t;

typedef enum RequestType { DAE1S=0, DAE2=1 } RequestType;
typedef enum TransferMode { Send=0, Receive=1, Reset=2 } TransferMode;
typedef enum AccessMode { AccessMem=0, AccessIO=1} AccessMode;
typedef enum RestartOption { No=0, Yes=1, IfNeeded=2 } RestartOption;
ostream& operator<<(ostream& os, enum RequestType type);

#endif	/* TYPES_HXX */
