/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Axes
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class Axes : public Drawable_objects
{
      // DESCRIPTION: Plot title
      private: String  title;
      // DESCRIPTION: logical that is TRUE if a box
      // is to be drawn around the plot
      private: int box_visible;
      // DESCRIPTION: is Y axis at x=0
      private: int Y_at_X0;
      // DESCRIPTION: is X axis at y=0
      private: int X_at_Y0;
      // DESCRIPTION: are major tick marks plotted
      private: int major_tick_marks;
      // DESCRIPTION: are minor tick marks plotted
      private: int minor_tick_marks;
      // DESCRIPTION: gap between major tick marks on X axis
      private: float Xtick_spacing;
      // DESCRIPTION: Distance in world co-ordinates between major Y tick marks
      private: float Ytick_spacing;
      // DESCRIPTION: are ticks plotted inside box
      private: int inset_ticks;
      // DESCRIPTION: is Y axis linear
      private: int Ylinear;
      // DESCRIPTION: logical that is true if the X axis is not logarithmic
      private: int Xlinear;
      // DESCRIPTION: size of characters used for numerical labels
      private: float character_size;
      // DESCRIPTION: font type for text labels
      private: int font;
      // DESCRIPTION: character size of text labels
      private: float text_char_size;
      // DESCRIPTION: text of X axis label
      private: String X_label;
      // DESCRIPTION: text of Y axis label
      private: String Y_label;
      // DESCRIPTION: angle of Y axis text to horizontal (0 or 90)
      private: int Y_orientation;
      // DESCRIPTION: logical that is true if a graticule is to be plotted
      // on the major tick marks
      private: int graticule;

      private: int show_X_values;
      private: int show_Y_values;
      private: int X_label_vertical;
      private: int Y_label_vertical;
   

      // DESCRIPTION: default 'is box visile'
      public: static int BOX_VISIBLE;
      // DESCRIPTION: 
      public: static int  Y_AT_X0;
      // DESCRIPTION: 
      public: static int  X_AT_Y0;
      // DESCRIPTION: 
      public: static int  MAJOR_TICK_MARKS;
      // DESCRIPTION: 
      public: static int  MINOR_TICK_MARKS;
      // DESCRIPTION: 
      public: static int  INSET_TICKS;
      // DESCRIPTION: 
      public: static int  YLINEAR;
      // DESCRIPTION: 
      public: static int  XLINEAR;
      // DESCRIPTION: 
      public: static float  CHARACTER_SIZE;
      // DESCRIPTION: 
      public: static int  FONT;
      // DESCRIPTION: 
      public: static float  TEXT_CHAR_SIZE;
      // DESCRIPTION: 
      public: static String  X_LABEL;
      // DESCRIPTION: 
      public: static String  Y_LABEL;
      // DESCRIPTION: 
      public: static int  Y_ORIENTATION;
      // DESCRIPTION: 
      public: static int  GRATICULE;
      // DESCRIPTION: 
      public: static String  TITLE;
private: int linetype;
public: static int LINE_TYPE; 
      // DESCRIPTION: displays axes on display surface
      //  PRECOND: must be declared.
      //  POSTCOND: in display list
      public: void display ();
      // DESCRIPTION: Constructor
      //  PRECOND: 
      //  POSTCOND: 
      public: Axes (String tt,
		    String yl=" ",
		    String xl=" ",
	            float tcs=0.0,
		    float cs=0.0,
		    int f=0,
		    float xts=0.0,
		    float yts=0.0,
		    int sh=-1,
		    int thickness=0,
		    int show_x = 1,
		    int show_y = 1,
		    int y_numbers_horizontal = 0,
		    int x_label_vertical = 0,
		    int y_label_vertical = 1,
		    int line=0
);
      // DESCRIPTION: Destructor
      //  PRECOND: 
      //  POSTCOND: 
      public:virtual  ~Axes ();
};
