/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "Cone.h"
#include "sbroutines.h"

Cone::Cone(const g_real* base, const g_real* apex, g_real radius, pg_int nsides, 
    g_real* eye, g_real* light, const ThreeDObjectColours& table) :
    ThreeDObject(eye, light, table), m_radius(F(radius)), m_nsides(nsides)
{
    int c;
    m_base = new pg_float[3];
    m_apex = new pg_float[3];
    for (c=0;c<3;c++)
    {
        m_base[c] = F(base[c]);
        m_apex[c] = F(apex[c]);
    }
}

Cone::~Cone()
{
	delete []m_base;
	delete []m_apex;
}

void Cone::display()
{
    sbcone(m_eye,m_base,m_apex,m_radius,m_table.ci_low(),m_table.ci_high(),
        m_light,m_nsides);
    sbccrt(1,m_table.ci_low(),m_table.ci_high(),m_table.table());
}
