/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef DRAWABLE_OBJECTS_H
#define DRAWABLE_OBJECTS_H

//+++
//
// CLASS: Drawable_objects
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class Drawable_objects
{
      // DESCRIPTION: Default storage
      public: static int LINE_THICKNESS;
      // DESCRIPTION: default value 
      public: static int LINE_COLOUR;
      // DESCRIPTION: thickness of line
      protected: int line_thickness;
      // DESCRIPTION: colour of line for outline
      public: int line_colour;
      // DESCRIPTION: greater than 0 when object invisible
      public: int  invisible;
 
      public: Drawable_objects(int line_thickness_, int line_colour_, int invisible_ = 0) :
		line_thickness(line_thickness_), line_colour(line_colour_), invisible(invisible_) {}

      public: Drawable_objects() : line_thickness(LINE_THICKNESS), line_colour(LINE_COLOUR), invisible(0) {}

      // DESCRIPTION: virtual jobby
      //  PRECOND: 
      //  POSTCOND: 
      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  
      public: virtual void  cursor (float*,float*,String& );
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  
      public: virtual ~Drawable_objects();

      // Report what sort of object we are
      public: virtual ostream& identity(ostream& os);

      public: virtual int query(GenieWorkspace& info);

};

#endif /* DRAWABLE_OBJECTS_H */
