/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef ELLIPSOID_H
#define ELLIPSOID_H

#include "ThreeDObject.h"
//+++
//
// CLASS: Ellipsoid
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class Ellipsoid : public ThreeDObject
{
private:    
    pg_float* m_paxes;
    pg_float* m_centre;
    pg_int m_icline;
    pg_float m_anglin;

public:
    Ellipsoid(const g_real* paxes, const g_real* centre, pg_int icline,
    g_real anglin, const g_real* eye, const g_real* light, const ThreeDObjectColours& table);
	Ellipsoid() : ThreeDObject(), m_paxes(0), m_centre(0), m_icline(-1),
	m_anglin(-1.0) {}

      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  

      public: virtual ~Ellipsoid();
};

#endif /* ELLIPSOID_H */
