/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Errors
//
// CLASS DESCRIPTION: 
//
// 
//
//---
class Errors
{
      // DESCRIPTION: object that has failed
      public: static String  OBJECT[5];
      // DESCRIPTION: the reason for failure
      public: static String  FAILURE[5];
      // DESCRIPTION: solution to the problem
      public: static String SOLUTION[5];
 
      // DESCRIPTION: constructor
      //  PRECOND:  
      //  POSTCOND:  
      public:  Errors ( );
      // DESCRIPTION: destructor
      //  PRECOND:  
      //  POSTCOND:  
      public:  ~Errors ( );
      // DESCRIPTION: clears any errors that are present
      //  PRECOND:  
      //  POSTCOND:  
      public: void  clear ( );
      // DESCRIPTION: returns true if errors are present
      //  PRECOND:  
      //  POSTCOND:  
      public: int  status ( );
      // DESCRIPTION: returns the object causing the error
      //  PRECOND:  
      //  POSTCOND:  
      public: const char* object (int number = 1 );
      // DESCRIPTION: returns the reason for failure
      //  PRECOND:  
      //  POSTCOND:  
      public: const char* failure (int number = 1 );
      // DESCRIPTION: returns a solution if known
      //  PRECOND:  
      //  POSTCOND:  
      public: const char* solution (int number =1 );
      // DESCRIPTION: return all three info strings
      //  PRECOND:  
      //  POSTCOND:  
      public: String message (int number = 1 );
      // DESCRIPTION: adds an error to the list, moving others down
      //  PRECOND:  
      //  POSTCOND:  
      public: void add_error(const char*,const char*,const char* );
};
