/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef ISOSURFACE_H
#define ISOSURFACE_H

#include "ThreeDLattice.h"
//+++
//
// CLASS: IsoSurface
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class IsoSurface : public ThreeDLattice
{
    pg_float m_dsurf;
	pg_int m_transparency;
public:
    IsoSurface(g_real dsurf, pg_int transparency, const g_real* lattice, const
        g_real* density, pg_int n1, pg_int n2, pg_int n3, const g_real* eye, 
        const g_real* light, const ThreeDObjectColours& table);
	IsoSurface() : ThreeDLattice(), m_dsurf(-1.0), m_transparency(-1) {}

      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  
};

#endif /* ISOSURFACE_H */
