/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef LatticePlane_H
#define LatticePlane_H

#include "ThreeDLattice.h"
//+++
//
// CLASS: LatticePlane
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class LatticePlane : public ThreeDLattice
{
protected:
    pg_float* m_normal;
    pg_float* m_apoint;
    pg_int m_edge;
	pg_int m_transparency;
public:
    LatticePlane(const g_real* normal, const g_real* apoint, pg_int edge, 
        pg_int transparency, const g_real* lattice, const g_real* density, 
        pg_int n1, pg_int n2, pg_int n3, const g_real* eye, const g_real* light, const
        ThreeDObjectColours& table);
	LatticePlane() : ThreeDLattice(), m_normal(0), m_apoint(0), m_edge(-1), 
	    m_transparency(-1) {}

      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  

      public: virtual ~LatticePlane();
};

#endif /* LatticePlane_H */
