/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDObject.h"
#include "ThreeDLattice.h"
#include "LatticePlane.h"
#include "LatticeSlice.h"
#include "sbroutines.h"

LatticeSlice::LatticeSlice(g_real dlow, g_real dhigh, const g_real* normal, 
    const g_real* apoint, pg_int edge, pg_int transparency, const g_real* 
    lattice, const g_real* density, pg_int n1, pg_int n2, pg_int n3, const 
    g_real* eye, const g_real* light, const ThreeDObjectColours& table) :
    LatticePlane(normal, apoint, edge, transparency, lattice, density, n1, n2,
    n3, eye, light, table), m_dlow(F(dlow)), m_dhigh(F(dhigh)) {} 

void LatticeSlice::display()
{
// dimensions flipped for fortran!
    sbslic(m_eye, m_lattice, m_density, m_n3, m_n2, m_n1, m_dlow, m_dhigh,
        m_table.ci_low(), m_table.ci_high(), m_normal, m_apoint, m_edge);
    sbccrt(1,m_table.ci_low(),m_table.ci_high(),m_table.table());
 }
