/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Picture
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class Picture
{
      // DESCRIPTION: Linked list of all objects displayed
      // INCLUDING the order in which they are displayed
      public: Drawable_objectsPTRList disp_list;
 
      // DESCRIPTION: Adds an object to the display list, returning index 
      //  PRECOND: 
      //  POSTCOND: 
      public: int disp_add(Drawable_objectsPTR);
      // DESCRIPTION: Re-draws all objects in the display list
      //  PRECOND: 
      //  POSTCOND: 
      public: void re_display ();
      // DESCRIPTION: initialise the window
      //  PRECOND: 
      //  POSTCOND: 
       Picture ();
      // DESCRIPTION: removes an object from the display list
      //  PRECOND: 
      //  POSTCOND: 
       ~Picture ();
      // DESCRIPTION: 
      //  PRECOND: 
      //  POSTCOND: 
      public: void disp_remove (int primno = 1);
      // DESCRIPTION: removes a viewport & primitives
      //  PRECOND: 
      //  POSTCOND: 
      public: void remove_View (int viewport = 1);
      // DESCRIPTION: undoes the last remove
      //  PRECOND: 
      //  POSTCOND: 
      public: void undo_remove ();
      // DESCRIPTION: safer than Viewport::cursor
      //  PRECOND:  
      //  POSTCOND:  
      public: void  cursor (int viewnumber, float* world, float* device, String& letter );
      // Return the object number of an intem on the list
      public: int objectNumber(Drawable_objectsPTR PTR);
      public: Drawable_objectsPTR objectPointer(int objnum);
      // Return the number of items on the display list
      public: int length();

      public: ostream& identity(ostream& os, int objnum = -1);

      // Find out information about an object on the display list
      public: int query(GenieWorkspace& info, int objnum = -1);

      public: int find(Drawable_objectsPTR p) { return disp_list.find(p); }	// find object
};
