/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef PLANE_H
#define PLANE_H

#include "ThreeDObject.h"
//+++
//
// CLASS: Plane
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class Plane : public ThreeDObject
{
    pg_int m_nvertices;
    pg_float* m_vertices;
	pg_int m_transparency;
public:
	Plane(const g_real* vertices, pg_int nvertices, pg_int transparency, const g_real* eye, 
	    const g_real* light, const ThreeDObjectColours& table);
	Plane() : ThreeDObject(), m_nvertices(-1), m_vertices(0), m_transparency(-1) {}

      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  

      public: virtual ~Plane();
};

#endif /* PLANE_H */
