/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef ROD_H
#define ROD_H

#include "ThreeDObject.h"
//+++
//
// CLASS: Rod
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class Rod : public ThreeDObject
{
    pg_float* m_end1;
    pg_float* m_end2;
    pg_float m_radius;
    pg_int m_nsides;
    pg_int m_lend;
public:
    Rod(const g_real* end1, const g_real* end2, g_real radius, pg_int nsides, 
    pg_int lend, const g_real* eye, const g_real* light, const ThreeDObjectColours& table);
    Rod() : ThreeDObject(), m_end1(0), m_end2(0), m_radius(-1.0), m_nsides(-1),
    m_lend(-1) {}
	
      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  

      public: virtual ~Rod();
};

#endif /* ROD_H */
