/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

// Streams.h: interface for the CStreams class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STREAMS_H__0AEF0BCD_EA33_11D1_A6BB_00609709EB73__INCLUDED_)
#define AFX_STREAMS_H__0AEF0BCD_EA33_11D1_A6BB_00609709EB73__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CStreams  
{
public:
	void ClearAll();
//	const istream& In();        not sure how to use this one
	const char* Out();
	const char* Inf();
	const char* Err();
	const char* Dbg();
	CStreams(bool bUseTerminal, bool bInf = true, bool bDebug = true);
	virtual ~CStreams();

private:
	istream* m_pgoIn;
	genie_ostream* m_pgoOut;
	genie_ostream* m_pgoInf;
	genie_ostream* m_pgoErr;
	genie_ostream* m_pgoDbg;
	static unsigned s_dwSessionID;
};

#endif // !defined(AFX_STREAMS_H__0AEF0BCD_EA33_11D1_A6BB_00609709EB73__INCLUDED_)
