/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDObject.h"
#include "TwoDLattice.h"
#include "Surface.h"
#include "sbroutines.h"

Surface::Surface(g_real dlow, g_real dhigh, g_real dvert, const g_real* lattice, 
    const g_real* density, pg_int n1, pg_int n2, const g_real* eye, const g_real* light, 
    const ThreeDObjectColours& table) : TwoDLattice(lattice, density, n1, n2, 
    eye, light, table), m_dlow(F(dlow)), m_dhigh(F(dhigh)), m_dvert(F(dvert)) {}

void Surface::display()
{
    // dimensions flipped for fortran!
    sb2srf(m_eye, m_lattice, m_density, m_n2, m_n1, m_dlow, m_dhigh, m_dvert,
        m_table.ci_low(), m_table.ci_high(), m_table.ncband(), m_light, 
        m_table.shine());
    sbccrt(1,m_table.ci_low(),m_table.ci_high(),m_table.table());
}
