/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Text
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class Text : public Drawable_objects
{
      // DESCRIPTION: default text string to display
      public: static String STRING_TEXT;
      // DESCRIPTION: default text orientation
      public: static float ORIENTATION;
      // DESCRIPTION: default font for text
      public: static int FONT;
      // DESCRIPTION: default size
      public: static float CHARACTER_SIZE;
      // DESCRIPTION: text of string to appear
      private: String string_text;
      // DESCRIPTION: angle of text to horizontal
      private: float orientation;
      // 0.5 = centre, 0.0 = left, 1.0 = right
      private: float justify;
      // DESCRIPTION: size of character used for text
      private: float character_size;
      // DESCRIPTION: font number for text
      private: int font;
      // DESCRIPTION: start position of text
      private: float X_ordinate;
      // DESCRIPTION: start point of text
      private: float Y_ordinate;
 
      // DESCRIPTION: displays the text in the current viewport
      //  PRECOND: must be declared
      //  POSTCOND: 
      public: void display ();
      // DESCRIPTION: Constructor
      //  PRECOND: 
      //  POSTCOND: 
      public: Text (float x, float y, String word = " ", float size=0.0, int shade=-1,float orient=-1.0, int cset=0, int thick=0,float justify=0.0);
      // DESCRIPTION: Destructor
      //  PRECOND: 
      //  POSTCOND: 
      public: virtual ~Text ();
};
