/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDObject.h"
#include "ThreeDLattice.h"

ThreeDLattice::ThreeDLattice(const g_real* lattice, const g_real* density,
    pg_int n1, pg_int n2, pg_int n3, const g_real* eye, const g_real* light, 
    const ThreeDObjectColours& table) : ThreeDObject(eye,light,table), m_n1(n1), m_n2(n2), m_n3(n3) 
{
	int c;
    int l = (m_n1+1) * (m_n2+1) * (m_n3+1);
	m_lattice = new pg_float[12];
	m_density = new pg_float[l];
	for (c=0;c<12;c++)
        m_lattice[c]=F(lattice[c]);
    for (c=0;c<l;c++)
		m_density[c]=F(density[c]);
}

ThreeDLattice::~ThreeDLattice()
{
	delete []m_lattice;
	delete []m_density;
}
