/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDLine.h"
#include "sbroutines.h"

ThreeDLine::ThreeDLine(const g_real* end1, const g_real* end2, pg_int colour, 
    pg_int dash, g_real* eye, g_real* light, const ThreeDObjectColours& table) : 
    ThreeDObject(eye, light, table), m_colour(colour), m_dash(dash)
{
    int c;
    m_end1 = new pg_float[3];
    m_end2 = new pg_float[3];
    for (c=0;c<3;c++)
    {
        m_end1[c] = F(end1[c]);
        m_end2[c] = F(end2[c]);
    }
}

ThreeDLine::~ThreeDLine()
{
	delete []m_end1;
	delete []m_end2;
}

void ThreeDLine::display()
{
//    pg_float x0, y0, r0;
    sbline(m_eye,m_end1,m_end2,m_colour,m_dash);
}
