/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDObjectColours.h"
#include "ThreeDObject.h"

ThreeDObject::ThreeDObject(const g_real* eye, const g_real* light, const
    ThreeDObjectColours& table) : m_table(table)
{
	int i;
	m_eye = new pg_float[3];
	m_light = new pg_float[3];
	for (i=0;i<3;i++)
	{
		m_eye[i]=F(eye[i]);
		m_light[i]=F(light[i]);
	}
}

ThreeDObject::~ThreeDObject()
{
	delete []m_eye;
	delete []m_light;
}
