/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef THREE_D_OBJECT_H
#define THREE_D_OBJECT_H

#include "ThreeDObjectColours.h"
//+++
//
// CLASS: Drawable_objects
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class ThreeDObject : public Drawable_objects
{
protected:
	pg_float* m_eye;
	pg_float* m_light;
	ThreeDObjectColours m_table;
public:
	ThreeDObject(const g_real* eye, const g_real* light, const ThreeDObjectColours& table);
	ThreeDObject() : m_eye(0), m_light(0), m_table() {}
	const ThreeDObjectColours& table() const { return m_table; }
        virtual ~ThreeDObject();
};

#endif /* THREE_D_OBJECT_H */
