/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef THREE_D_OBJECT_COLOURS_H
#define THREE_D_OBJECT_COLOURS_H

#include "Pginclude.h"

class ThreeDObjectColours
{
private:
    pg_int m_ci_low;
    pg_int m_ci_high;
    pg_int m_shine; 		// 1=shiney 0=diffuse
    pg_int m_ncband;
    pg_int* m_table;

public:
    ThreeDObjectColours(pg_int ci_low, pg_int ci_high, pg_int shine, pg_int
        ncband, const g_integer* table);
    ThreeDObjectColours() : m_ci_low(-1), m_ci_high(-1), m_shine(-1),
        m_ncband(-1), m_table(0) {}
    ThreeDObjectColours(const ThreeDObjectColours& c);
    ~ThreeDObjectColours();
    ThreeDObjectColours& operator=(const ThreeDObjectColours& c);
    pg_int ci_low() const { return m_ci_low; }
    pg_int ci_high() const { return m_ci_high; }
    pg_int shine() const { return m_shine; }
    pg_int ncband() const { return m_ncband; }
    const pg_int* table() const { return m_table; }
    ostream& print(ostream& os) const;
};

inline ostream& operator<<(ostream& os, const ThreeDObjectColours& c)
{
    return c.print(os);
}

#endif /* THREE_D_OBJECT_COLOURS_H */
