/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "ThreeDText.h"
#include "sbroutines.h"

ThreeDText::ThreeDText(const String& text, pg_int colour, const g_real* pivot, g_real justify,
    const g_real* orient, g_real size, g_real* eye, g_real* light, const 
    ThreeDObjectColours& table) : ThreeDObject(eye, light, table), m_text(text), 
    m_colour(colour), m_justify(F(justify)), m_size(F(size))
{
    int c;
    m_pivot = new pg_float[3];
    m_orient = new pg_float[6];
    for (c=0;c<3;c++)
        m_pivot[c] = F(pivot[c]);
    for (c=0;c<6;c++)
        m_orient[c] = F(orient[c]);
}

ThreeDText::~ThreeDText()
{
	delete []m_pivot;
	delete []m_orient;
}

void ThreeDText::display()
{
    STRING s;
    s.length = m_text.length();
    strcpy(s.spot, m_text);
    sbtext(m_eye,s,m_colour,m_pivot,m_justify,m_orient,m_size);   
}
