/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef ThreeDText_H
#define ThreeDText_H

#include "ThreeDObject.h"
//+++
//
// CLASS: ThreeDText
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class ThreeDText : public ThreeDObject
{
    
    String m_text;
    pg_int m_colour;
    pg_float* m_pivot;
    pg_float m_justify;
    pg_float* m_orient;
    pg_float m_size; 
public:
    ThreeDText(const String& text, pg_int colour, const g_real* pivot, g_real 
    justify, const g_real* orient, g_real size, g_real* eye, g_real* light, 
    const ThreeDObjectColours& table);
	ThreeDText() : ThreeDObject(), m_text(""), m_colour(-1), m_pivot(0), m_justify(-1.0), m_orient(0),
	        m_size(-1.0) {}

      public: virtual void display ();
      // DESCRIPTION: dummy routine
      //  PRECOND:  
      //  POSTCOND:  

      public: virtual ~ThreeDText();
};

#endif /* ThreeDText_H */
