/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include <gnustring.h>
#include "g_types.h"
#include "Pginclude.h"
#include "Drawable_objects.h"
#include "Viewport.h"
#include "ThreeDViewport.h"
#include "sbroutines.h"

ThreeDViewport::ThreeDViewport(const g_real* eye, const g_real* light, float x1,    
    float x2,float y1,float y2,float X1, float X2,float Y1,float Y2, int colour)
     : Viewport( x1, x2, y1, y2, X1, X2, Y1, Y2, colour), m_buffer(1)
{
    int c;
    m_eye = new pg_float[3];
    m_light = new pg_float[3];
    for (c=0;c<3;c++)
    {
        m_eye[c]=F(eye[c]);
        m_light[c]=F(light[c]);
    }
}
    
ThreeDViewport::~ThreeDViewport()
{
    delete[] m_eye;
    delete[] m_light;
}

ThreeDViewport::ThreeDViewport(float x1, float x2, float y1, float y2,
    ThreeDViewport original) : Viewport(x1,x2,y1,y2,original), m_buffer(1)
{
    int c;
    m_eye = new pg_float[3];
    m_light = new pg_float[3];
    for (c=0;c<3;c++)
    {
        m_eye[c]=original.m_eye[c];
        m_light[c]=original.m_light[c];
    }
}

void ThreeDViewport::display()
{
    Viewport::display();
//     String bc("BC");
    pg_int maxbuf;
    pg_float bg[3];
    pgqcr(m_colour,bg[0],bg[1],bg[2]);
//     PGBOX_S(bc,0.0,0,bc,0.0,0);
    sbfint(bg,m_colour,1,m_buffer,maxbuf);
}

void ThreeDViewport::flushBitmap()
{
//     String bc("BC");
    sbfcls(m_buffer);
//     PGBOX_S(bc,0.0,0,bc,0.0,0);
}
