/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef THREE_D_VIEWPORT
#define THREE_D_VIEWPORT

#include "Pginclude.h"

class ThreeDViewport : public Viewport
{
    public:
        pg_float* m_eye;
        pg_float* m_light;
	    int m_buffer;	// buffer number for SBFCLS etc.

    public:
      	ThreeDViewport(const g_real* eye, const g_real* light,float x1,float x2,
      	    float y1,float y2,float X1=0.0, float X2=1.0,float Y1=0.0,float 
      	    Y2=1.0, int colour=0);
      	virtual ~ThreeDViewport();
      	void display();
      	ThreeDViewport (float, float, float, float, ThreeDViewport);
	    void flushBitmap();

};

#endif /* THREE_D_VIEWPORT */
