/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef TWO_D_LATTICE_H
#define TWO_D_LATTICE_H

//+++
//
// CLASS: TwoDLattice
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class GenieWorkspace;

class TwoDLattice : public ThreeDObject
{
protected:
	pg_float* m_lattice;
	pg_float* m_density;
    pg_int m_n1;
    pg_int m_n2;
public:
	TwoDLattice(const g_real* lattice, const g_real* density, pg_int n1,
	    pg_int n2, const g_real* eye, const g_real* light, const ThreeDObjectColours& table);
	TwoDLattice() : ThreeDObject(), m_lattice(0), m_density(0), m_n1(-1),
	    m_n2(-1) {}

      public: virtual ~TwoDLattice();
};

#endif /* TWO_D_LATTICE_H */
