/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Viewport
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class Viewport : public Drawable_objects
{
      // DESCRIPTION: world co-ordinates of lower left corner
      private: float X_W_origin;
      // DESCRIPTION: lower left corner of window
      private: float Y_W_origin;
      // DESCRIPTION: device co-ordinates of window origin
      private: float X_D_origin;
      // DESCRIPTION: device co-ordinates of upper right corner
      private: float X_D_limit;
      // DESCRIPTION: device co-ordinates of window origin
      private: float Y_D_origin;
      // DESCRIPTION: device co-ordinates of upper right corner
      private: float Y_D_limit;
      // DESCRIPTION: world co-ordinates of upper right corner
      private: float Y_W_limit;
      // DESCRIPTION: 
      private: float X_W_limit;

      protected: int m_colour;			// colour of viewport
 
      // DESCRIPTION: initialises the viewport,
      //  PRECOND: 
      //  POSTCOND: viewport area given world co-ordinates
      public: Viewport (float x1,float x2,float y1,float y2,float X1=0.0,
		float X2=1.0,float Y1=0.0,float Y2=1.0, int colour = 0);
      // DESCRIPTION: destructor
      //  PRECOND: 
      //  POSTCOND: 
      public: virtual ~Viewport ();
      // DESCRIPTION: makes the viewport the current plot focus
      //  PRECOND: 
      //  POSTCOND: 
      public: void display ();
      // DESCRIPTION: Create viewport copy with new device ordinates
      //  PRECOND: 
      //  POSTCOND: 
       Viewport (float, float, float, float, Viewport);
      // DESCRIPTION: returns device & world coordinates
      //  PRECOND: 
      //  POSTCOND: 
      public: void cursor (float world[], float device[], String& letter);
      // DESCRIPTION: returns the world co-ordintes given device
      //  PRECOND:  
      //  POSTCOND:  
      public: void  ret_world (float* device, float* world);

      public: int query(GenieWorkspace& info);
};
