/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

//+++
//
// CLASS: Window
//
// CLASS DESCRIPTION: 
//
// 
//
//---
 
class ColourMap;

class Window
{
      // DESCRIPTION: The width of the window in normalised device co-ordinates
      float X_dimension;
      // DESCRIPTION: The vertical size of the window in normalised device co-ordinates
      float Y_dimension;
      // DESCRIPTION: The number of pictures that will appear across the page
      pg_int h_pictures;
      // DESCRIPTION: number of pictures that will appear vertically
      // on the page
      pg_int v_pictures;
      // DESCRIPTION: List of class PICTUREs that appear on the page
      //PictureList Pict_list;
      // DESCRIPTION: The type of device for plotting
      String device_type;
      // DESCRIPTION: The name of the file for hardcopy
      String filename;
      float ratio;
      funcPtrI ExitFunction;
      funcPtrI MenuFunction;
      funcPtr RedrawFunction;
      String MenuTitle;
      String MenuItems;
      int Nitems;
      String WindowTitle;
      String IconName;
      pg_int device_id;			// PGPLOT device code
 
      public: ColourMap* m_map;		// colour map

      // DESCRIPTION: Method of initialising the window
      //  PRECOND: 
      //  POSTCOND: 
      public: Window (String device, String file = " ",float x=12.0,
		    float y=8.5, float ra=1.0,String title = "PGPLOT window",
		    String icont="PLOT", funcPtrI exf=NULL, funcPtr redrf=NULL,
		    String menutitle ="", int n=0,String menuitems="",
		    funcPtrI menuf=NULL);

      // DESCRIPTION: Method of removing the window
      // from the display surface - possible
      // only for some interactive devices.
      //  PRECOND: 
      //  POSTCOND: 
      public: void remove ();
      // DESCRIPTION: destructor
      //  PRECOND: 
      //  POSTCOND: 
      public: ~Window ();
      // DESCRIPTION: displays the window on the device
      //  PRECOND: 
      //  POSTCOND: 
      public: int create ();
      // DESCRIPTION: erases the graphics window
      //  PRECOND: 
      //  POSTCOND: 
      public: void installColourmap(ColourMap* map);
      public: void clean ();
      public: pg_int select ();
      public: String deviceType() const { return device_type; }
};
