/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef GENIE_CALLOUT_LIST
#define GENIE_CALLOUT_LIST

//
// The "GenieCalloutList" class is used to encapsulate the OOP parameters
// passed out from Smalltalk via geniecall()
// Once a class object is made, it allows easy initialisation of GenieVariables
// from their Smalltalk variable "name"
//
// The associate() method can be called diectly, but is usually invoked indirectly
// by a constructor of the GenieVariable object concerned
//
// Freddie Akeroyd, ISIS, 26/1/96
//

class GenieCalloutList
{
    private:
	char** m_names;				// List of variable names
	int m_count;				// number of names in the above list
  	OOP m_paramValues;			// Array of OOP values for the names

// make these private so they can never get called
	GenieCalloutList() : m_names(0), m_count(0), m_paramValues(nilOOP) {}
	GenieCalloutList(const GenieCalloutList& gcl) : m_names(0), m_count(0), m_paramValues(nilOOP) {}
	void operator=(const GenieCalloutList& gcl) {}

    public:
    	GenieCalloutList(OOP parameters);				// Set us up "geniecall" parameters
	int associate(const char* name, GenieVariableBase* gvp) const; 	// Link Genievariable to Smalltalk OOP
	static int validParameters(OOP parameters);			// Validate "geniecall" parameters
	~GenieCalloutList();
};

#endif /* GENIE_CALLOUT_LIST */
