/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef CELL_ARRAY_H
#define CELL_ARRAY_H

#include "two_d_plot.h"

class TwoDimensionalCoordinateTransformFunction;

class CellArray : public TwoDimensionalPlot
{
    protected:
	pg_int m_ntab;
	pg_int m_type;			// 0=linear, 1=log, 2=sqrt
	pg_int m_mode;			// 0=Same colour for all of cell, 1=Interpolate
	pg_float m_fg, m_bg;
	pg_int* m_table;		// colour table indices
   	void displayHorizontalWedge();
   	void displayVerticalWedge();

    public:
        CellArray(g_real* values, int nx_values, int ny_values, g_real fg, g_real bg, int itype,
			int mode, g_integer* table, int ntab, TwoDimensionalCoordinateTransformFunction* ctf);
    	~CellArray();
   	void display();
   	void displayPlot();
   	void displayWedge(int mode);
};

#endif /* CELL_ARRAY_H */
