/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef CONTOUR_PLOT_H
#define CONTOUR_PLOT_H

#include "two_d_plot.h"

class ContourPlot : public TwoDimensionalPlot
{
    protected:
	pg_float* m_contours;		
	pg_int m_ncontours;
	pg_int m_line_style;
	static int LINE_STYLE;

    public:
	ContourPlot(g_real* values, int nx, int ny, g_real* contours, int ncontours, 
				TwoDimensionalCoordinateTransformFunction* ctf, int ls, int lc, float lt);
	~ContourPlot();
	void display();
	void displayPlot();

	friend class ContourLabels;
};

#endif /* CONTOUR_PLOT_H */
