/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
//+++
//
// CLASS: Curve_Xft_Ygt
//
//
//---
// ----
// define String data type
//
#include <gnustring.h>
 
#include "Drawable_objects.h"
#include "Curve_xft_ygt.h" 
#include "Pginclude.h"

static const char* rcsid = "@(#)$Id: curve_xft_ygt.cxx,v 1.6 1997/03/26 16:26:15 cmm Exp $";
USE_RCSID(rcsid);

// *** constructor
Curve_Xft_Ygt::Curve_Xft_Ygt(float* ft,
			     float* gt,
			     int points,
			     float min,
			     float max,
			     int colour,
			     int thickness) {

	    // *** set visibility
	    invisible = 0;

	    // *** get function names
	    func_ft = ft;
	    func_gt = gt;

	    // *** get number of points
	    if (points >= 1)
			number_of_points = points;
	    else
			number_of_points = 1;

	    // *** set min/max values
	    Tmin = min;
	    Tmax = max;

	    // *** set the colour
	    if (colour == -1)
		    line_colour = LINE_COLOUR;
	    else
		    line_colour = colour;

	    // *** set line thickness
	    if (thickness == 0)
		    line_thickness = LINE_THICKNESS;
	    else
		    line_thickness = thickness;

}


// *** destructor
Curve_Xft_Ygt::~Curve_Xft_Ygt() {

}

// *** display the plot
void Curve_Xft_Ygt::display() {

	int one = 1;

	// *** set colour
	pgsci(line_colour);

	// *** set line thickness
	pgslw(line_thickness);

	// *** plot the function
	pgfunt(func_ft, func_gt, number_of_points, Tmin, Tmax, one);

}
