/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef DLFCN_WIN32_H
#define DLFCN_WIN32_H

#ifdef __cplusplus
extern "C" {
#endif

void* dlopen(const char* path, int mode);
void* dlsym(void* handle, const char* name);
int dlclose(void* handle);
const char* dlerror(void);

// Ignored, just leave for compatibility
#define RTLD_LAZY	1
#define RTLD_NOW	2

#ifdef __cplusplus
}
#endif

int GetExportList(const char* image_name, ModuleFunctionList& exports);

#endif /* DLFCN_WIN32_H */
