/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "dpolygon_array.h"
#include "pg_coord_trans_func.h"

static const char* rcsid = "@(#)$Id: dpolygon_array.cxx,v 1.2 1998/06/22 13:41:30 faa Exp $";
USE_RCSID(rcsid);

DPolygonArray::DPolygonArray(g_real* values, int nv, g_real* x, g_real* y, int npoly, 
			g_real fg, g_real bg, int itype,
			g_integer* table, int ntab, TwoDimensionalCoordinateTransformFunction* ctf) :
CellArray(values, 1, nv, fg, bg, itype, 0, table, ntab, ctf)
{
    ginf << "Drawing " << nv << " polygons each with " << npoly << " sides" << endl;
    int dims_array[2] = { npoly, nv }; 
    m_x.setup(x, dims_array, 2);
    m_y.setup(y, dims_array, 2);
}

DPolygonArray::~DPolygonArray()
{
}

void DPolygonArray::display()
{
    displayPlot();
}

void DPolygonArray::displayPlot()
{
// This is only used for the cell wedge
    PGCoordinateTransformFunction* pg_func = (PGCoordinateTransformFunction*)this->function();
    pg_func->setPointers();
    
    pgdpolyarray(m_values.values(), m_values.npoints(),
		   m_fg, m_bg, m_x.dims(0), m_x.values(), m_x.dims(0), m_y.values(), m_y.dims(0), m_table, m_ntab, m_type);
}

