/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef DPOLYGON_ARRAY_H
#define DPOLYGON_ARRAY_H

#include "cell_array.h"

class TwoDimensionalCoordinateTransformFunction;

class DPolygonArray : public CellArray
{
    protected:
	DrawableValues m_x;
	DrawableValues m_y;

    public:
        DPolygonArray(g_real* values, int nv, g_real* x, g_real* y, int npoly, 
			g_real fg, g_real bg, int itype,
			g_integer* table, int ntab, TwoDimensionalCoordinateTransformFunction* ctf);
    	~DPolygonArray();
   	void display();
   	void displayPlot();
};

#endif /* DPOLYGON_ARRAY_H */
