/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_CURVE.C
//
// Description: C++ code to allow creation of a Genie object-graphics curve.
//
//
// *** includes for the picture list
#include "Pictlist.h"

// *** local includes
#include "Curve_xft_ygt.h"

static const char* rcsid = "@(#)$Id: draw_curve.cxx,v 1.4 1997/05/06 09:56:52 cmm Exp $";
USE_RCSID(rcsid);

    void draw_curve(float *xfunct,
		    float *yfunct,
		    int npts,
		    float minT,
		    float maxT,
		    int colour,
		    int linewidth) {


	Drawable_objects *PTR;
	int width;

	// convert line width to integer
	width = (int)linewidth;

	// *** NEW an object
	PTR = new Curve_Xft_Ygt(xfunct,yfunct,npts,minT,maxT,colour,width);
	
	// *** display
	PTR->display();

	// ** update the display
	flush_buffer();

	// *** add them to the display list
	PicturePTR[Current_Picture]->disp_add(PTR);

    }
