/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_HISTOGRAM_MULTIPLOT.C
//
// Description: C++ code to allow creation of a Genie object-graphics multiplot.
//
//
// *** includes for the picture list
#include "g_types.h"
#include "Genie_functions.h"
#include "Pictlist.h"

// *** local includes
#include "Plot.h"
#include "Multiplot.h"
extern Multiplot *mult;
#ifndef NOmult
Multiplot *mult;
#endif

static const char* rcsid = "@(#)$Id: draw_histogram_multiplot.cxx,v 1.7 1997/04/02 22:24:41 faa Exp $";
USE_RCSID(rcsid);

    void create_multiplot(int nhist,
			double *xarray,
			int lengths,
			int chmin,
			int chmax,
			float ygap,
			int colour,
			int bin,
			int type,
			float linewidth) {

	int width;
	// *** convert line width to int value
	width = (int)linewidth;

	// *** NEW an object
	mult = new Multiplot(lengths,xarray,nhist,chmin,chmax,ygap,bin,
		colour,width,type);
    }



void add_spectra(const int *yarray, int length) 
{

    if (mult == 0)
	return;
    mult->add_spectra(yarray, length);
}

void add_spectra(const double *yarray, int length) {

	if (mult == 0) return;

	mult->add_spectra(yarray, length);
	}

void make_multiplot(g_objectid objid) {
	if (mult == 0) return;
	objid[ObjectPosition] = PicturePTR[Current_Picture]->disp_add((Drawable_objects *)mult);
 	 
      objid[ObjectPicture] = Current_Picture;

    }

void draw_multiplot() {

	g_integer objid[GENIE_OBJECTID_SIZE];
 	make_multiplot(objid);	
	display_object(objid);

    }
