/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
// -----------------------------------------------------------------------------
// DRAW_TEXT.C
//
// Description: C++ code to allow creation of a Genie object-graphics text.
//
//
#include "Genie_functions.h"

// *** includes for the picture list
#include "Pictlist.h"

// *** local includes
#include "Text.h"

static const char* rcsid = "@(#)$Id: draw_text.cxx,v 1.8 1997/09/16 10:05:20 faa Exp $";
USE_RCSID(rcsid);

    void new_text(float xpos,
		    float ypos,
		    const char* words,
		    float size,
		    float angle,
		    int colour,
		    int quality,
		    float linewidth,
		    float justify,
                    g_objectid objid) {


	Drawable_objects *PTR;
	int width;
	String WORDS = words;

	width = (int)linewidth;

	// *** NEW a text object
	PTR = new Text(xpos,ypos,WORDS,size,colour,angle,quality,width,justify);
	
	// *** add them to the display list
	objid[ObjectPosition] = PicturePTR[Current_Picture]->disp_add(PTR);
        objid[ObjectPicture] = Current_Picture;

    }

    void draw_text(float xpos,
		    float ypos,
		    const char* words,
		    float size,
		    float angle,
		    int colour,
		    int quality,
		    float linewidth) {

    g_integer objid[GENIE_OBJECTID_SIZE];
    new_text(xpos, ypos, words, size,angle, colour, quality, linewidth, 0.0, objid);
    display_object(objid);
}

