/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
//+++
//
// CLASS: Drawable_objects
//
//
//---
// ----
// define String data type
//
#include <gnustring.h>

#include "Drawable_objects.h"
#include "Errors.h"

#include "genievars.h"


static const char* rcsid = "@(#)$Id: drawable_objects.cxx,v 1.8 1997/03/26 16:26:17 cmm Exp $";
USE_RCSID(rcsid);

void  Drawable_objects::display ( ) {
    Errors syserr;
    syserr.add_error("Drawable objects ",
		    "display routine called",
		    "do not call Drawable_objects::display");
}

void  Drawable_objects::cursor(float* b,float* c,String& e ) {
    Errors syserr;
    syserr.add_error("Drawable objects ",
		    "cursor routine called",
		    "do not call Drawable_objects::cursor");
}

Drawable_objects::~Drawable_objects() 
{
}
 

ostream& Drawable_objects::identity(ostream& os)
{
    return os << "Drawable Object";
}

int Drawable_objects::query(GenieWorkspace& info)
{
    info("TYPE", 0);
    info("DESCRIPTION", "Drawable Object");
    return 0;
}
