/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 * Place holders for Open GENIE error handling routines
 *
 * Freddie Akeroyd, ISIS, 7/5/98
 */
#include "geniedefs.h"
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

static const char* rcsid = "@(#)$Id: error_add_dummy.c,v 1.1 1998/05/08 19:01:50 faa Exp $";
USE_RCSID(rcsid);

void error_add(const char *obj, const char *fail, const char *soln)
{
	if (obj == 0 || *obj == '\0')
	    return;

	if (strcasecmp(obj, "INFORMATION") != 0)
	{
	    printf("ERROR returned from: %s\n%s\n", obj, fail);
	}
	else
	{
	    printf("%s\n", fail);
	}
        if (soln != 0 && *soln != '\0')
	    printf("SOLUTION: %s\n", soln);
}

void g_printef(const char *fmt, ...)
{
    va_list args;
    va_start(args, fmt);
    vprintf(fmt, args);
    va_end(args);
}

void gprintdf(const char *fmt, ...)
{
    va_list args;
    va_start(args, fmt);
    vprintf(fmt, args);
    va_end(args);
}
