/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G3IO_TYPES_H
#define G3IO_TYPES_H

typedef long g3io_int_t;
typedef double g3io_real_t;
 
#if SIZEOF_LONG == 8	/* Alpha AXP */
typedef long g3io_int64_t;
typedef int g3io_int32_t;
#elif SIZEOF_LONG == 4	/* everybody else */
typedef int g3io_int32_t;
typedef struct
{
    g3io_int32_t low;
    g3io_int32_t high;
} g3io_int64_t; 
#else
#error Funny integer sizes
#endif /* SIZEOF_LONG */

#if SIZEOF_DOUBLE == 8
typedef double g3io_real64_t;
typedef float g3io_real32_t;
#else
#error Funny real sizes
#endif /* SIZEOF_DOUBLE */

#endif /* G3IO_TYPES_H */
