/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

enum NewGraphicsCode
{
    gxNewGraphicsTest = 0,
    gxPolygonCreate = 1,
    gxPolylineCreate = 2,
    gxTextCreate = 3,
    gxAxesCreate = 4,
    gxGraticuleCreate = 5,
    gxLabelsCreate = 6,
    gxTitleCreate = 7,
    gxPlotCreate = 8,
    gxHistogramCreate = 9,
    gxMarkersCreate = 10,
    gxVErrorsCreate = 11,
    gxHErrorsCreate = 12,
    gxContourCreate = 13,
    gxContourCreateArray = 14,
    gxContourCreateFunction = 15,
    gxContourCreateLabel = 16,
    gxCellArrayCreate = 17,
    gxCellWedgeCreate = 18,
    gxColourTableAllocate = 19,
    gxColourTableDeallocate = 20,
    gxNewUnScaledWindow = 21,
    gxNewScaledWindow = 22,
    gxCreateMultiplotWindow = 23,
    gxCreateWindowTwoD = 24,
    gxCreateMultiplot = 25,
    gxMultiplotMake = 26,
    gxAddSpectra = 27,
    gxDeviceOpen = 28,
    gxDeviceClose = 29,
    gxDeviceClear = 30,
    gxPictureCreate = 31,
    gxPictureDelete = 32,
    gxPictureRedraw = 33,
    gxPictureUndraw = 34,
    gxPictureUndrawAll = 35,
    gxPictureWindowDelete = 36,
    gxPictureUndoUndraw = 37,
    gxGetCursor = 38,
    gxDisplay = 39,
    gxCellFunctionCreate = 40,	
    gxNewPicture = 41,
    gxAddSpectraArray = 42,
    gxDeviceSelect = 43,
    gxGetObjectFromTag = 44,
    gxErrorsCreate = 45,
    gxCellCreate = 46,
    gxPictureSelect = 47,
    gxPlaneCreate = 48,
    gxThreeDTextCreate = 49,
    gxEllipsoidCreate = 50,
    gxThreeDLineCreate = 51,
    gxRodCreate = 52,
    gxConeCreate = 53,
    gxBallCreate = 54,
    gxIsoSurfaceCreate = 55,
    gxLatticePlaneCreate = 56,
    gxSurfaceCreate = 57,
    gxThreeDWindowCreate = 58,
    gxThreeDWindowFlushBitmap = 59,
    gxLatticeSliceCreate =60
};

static const char* NewGraphicsNames[] =
{
    "gxNewGraphicsTest",
    "gxPolygonCreate",
    "gxPolylineCreate",
    "gxTextCreate",
    "gxAxesCreate",
    "gxGraticuleCreate",
    "gxLabelsCreate",
    "gxTitleCreate",
    "gxPlotCreate",
    "gxHistogramCreate",
    "gxMarkersCreate",
    "gxVErrorsCreate",
    "gxHErrorsCreate",
    "gxContourCreate",
    "gxContourCreateArray",
    "gxContourCreateFunction",
    "gxContourCreateLabel",
    "gxCellArrayCreate",
    "gxCellWedgeCreate",
    "gxColourTableAllocate",
    "gxColourTableDeallocate",
    "gxNewUnScaledWindow",
    "gxNewScaledWindow",
    "gxCreateMultiplotWindow",
    "gxCreateWindowTwoD",
    "gxCreateMultiplot",
    "gxMultiplotMake",
    "gxAddSpectra",
    "gxDeviceOpen",
    "gxDeviceClose",
    "gxDeviceClear",
    "gxPictureCreate",
    "gxPictureDelete",
    "gxPictureRedraw",
    "gxPictureUndraw",
    "gxPictureUndrawAll",
    "gxPictureWindowDelete",
    "gxPictureUndoUndraw",
    "gxGetCursor",
    "gxDisplay",
    "gxCellFunctionCreate",
    "gxNewPicture",
    "gxAddSpectraArray",
    "gxDeviceSelect",
    "gxGetObjectFromTag",
    "gxErrorsCreate",
    "gxCellCreate",
    "gxPictureSelect",
    "gxPlaneCreate",
    "gxThreeDTextCreate",
    "gxEllipsoidCreate",
    "gxThreeDLineCreate",
    "gxRodCreate",
    "gxConeCreate",
    "gxBallCreate",
    "gxIsoSurfaceCreate",
    "gxLatticePlaneCreate",
    "gxSurfaceCreate",
    "gxThreeDWindowCreate",
    "gxThreeDWindowFlushBitmap",
    "gxLatticeSliceCreate"
};

OOP g_newgraphics(NewGraphicsCode code, OOP arguments);

