/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G_OBJGRAPHICS__
#define G_OBJGRAPHICS__

/* Header file for graphics parts of GENIE to be called by smalltalk
 *
 *   These callouts are likely to be essential to the working of GENIE as
 *   a whole and should not be altered without a good understanding of what
 *   is going on!
 */

/*define internal function codes for this facility*/
typedef enum {
    Gtest = 0,
    Init_defaults	= 1,
    Error_status	= 2,
    Clear_errors	= 3,
    Error_object	= 4,
    Error_failure	= 5,
    Error_solution	= 6,
    Error_message	= 7,
    Open_device		= 8,
    Close_device	= 9,
    Clear_device	= 10,
    Create_picture	= 11,
    Delete_pictures	= 12,
    Redraw_picture	= 13,
    Get_picture_cursor	= 14,
    Undraw		= 15,
    Undraw_all		= 16,
    Undo_undraw		= 17,
    Window_delete	= 18,
    Create_window_unscaled  = 19,
    Create_window_scaled    = 20,
    Create_window_multiplot = 21,
    Get_window_cursor	= 22,
    Draw_axes		= 23,
    Draw_text		= 24,
    Draw_histogram	= 25,
    Draw_multiplot	= 26,
    Draw_plot		= 27,
    Draw_markers	= 28,
    Draw_graticule	= 29,
    Draw_labels		= 30,
    Draw_title		= 31,
    Draw_box		= 32,
    Draw_line		= 33,
    Draw_curve		= 34,
    Draw_errors		= 35,
    Getpictnum		= 36,
    Checkdev		= 37,
    Pgplot		= 38,
    Create_multiplot	= 39,
    Add_one_spectrum	= 40,
    Add_error		= 41,
    Create_2d_plot	= 42,
    Add_2d_spectra	= 43,
    Draw_2d_plot	= 44,
    Set_display_update	= 45,
    Flush_buffer	= 46,
    Add_spectra		= 47,
    TotalInRange	= 48,
    Draw_polygon	= 49,
    Define_rgb_colour	= 50,
    Define_named_colour	= 51,
    Define_hls_colour	= 52,
    Contour_plot	= 53,
    Contour_label	= 54,
    HLS_to_RGB		= 55,
    Allocate_colourtable = 56,
    Deallocate_colourtable = 57,
    Cellarray_plot		= 58,
    Create_window_2d		= 59,
    Cellarray_wedge		= 60,
    Query_object		= 61,
    Allocate_predefined_colourtable = 62
} graphics_function_code;


static const char* graphics_function_names[] =
{
    "Gtest",
    "Init_defaults",
    "Error_status",
    "Clear_errors",
    "Error_object",
    "Error_failure",
    "Error_solution",
    "Error_message",
    "Open_device",
    "Close_device",
    "Clear_device",
    "Create_picture",
    "Delete_pictures",
    "Redraw_picture",
    "Get_picture_cursor",
    "Undraw",	
    "Undraw_all",
    "Undo_undraw",
    "Window_delete",
    "Create_window_unscaled",
    "Create_window_scaled",  
    "Create_window_multiplot",
    "Get_window_cursor",
    "Draw_axes",
    "Draw_text",
    "Draw_histogram",
    "Draw_multiplot",
    "Draw_plot",
    "Draw_markers",
    "Draw_graticule",
    "Draw_labels",
    "Draw_title",	
    "Draw_box",
    "Draw_line",
    "Draw_curve",
    "Draw_errors",
    "Getpictnum",	
    "Checkdev",
    "Pgplot",	
    "Create_multiplot",
    "Add_one_spectrum",
    "Add_error",
    "Create_2d_plot",
    "Add_2d_spectra",
    "Draw_2d_plot",
    "Set_display_update",
    "Flush_buffer",
    "Add_spectra",
    "TotalInRange",
    "Draw_polygon",
    "Define_rgb_colour",
    "Define_named_colour",
    "Define_hls_colour",
    "Contour_plot",
    "Contour_label",
    "HLS_to_RGB",
    "Allocate_colourtable",
    "Deallocate_colourtable",
    "Cellarray_plot",
    "Create_window_2d",
    "Cellarray_wedge",
    "Query_object",
    "Allocate_predefined_colourtable"
};

/* Prototype */
OOP g_objgraphics( graphics_function_code function, OOP parameters );

#endif /* G_OBJGRAPHICS__ */
