/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G_SYSTEM__
#define G_SYSTEM__

/* Header file for builtin parts of GENIE to be called by smalltalk
 *
 *   These callouts are likely to be essential to the working of GENIE as
 *   a whole and should not be altered without a good understanding of what
 *   is going on!
 */

/* define internal function codes for this facility */
typedef enum {
    Test = 0,
    SystemCommand = 1,
    GetEnv = 2,
    GCTorture = 3,
    GetGenieVersion = 4,
    GenieLog = 5,
    MakeTempFile = 6,
    RaiseSignal = 7,
    GetCPUTimes = 8
} system_function_code;

/* Prototype */
OOP g_system( system_function_code function, OOP oopParameters );

extern bool gcTortureInCallout; 
extern int gcTortureFacility;

#endif /* G_SYSTEM__ */
