/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G_TKTCL
#define G_TKTCL

/* Forward declarations */
struct STRING;

#include "fortran_types.h"

#include <tk.h>

#ifdef __cplusplus
#include "Pginclude.h"		/* for STRING */
#include "module.h"
#endif /* __cplusplus */

#if TK_MAJOR_VERSION != 4 || TK_MINOR_VERSION != 1 || TCL_MAJOR_VERSION != 7 || TCL_MINOR_VERSION != 5
/*#error TCL Version Mismatch: Tk is not 4.1 or Tcl is not 7.5*/
#endif

/* Structures for tk PGPLOT driver */
typedef struct
{
    Tk_Uid cmd;
    Tcl_CmdInfo cmdinfo;
    Tk_Window tkwin;
    Tcl_Interp* interp;
    int opened; 	/* 1 if PGOPEN done on this window */
} PGTkItem;

#if defined(HAVE_LIBF2C)
#define g3_module_tk_inquire_begin g3_module_tk_inquire_begin__
#define g3_module_tk_inquire_int g3_module_tk_inquire_int__
#define g3_module_tk_inquire_real g3_module_tk_inquire_real__
#define g3_module_tk_inquire_double g3_module_tk_inquire_double__
#define g3_module_tk_inquire_string g3_module_tk_inquire_string__
#define g3_module_tk_inquire_end g3_module_tk_inquire_end__
#elif defined(__unix)
#define g3_module_tk_inquire_begin g3_module_tk_inquire_begin_
#define g3_module_tk_inquire_int g3_module_tk_inquire_int_
#define g3_module_tk_inquire_real g3_module_tk_inquire_real_
#define g3_module_tk_inquire_double g3_module_tk_inquire_double_
#define g3_module_tk_inquire_string g3_module_tk_inquire_string_
#define g3_module_tk_inquire_end g3_module_tk_inquire_end_
#elif defined(_WIN32)
#define g3_module_tk_inquire_begin G3_MODULE_TK_INQUIRE_BEGIN
#define g3_module_tk_inquire_int G3_MODULE_TK_INQUIRE_INT
#define g3_module_tk_inquire_real G3_MODULE_TK_INQUIRE_REAL
#define g3_module_tk_inquire_double G3_MODULE_TK_INQUIRE_DOUBLE
#define g3_module_tk_inquire_string G3_MODULE_TK_INQUIRE_STRING
#define g3_module_tk_inquire_end G3_MODULE_TK_INQUIRE_END
#endif


#ifdef __cplusplus
extern "C" {
GENIEIMPORT int Genie_Tcl_AppInit(Tcl_Interp* interp); /* here so tkdriv.c doesn't see us */
GENIEIMPORT void GenieTclPanic(char* format, ... );
void GENIEMECHANISM g3_module_tk_inquire_begin(const STRING& title, int* dialog);
void GENIEMECHANISM g3_module_tk_inquire_int(int* dialog, const STRING& label, fort_int& val);
void GENIEMECHANISM g3_module_tk_inquire_real(int* dialog, const STRING& label, fort_real& val);
void GENIEMECHANISM g3_module_tk_inquire_double(int* dialog, const STRING& label, fort_double& val);
void GENIEMECHANISM g3_module_tk_inquire_string(int* dialog, const STRING& label, char* val, fort_int len);
void GENIEMECHANISM g3_module_tk_inquire_end(int* dialog);
#endif /* __cplusplus */

#ifdef HAVE_LIBTIX
int Tix_Init(Tcl_Interp *interp);
#endif /* HAVE_LIBTIX */

extern Tcl_Interp* PGTkDefaultInterp;

#define MAX_PGTKITEMS	6		/* Max num of open TK devices */
extern PGTkItem* PGTkItemList[];	/* length MAX_PGTKITEMS */
/* PGTkItemList[i] != 0 --> i is a valid device number */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* G_TKTCL */
