/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef G_TRANSFORM__
#define G_TRANSFORM__

/* define internal function codes for this facility */
typedef enum {
    TransformTest = 0, // not used
    TransformTshift = 1, // not used
    TransformRunid = 2, // not used
    TransformMultiplotConcat = 6, // not used
    TransformBinGroup = 8,
    TransformRebinAs = 9,
    TransformBinBound = 10,
    TransformBinRange = 11,
    TransformIntegrateSpectra = 12,
    TransformIntegrateFile = 13,
    TransformArrayBracket = 14,
    TransformUnits = 20,
    CreateNewUnit = 31,
    GetUnitProperties = 32,
    MultiplyTwoUnits = 33,
    ConvertUnit = 34,
    GetUnitDims = 35,
    GetKnownUnits = 36
} transform_function_code;

/* Prototypes */

OOP g_transform( transform_function_code function, OOP parameters );

#endif /* G_TRANSFORM__ */
