/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/* Automatically generated list of Genie commands for GNU Readline */
#ifndef GENIE_COMMANDS_H
#define GENIE_COMMANDS_H

enum { COMMAND=0, COMMENT=1 }; 

static const char* genie_commands[][2] = {
    { "abs", "Calculate the absolute values." },
    { "alias", "Allows the definition of aliases for command names and qualifiers" },
    { "alter", "Sets various defaults for the subsequent Display(), Plot() and" },
    { "arccos", "Generic trig functions." },
    { "arcsin", "Generic trig functions." },
    { "arctan", "Generic trig functions." },
    { "as_integer", "Truncates an Open GENIE real number to an integer." },
    { "as_string", "Converts any genie variable into a string." },
    { "as_variable", "Converts a string into an internal Open GENIE variable type." },
    { "asciifile", "Read or write any format of ASCII data." },
    { "assign", "Select a run for input by giving the ISIS run number" },
    { "axes", "Displays an axes on the graphics device" },
    { "bracket", "Finds the index position of a given value in an array." },
    { "buffer", "Sorry, no help is available for this command" },
    { "called_as_function", "Test if a procedure was called as a function, i.e. x = command(y)" },
    { "callout", "Sorry, no help is available for this command" },
    { "cell", "Colour cell plot for gridded data." },
    { "cell_array", "Colour cell plot for gridded data with explicit gridding." },
    { "cell_function", "Coloured cell plot for ungridded data." },
    { "cell_wedge", "Displays a cell_wedge (colour key) on the graphics device." },
    { "centre_bins", "Centre the bins of a real array (i.e. convert from histogram to point" },
    { "cfn", "Construct the full filename from run number and defaults" },
    { "chdir", "Sorry, no help is available for this command" },
    { "colour", "Define a new graphics colour based on one of several models" },
    { "colourtable", "Manipulate graphics colour tables (used with Cell() commands)." },
    { "comment", "Sorry, no help is available for this command" },
    { "contour", "Makes a contour plot on the graphics device." },
    { "contour_array", "Plots a contour_array on the graphics device" },
    { "contour_function", "Plots contours for ungridded data." },
    { "contour_label", "Labels the contours in the contour plot" },
    { "copying", "Prints the GNU licensing conditions for Open GENIE" },
    { "cos", "Generic trig function." },
    { "cursor", "Displays a cursor on the graphics screen to allow interactive" },
    { "cut", "Takes a one-D cut out of a two-D array" },
    { "debug", "Enables simple procedure call debugging" },
    { "defined", "Tests whether a variable has a defined value (not undefined)." },
    { "delete", "Deletes unwanted graphics objects from memory" },
    { "dev", "Locates and returns device object given its index." },
    { "device", "Selects and controls graphics devices" },
    { "dimensionality", "Return an integer giving the dimensionality of the array" },
    { "dimensions", "Create and size an Open GENIE array" },
    { "dir", "List the files in the current directory or the directory specified" },
    { "display", "Display a graphical plot of spectra in a workspace." },
    { "draw", "Obsolete command" },
    { "errors", "Displays error-bars on a plot" },
    { "exit", "One line description - the one given by CTRL-H at the command line" },
    { "exp", "Generic transcendental functions." },
    { "fields", "Create a workspace" },
    { "filetype", "Finds out the type of a data file (if recognized by Open GENIE)." },
    { "fill", "Fill an array with values" },
    { "fix", "Fix any undefined values in an array" },
    { "focus", "Focus a range of spectra with given parameters" },
    { "free", "Deletes a variable or workspace field and frees the storage." },
    { "g_error_handler", "Sorry, no help is available for this command" },
    { "gctorture", "Sorry, no help is available for this command" },
    { "get", "Read binary spectrum data into GENIE from any valid data source (e.g." },
    { "get_cursor", "Sorry, no help is available for this command" },
    { "getcursor", "Cursor input routine for a window or a picture." },
    { "getcwd", "Sorry, no help is available for this command" },
    { "graph", "Displays a graph (or line plot) on a graphics device." },
    { "graticule", "Displays a graticule axis on the graphics device" },
    { "gripe", "One line description - the one given by CTRL-H at the command line" },
    { "groupbins", "Groups histogram bins by averaging the bin contents." },
    { "hardcopy", "Makes a copy of picture on a hardcopy device." },
    { "histogram", "Displays a histogram on a graphics device." },
    { "inquire", "Prompts the user for terminal input and reads back an input variable." },
    { "inspect", "One line description - the one given by CTRL-H at the command line" },
    { "integrate", "Integrate one or more spectra" },
    { "interactive", "Tests whether code is running as part of a procedure or not." },
    { "is_a", "Tests the type of an Open GENIE variable." },
    { "jump", "Similar to the System() command." },
    { "keep", "The keep command is no longer supported. Use Hardcopy() for saving" },
    { "labels", "Displays x/y labels on the graphics device" },
    { "length", "Generic command for returning the length of something" },
    { "limits", "Sets axis limits for the Display() and Plot() commands." },
    { "line", "Displays a line on the graphics device" },
    { "list", "Lists the items available within any datafile with a format Open GENIE" },
    { "ln", "Generic transcendental functions." },
    { "load", "Sorry, no help is available for this command" },
    { "locate", "Finds the position (or positions) of a given sub-string within a" },
    { "log", "Generic transcendental functions." },
    { "markers", "Displays markers on a plot" },
    { "max", "Find the maximum value in an array" },
    { "min", "Find the minimum value in an array" },
    { "module", "Manage the dynamic loading and execution of user written C or FORTRAN" },
    { "multi_plot", "Controls multiplot creation and plotting" },
    { "multiplot", "Plots multiple spectra on one set of axes using a hidden line removal" },
    { "nblocks", "Returns the number of readable blocks in an Open GENIE recognized" },
    { "new_zoom", "Zooms in on a graphics device" },
    { "now", "Returns the current date and time as a string." },
    { "obj", "Locates and returns a graphics primitive object given its location." },
    { "os", "Returns a string giving the operating system Open GENIE is running on" },
    { "peak", "Performs interactive peak fitting" },
    { "peakfit", "Fits various peaks to data supplied in arrays." },
    { "peakgen", "Generates peak data from an X-array and peak parameters." },
    { "pic", "Locates and returns a picture object given its index." },
    { "pic_add", "Copy graphical objects from picture to picture." },
    { "picture", "Creates a picture" },
    { "plot", "Overplots an existing graph produced by Display()" },
    { "polygon", "Displays a polygon on the graphics device" },
    { "print", "Print to the users terminal (no newline)." },
    { "printd", "Print an debugging message to the users terminal (no newline)." },
    { "printdn", "Print a debugging message to the users terminal with a terminating" },
    { "printe", "Print an error message to the users terminal (no newline)." },
    { "printen", "Print an error message to the users terminal with a terminating" },
    { "printi", "Print an informational message to the users terminal (no newline)." },
    { "printin", "Print an informational message to the users terminal with a" },
    { "printn", "Print to the users terminal with a terminating newline." },
    { "put", "Outputs Open GENIE data to a known file type." },
    { "quit", "Sorry, no help is available for this command" },
    { "read", "One line description - the one given by CTRL-H at the command line" },
    { "read_terminal", "Read a string back from the input terminal into a variable" },
    { "rebin", "Rebin a workspace given the specified binning scheme." },
    { "redim", "Re-dimensions an array whilst keeping the size and contents identical" },
    { "redraw", "Redisplay current or previous pictures or objects." },
    { "s", "Get data, now identical to the Get() command. See Get/Help" },
    { "save", "One line description - the one given by CTRL-H at the command line" },
    { "scatmode", "Return GENIE-V2 Energy mode description" },
    { "search", "Sorry, no help is available for this command" },
    { "select", "Select a new current device, window or picture" },
    { "set", "Set user defined defaults." },
    { "setpar", "GENIE-V2 style T-O-F parameter setting for the Units() command." },
    { "show", "Set user defined defaults and system variables." },
    { "sin", "Generic trig function." },
    { "sqrt", "Calculate the square root of a value." },
    { "substring", "Extracts a smaller string out of a larger string using the given" },
    { "sum", "Sums all the elements in an array" },
    { "sumspec", "Sum spectra in a given range from the specified file. (See also" },
    { "system", "Executes a single command or command session from within Open GENIE." },
    { "tan", "Generic trig function." },
    { "text", "Displays some text on the graphics device" },
    { "title", "Displays a Title on the graphics device" },
    { "toggle", "Toggles between common settings, mainly graphics." },
    { "undraw", "Undraw a primitive graphics operation." },
    { "unfix", "Replace sentinel values with 'undefined'" },
    { "units", "Convert the units of a Time of Flight workspace as specified" },
    { "version", "Sorry, no help is available for this command" },
    { "warranty", "Sorry, no help is available for this command" },
    { "win", "Locates and returns a graphics window object given its location." },
    { "win_autoscaled", "Creates a scaled window automatically from supplied data." },
    { "win_multiplot", "Controls and creates multi_plot windows for plotting" },
    { "win_scaled", "Controls and creates pre-scaled windows for plotting data." },
    { "win_twod", "Controls and creates two dimensional windows for plotting" },
    { "win_unscaled", "Controls and creates unscaled windows for plotting." },
    { "window", "Obsolete command" },
    { "workspace_abs", "Called by the generic function Abs(x) when x is of type Workspace." },
    { "workspace_add", "Called by the generic function x + y when x and y are of type" },
    { "workspace_and", "Called by the generic function x AND y when x and y are of type" },
    { "workspace_append", "Called by the generic function x & y (append) when x and y are of type" },
    { "workspace_arccos", "Called by the generic function Acos(x) when x is of type Workspace." },
    { "workspace_arcsin", "Called by the generic function Asin(x) when x is of type Workspace." },
    { "workspace_arctan", "Called by the generic function Atan(x) when x is of type Workspace." },
    { "workspace_coerce", "Called to convert numbers and arrays automatically in to workspaces." },
    { "workspace_cos", "Called by the generic function Cos(x) when x is of type Workspace." },
    { "workspace_divide", "Called by the generic function x / y when x and y are of type" },
    { "workspace_equal", "Called by the generic function x = y when x and y are of type" },
    { "workspace_exp", "Called by the generic function Exp(x) when x is of type Workspace." },
    { "workspace_greater_than", "Called by the generic function x > y when x and y are of type" },
    { "workspace_greater_than_or_equal", "Called by the generic function x >= y when x and y are of type" },
    { "workspace_less_than", "Called by the generic function x < y when x and y are of type" },
    { "workspace_less_than_or_equal", "Called by the generic function x <= y when x and y are of type" },
    { "workspace_ln", "Called by the generic function ln(x) when x is of type Workspace." },
    { "workspace_log", "Called by the generic function log(x) when x is of type Workspace." },
    { "workspace_modulo", "Called by the generic function x | y when x and y are of type" },
    { "workspace_multiply", "Called by the generic function x * y when x and y are of type" },
    { "workspace_negated", "Called by the generic function -x when x is of type Workspace." },
    { "workspace_not", "Called by the generic function NOT x when x is of type Workspace." },
    { "workspace_not_equal", "Called by the generic function x != y when x and y are of type" },
    { "workspace_or", "Called by the generic function x OR y when x and y are of type" },
    { "workspace_raised_to", "Called by the generic function x ^ y when x and y are of type" },
    { "workspace_sin", "Called by the generic function Sin(x) when x is of type Workspace." },
    { "workspace_sqrt", "Called by the generic function Sqrt(x) when x is of type Workspace." },
    { "workspace_subtract", "Called by the generic function x - y when x and y are of type" },
    { "workspace_tan", "Called by the generic function Tan(x) when x is of type Workspace." },
    { "write", "Sorry, no help is available for this command" },
    { "zoom", "Interactively choose an area of a plot to magnify." },
    { 0, 0 } 
};

#endif /* GENIE_COMMANDS_H */
