/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include <math.h>
#include "genievars.h"

GenieSpectrum& GenieSpectrum::operator+=(const GenieSpectrum& gs)
{
    g_integer ntc = (GenieInteger)(*this)("NTC");
#if 0
    GenieReal gr;
    gr = (*this)("L1");
    (*this)("L1", gr + gs("L1"));
    (*this)("L2", (*this)("L2") + gs("L2"));
    (*this)("TTHE", (*this)("TTHE") + gs("TTHE"));
    (*this)("DELTA", (*this)("DELTA") + gs("DELTA"));
    (*this)("RUN_DURATION", (*this)("RUN_DURATION") + gs("RUN_DURATION"));
    OOP nsumOOP = getKey("NSUM");
    if (isNil(getKey("NSUM")))
    {
	(*this)("NSUM", 0);
    }
    (*this)("NSUM", (*this)("NSUM") + 1);
#endif
// X must be same
    GenieRealArray
		yarray((*this)("Y")),
		gs_yarray = gs("Y"),
		earray = (*this)("E"),
		gs_earray = gs("E");
    for(int i=0; i<ntc; i++)
    {
	yarray(i) += gs_yarray(i);
	earray(i) = sqrt(earray(i) * earray(i) + gs_earray(i) * gs_earray(i));
    }
    return *this;
}