/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"

#ifndef GENIEVARS
#define GENIEVARS

#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <gnustring.h>
#include <ctype.h>

#ifndef Strdup
char* Strdup(const char* old_string);
char* Strdup(const char* old_string, int length);
char* Strdup(const unsigned char* old_string);
char* Strdup(const unsigned char* old_string, int length);
#endif

#include "smalltalk.h"
#include "g_types.h"

extern OOP getClassOOP(OOP oop);

extern char* getClassString(OOP oop);
    
extern "C" OOP identityDictionaryAtPut(OOP identityDictionary, OOP key, OOP value);

int associateGenieVariables(OOP oopParameters, ... );

GenieVariableType getGenieVariableType(OOP oop);
GenieVariableType getGenieVariableTypeFromClass(OOP classy);
OOP getGenieVariableOOP(GenieVariableType type);

class GenieVariable;	// forward declaration --- needed for workspace

#include "genie_base.h"
#include "genie_int.h"
#include "genie_real.h"
#include "genie_float.h"
#include "genie_char.h"
#include "genie_string.h"
#include "genie_work.h"
#include "genie_spectrum.h"
#include "genie_interval.h"

#include "genie_real_array.h"
#include "genie_integer_array.h"
#include "genie_workspace_array.h"
#include "genie_string_array.h"

#include "genie_var.h"

#endif	/* GENIEVARS */
