C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
        SUBROUTINE GETSECT(ISTART,ILONG,IVALUE,IUNIT,IERR)
        IMPLICIT NONE
C  gets a section of the data file and places it in IVALUE
C   ISTART is the starting position in the file
C   ILONG is the length of the required section
C
C  if ( IERR .NE. 0) on return, error in reading from that record
C
        INTEGER*4 ILONG,IVALUE(ILONG),IWORK(128),IUNIT,IERR
        INTEGER*4 IBLOCK,ISTART,IFIRST,ILAST,I,J,ILEFT
C        COMMON/crpt_WORK/IWORK
C        SAVE /crpt_WORK/
C
C calculate which block to start from, and first and last elements to use
	IERR=0
        IBLOCK=(ISTART-1)/128 + 1
        IFIRST=ISTART - (IBLOCK-1)*128
        ILAST=IFIRST+ILONG-1
        IF (ILAST.GT.128) ILAST=128
C also keep a count of how many elements left to get
        ILEFT=ILONG
C
C
        J=1
C 5     TYPE *,' IBLOCK',IBLOCK
 5      READ(IUNIT, REC=IBLOCK, IOSTAT=IERR) IWORK
	IF (IERR .NE. 0) THEN
	    IF (IBLOCK .NE. 0) THEN
	        IERR = IBLOCK
	    ELSE
		IERR = -1
	    ENDIF
	    RETURN
	ENDIF
C
        DO 10 I=IFIRST,ILAST
	    IF (J. GT. ILONG) THEN
	        IERR = -1
	        RETURN
	    ENDIF
            IVALUE(J)=IWORK(I)
            J=J+1
 10     CONTINUE
C
        ILEFT=ILEFT-(ILAST-IFIRST+1)
        IF (ILEFT.LE.0) GOTO 999
        IBLOCK=IBLOCK+1
        IFIRST=1
        ILAST=ILEFT+IFIRST-1
        IF (ILAST.GT.128) ILAST=128
        GOTO 5
C
C
 999    RETURN
        END
C
C *** dummy routine to replace one in getsect.cc
C
	INTEGER FUNCTION FASTGET_INIT(A,IUNIT)
        IMPLICIT NONE
	INTEGER A,IUNIT
        CHARACTER*120 FILNAM
        INTEGER*4 VER1,IFORMAT(10),IVER(10),NDET,NMON,NEFF,
     +  NSEP,NTRG,NSP1,NTC1,ULEN,NPER,DATA_HEADER(32),ISTATUS,TRUELEN,I
        LOGICAL OPENFILE
        COMMON/crpt_SPECIALS/ FILNAM,VER1,IFORMAT,IVER,
     +          NDET,NMON,NEFF,NSEP,NTRG,NSP1,NTC1,ULEN,OPENFILE,NPER,
     +          DATA_HEADER
        SAVE /crpt_SPECIALS/
	INQUIRE(UNIT=IUNIT,OPENED=OPENFILE)
	IF (OPENFILE) THEN
	    CLOSE(IUNIT)
	    OPENFILE=.FALSE.
        ENDIF
        I=TRUELEN(FILNAM)
C *** For Linux (at least) RECL is measured in bytes rather than words
C *** and so you must set RECL=512
C *** OSF1/VMS use words so set RECL=128
        OPEN(UNIT=IUNIT,FILE=FILNAM(1:I),RECL=128,STATUS='OLD',
     +       ACCESS='DIRECT',IOSTAT=ISTATUS,
C READONLY, SHAREABLE on VMS - comment out if your OS doesn't support
     +		READONLY,SHARED)
        IF (ISTATUS .NE. 0) THEN
               WRITE(6,6010)ISTATUS
 6010          FORMAT(' File could not be opened. Status=',I12)
                FASTGET_INIT=1
                RETURN
        ENDIF
	FASTGET_INIT=0
	RETURN
	END
C
