/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

// ghistory.h: interface for the CHistory class.
//
//////////////////////////////////////////////////////////////////////
//
//    Module:         ghistory.cxx
//    Author:         Chris Moreton-Smith, ISIS
//
//  Encapsulates the use of the GNU command line history mechanism within a class


#if !defined(AFX_GHISTORY_H__7F1FE9ED_E3F2_11D1_A6BA_00609709EB73__INCLUDED_)
#define AFX_GHISTORY_H__7F1FE9ED_E3F2_11D1_A6BA_00609709EB73__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CHistory  
{
public:
    const char* GetPreviousCommand();
    const char* GetNextCommand();
	const char* GetLastCommand();
	const char* Search(const char* text);
	void AddCommand(const char* szCommand);
	String m_gstrHistoryFile;
	CHistory(const char* filename);
	virtual ~CHistory();

private:
	static unsigned s_dwSessionID;
    int m_search_pos;
};

#endif // !defined(AFX_GHISTORY_H__7F1FE9ED_E3F2_11D1_A6BA_00609709EB73__INCLUDED_)
