/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef GSIGNALS__
#define GSIGNALS__

#ifdef __cplusplus
extern "C" {
#endif

#define SIGTYPE int sig	    /* This definition is largely historical */

typedef void (*signal_handler)(SIGTYPE);

/* Routines exported by this module */
void	Set_signals(void);
void	Unset_signals(void);
void	Restore_signals(void);
char    *printsig(int sig);

extern volatile signal_handler oldCtrlCaction;

/*
 * Asynchronously called routines
 */

/* Provided by this module */
volatile void Handle_signal(int sig);

/* Provided by the client module */
volatile void	sigint_action(void);
volatile void	sigterm_action(void);
volatile void	sigfpe_action(void);
volatile void	sigother_action(int sig);	    /* Pass the signal to allow discrimination */

GENIEIMPORT volatile signal_handler genie_signal(int sig, volatile signal_handler func);
void initializeSmalltalkSignals();

/*
 * MODULE GLOBALS
 */
extern sigjmp_buf gsignals_context;	    /* Saved context for longjmps ( not used until set other than 0 ) */
extern volatile int jumpsigs;		    /* Saved context for longjmps ( not used until set other than 0 ) */

#ifdef __cplusplus
}
#endif

#endif /* GSIGNALS__ */
