/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef HDF_UTILS
#define HDF_UTILS

#include "hdf.h"
#include "mfhdf.h"

#define INVALID_REF	((uint16)65535)
#define INVALID_TAG	((uint16)65535)
#define INVALID_FID	((int32)-1)
#define INVALID_TYPE	((int32)-1)

#define DFTAG_UNDEFINED	((uint16)45264)			/* define a new TAG for a genie "undefined" */

extern void print_hdf_error_stack(ostream& os);

#define HDF_IS_ERROR(__status) 		(__status == FAIL)

#define HDF_ERROR_MESSAGE(__routine, __status)	\
	if HDF_IS_ERROR(__status) \
	{ \
	    gerr << "Error returned from \"" << __routine "\"" << endl; \
	    print_hdf_error_stack(*g_err); \
	}

#define HDF_ERROR(__routine, __status, __retval)	\
	if HDF_IS_ERROR(__status) \
	{ \
	    gerr << "Error returned from \"" << __routine "\"" << endl; \
	    print_hdf_error_stack(*g_err); \
	    return __retval; \
	}

#endif /* HDF_UTILS */
