/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
/*
 * A routine to be called from fortran
 *
 * need to compile this with gcc rather than g++, as g++ seems to
 * mangle the symbols and then the fortran can't find it
 *
 * converts a vector of n IEEE ULTRIX binary floats to VAX floats
 *
 *  errcode = 0 on success
 *            1 on failure
 */

static const char* rcsid = "@(#)$Id: ieee_to_vax.cxx,v 1.6 1997/10/16 16:20:49 cmm Exp $";
USE_RCSID(rcsid);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __unix
    extern int itof(float *);		/* PROTOTYPE */
#   define ieee_to_vax ieee_to_vax_
#endif
void ieee_to_vax (float *, int *, int *);	/* PROTOTYPE */

#ifdef __cplusplus
}
#endif

void ieee_to_vax (float *val, int *n, int *errcode)
{
	*errcode=0;
#ifdef __unix
	for(int i=0; i<*n; i++)
	{
		if ( itof(i+val) != 0 )
		{
			*errcode=1;
		}
	}
#endif
	return;
}
