/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

# define U(x) ((x)&0377)
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern unsigned char yytext[];
int yymorfg;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

#include "geniedefs.h"

static const char* rcsid = "@(#)$Id: lexcommands.c,v 1.41 1998/05/18 14:57:17 cmm Exp $";
USE_RCSID(rcsid);

#if defined (HAVE_UNISTD_H)
#  include <unistd.h>
#endif /* HAVE_UNISTD_H */

#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>

#define INSIDE_PARSER__	/* Used to localize variables to parser modules only */
#include "parsedefs.h"
#include "yacccommands.h"

#ifndef FALSE
#define FALSE (0)
#endif
#ifndef TRUE
#define TRUE (1)
#endif

#ifdef yywrap				/* if yywrap is defined as a macro eg "#define yywrap() 1" then clear it */
#undef yywrap
#endif

static char buffer[SHORTCHARBUFF];
#ifdef _WIN32
extern int yyback(int *p, int m);
#endif /* _WIN32 */

#ifdef ECHO				/* if ECHO is defined as a macro replace it with a hard error */
#undef ECHO
#endif
#define ECHO { sprintf(buffer,"%c <-- ECHOing without translation",yytext[0]); yyerror("buffer"); }

#ifdef YYLMAX				/* Need to up the size of Token buffer so redefine YYLMAX */
#undef YYLMAX
#endif
#define YYLMAX LEXTOKENBUFFERSIZ


/* Make up our own definitions for input and output to allow control over the getc */
#undef input
#undef unput
#define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):\
        getc_parser())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}




/* Macros for returning apprpriate token values */
/* NOTE: do not change the position at which oldyy0 is set, uplus, uminus & special rely on it ! */

#define RETTOKVAL(x) {\
	oldyy0 = yytext[0];\
	if ( x == ENDOFLINE ) strcpy((char *)yytext,"<eol>");\
	strcpy(yylval.terminal, (char *)yytext);\
	return(last=x); }

#define RETFVAL(x) {\
	oldyy0 = yytext[0];\
	sscanf((char *)yytext, "%lf", &yylval.areal);\
	return(last=x); }

#define RETIVAL(x) {\
	oldyy0 = yytext[0];\
	yylval.aninteger = atol((char *)yytext);\
	return(last=x); }

#define RETSTRVAL yylval.astring

#define RETDEBUGSTRING(x) {\
	oldyy0 = yytext[0];\
	if ( x == ENDOFLINE ) strcpy((char *)yytext,"<eol>");\
	strcpy(yylval.debugging_string, (char *)yytext);\
	return(last=x); }

#ifdef _DEB_
#undef RETTOKVAL
#undef RETFVAL
#undef RETIVAL
#undef RETSTRVAL
#define RETTOKVAL(x) RETDEBUGSTRING(x)
#define RETFVAL(x) RETDEBUGSTRING(x)
#define RETIVAL(x) RETDEBUGSTRING(x)
#define RETSTRVAL yylval.debugging_string
#endif


/* VARIABLES
 * =========
 */


/* ancillary local definitions */

static char *strp;			/* general string pointer */
static int oldyy0;			/* Information kept to allow left context sensitivity on a Unary minus */
static int last;			/* The last token value returned to the calling parser */
static unsigned char *last_lexeme;	/* Keep our own pointer to the last lexeme parsed (ie yytext) */


/* Any functions to be used by yylex */

int yywrap(void){
	strcpy((char *)last_lexeme, "<eof>");	/* not strictly necessary but does help debugging */
	return(1);			/* 1 indicates end of file OK, stop lexing */
}

/* called by yacc or lex on a syntax error */

void ggerror(const char err[])
{
    g_printef("%d: %s\nThe last token read was \"%s\" (%d decimal), Token value = %d\n",
	    lines_parsed+1, err, last_lexeme, (int)(last_lexeme[0]), last);
    errors_found++;
    return;
}

int yylook();

/* First define all the token strings and regular expressions to get them
   note that the "special" definition is weird check out RE syntax very
   carefully for this one !*/

# define STRN 2
# define NORM 4
# define CSTATE 6
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
last_lexeme = (unsigned char *) yytext;			/* keep a pointer to yytext for diagnostics (cannot be done earlier) */
if(0)goto yyfussy;	/* Just to kill warnings */
continuation_line = FALSE;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
	    RETTOKVAL(OR);
break;
case 2:
	    RETTOKVAL(AND);
break;
case 3:
	    RETTOKVAL(NOT);
break;
case 4:
	RETTOKVAL(FORWARD);
break;
case 5:
	RETTOKVAL(PROCEDURE);
break;
case 6:
RETTOKVAL(ENDPROCEDURE);
break;
case 7:
RETTOKVAL(PARAMETERS);
break;
case 8:
RETTOKVAL(QUALIFIERS);
break;
case 9:
	RETTOKVAL(RESULT);
break;
case 10:
	RETTOKVAL(GLOBAL);
break;
case 11:
	    RETTOKVAL(LOCAL);
break;
case 12:
	    RETTOKVAL(LOOP);
break;
case 13:
	    RETTOKVAL(FROM);
break;
case 14:
	    RETTOKVAL(TO);
break;
case 15:
	    RETTOKVAL(STEP);
break;
case 16:
	RETTOKVAL(ENDLOOP);
break;
case 17:
	RETTOKVAL(EXITIF);
break;
case 18:
	    RETTOKVAL(CASE);
break;
case 19:
	    RETTOKVAL(IS);
break;
case 20:
	RETTOKVAL(ENDCASE);
break;
case 21:
	RETTOKVAL(OTHERWISE);
break;
case 22:
	    RETTOKVAL(IF);
break;
case 23:
	RETTOKVAL(ELSEIF);
break;
case 24:
	    RETTOKVAL(ELSE);
break;
case 25:
	    RETTOKVAL(ENDIF);
break;
case 26:
           RETTOKVAL(RETURN);
break;
case 27:
             RETTOKVAL(ALIAS);
break;
case 28:
             RETTOKVAL(NOTEQUALS);
break;
case 29:
             RETTOKVAL(GEQUAL);
break;
case 30:
             RETTOKVAL(LEQUAL);
break;
case 31:
         {
			            BEGIN CSTATE;
			            strp = RETSTRVAL;
			        }
break;
case 32:
	{ if ( strchr("(><=!+-*/| \t&,[^", oldyy0) )
				        { RETTOKVAL(UPLUS); } else RETTOKVAL(oldyy0); }
break;
case 33:
	{ if ( strchr("(><=!+-*/| \t&,[^", oldyy0) )
				        { RETTOKVAL(UMINUS); } else RETTOKVAL(oldyy0); }
break;
case 34:
	RETFVAL(UREAL);
break;
case 35:
RETIVAL(UINTEGER);
break;
case 36:
RETTOKVAL(IDENTIFIER);
break;
case 37:
        {
        			    BEGIN STRN;			/* Sub-syntax for strings (similar to C strings) */
        			    strp = RETSTRVAL;		/* initialize string pointer to build up string value */
        			}
break;
case 38:
	RETTOKVAL(oldyy0);
break;
case 39:
	oldyy0 = yytext[0];
break;
case 40:
	    RETTOKVAL(ENDOFLINE);
break;
case 41:
		    {				            /* Pseudo end of line */
            			lines_parsed--;			/* fix the line count as the yacc parser will increment it */
            			RETTOKVAL(ENDOFLINE);
        			}
break;
case 42:
	RETTOKVAL(COMMENT);
break;
case 43:
		    RETTOKVAL(RUBBISH);
break;
case 44:
{ *strp++ = (unsigned char)strtol((char *)yytext+1, (char **)0, 10); }
break;
case 45:
{ *strp++ = (unsigned char)strtol((char *)yytext+1, (char **)0, 8); }
break;
case 46:
{ *strp++ = (unsigned char)strtol((char *)yytext+2, (char **)0, 16); }
break;
case 47:
{ *strp++ = *(strchr("\rr\bb\ff\nn\tt\vv", yytext[1]) - 1); }
break;
case 48:
{
                			yyerror("Unterminated string");
                			BEGIN NORM;
                			oldyy0 = yytext[0];
                			return(last=RUBBISH);		/* Return an error */
            			}
break;
case 49:
	    {
            			*strp = '\0';
            			BEGIN NORM;
            			oldyy0 = yytext[0];
            			return(last=STRING);			/* Return the bits */
        			}
break;
case 50:
	    { *strp++ = yytext[1]; }
break;
case 51:
		    { *strp++ = yytext[0]; *strp++ = yytext[0]; }
break;
case 52:
		    { *strp++ = yytext[0]; }
break;
case 53:
{ *strp++ = (unsigned char)strtol((char *)yytext+1, (char **)0, 10); }
break;
case 54:
{ *strp++ = (unsigned char)strtol((char *)yytext+1, (char **)0, 8); }
break;
case 55:
{ *strp++ = (unsigned char)strtol((char *)yytext+2, (char **)0, 16); }
break;
case 56:
    { *strp++ = *(strchr("\rr\bb\ff\nn\tt\vv", yytext[1]) - 1); }
break;
case 57:
{
                			*strp = '\0';
                			oldyy0 = yytext[0];
                			strp = RETSTRVAL;
                			return(last=CODELINE);			/* Return the bits */
            			}
break;
case 58:
   {
        			*strp = '\0';
        			BEGIN NORM;
        			oldyy0 = yytext[0];
        			strp = RETSTRVAL;
        			return(last=ENDCODE);			/* Return the bits */
    			}
break;
case 59:
	{ *strp++ = yytext[1]; }
break;
case 60:
	{ *strp++ = yytext[0]; }
break;
case 61:
{ oldyy0 = yytext[0]; continuation_line = TRUE; lines_parsed++; }
break;
case 62:
		{ unput(yytext[0]); BEGIN NORM; }
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
int yyvstop[] = {
0,

62,
0,

62,
0,

62,
0,

52,
62,
0,

48,
62,
0,

52,
62,
0,

49,
52,
62,
0,

52,
62,
0,

51,
52,
62,
0,

52,
62,
0,

43,
62,
0,

39,
43,
62,
0,

40,
62,
0,

43,
62,
0,

43,
62,
0,

37,
43,
62,
0,

42,
43,
62,
0,

36,
43,
62,
0,

38,
43,
62,
0,

38,
43,
62,
0,

38,
43,
62,
0,

38,
43,
62,
-32,
0,

38,
43,
62,
-33,
0,

38,
43,
62,
0,

35,
43,
62,
0,

41,
43,
62,
0,

38,
43,
62,
0,

38,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

36,
43,
62,
0,

60,
62,
0,

57,
62,
0,

60,
62,
0,

60,
62,
0,

60,
62,
0,

60,
62,
0,

61,
0,

50,
0,

48,
0,

50,
0,

50,
0,

44,
50,
0,

50,
0,

47,
50,
0,

28,
0,

42,
0,

36,
0,

31,
0,

32,
0,

33,
0,

34,
0,

34,
0,

35,
0,

30,
0,

27,
0,

29,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

22,
36,
0,

19,
36,
0,

36,
0,

36,
0,

1,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

14,
36,
0,

58,
0,

59,
0,

57,
0,

59,
0,

59,
0,

53,
59,
0,

59,
0,

56,
59,
0,

45,
0,

44,
0,

46,
0,

34,
0,

2,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

3,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

54,
0,

53,
0,

55,
0,

34,
0,

34,
0,

18,
36,
0,

24,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

13,
36,
0,

36,
0,

36,
0,

12,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

15,
36,
0,

34,
0,

36,
0,

36,
0,

25,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

11,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

23,
36,
0,

36,
0,

36,
0,

36,
0,

17,
36,
0,

36,
0,

10,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

9,
36,
0,

26,
36,
0,

20,
36,
0,

16,
36,
0,

36,
0,

4,
36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

36,
0,

21,
36,
0,

36,
0,

5,
36,
0,

36,
0,

36,
0,

7,
36,
0,

8,
36,
0,

36,
0,

6,
36,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,9,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,9,	1,9,	
0,0,	10,9,	1,10,	2,10,	
14,13,	8,53,	22,21,	53,52,	
59,58,	63,62,	69,0,	104,103,	
109,109,	0,0,	4,14,	0,0,	
0,0,	0,0,	11,57,	11,58,	
0,0,	0,0,	11,59,	0,0,	
0,0,	1,9,	1,9,	1,11,	
2,11,	55,101,	8,54,	27,71,	
1,9,	8,55,	3,12,	4,15,	
0,0,	1,9,	1,9,	4,16,	
4,17,	11,57,	3,12,	3,13,	
11,60,	1,9,	3,14,	0,0,	
0,0,	0,0,	0,0,	0,0,	
23,68,	35,78,	1,9,	36,80,	
38,82,	97,130,	1,9,	81,116,	
48,98,	42,89,	84,119,	94,127,	
74,113,	85,120,	99,133,	3,15,	
41,88,	3,12,	3,12,	3,16,	
3,17,	37,81,	42,90,	43,91,	
3,12,	1,9,	39,83,	44,92,	
39,84,	3,12,	3,12,	40,86,	
8,56,	47,97,	40,87,	1,9,	
49,99,	3,12,	39,85,	46,95,	
45,93,	4,18,	45,94,	50,100,	
74,113,	82,117,	3,12,	1,9,	
83,118,	86,121,	3,12,	87,122,	
88,123,	5,19,	92,126,	91,124,	
46,96,	95,128,	96,129,	98,131,	
98,132,	5,20,	5,21,	117,140,	
118,141,	5,22,	35,79,	91,125,	
119,142,	3,12,	120,146,	121,147,	
122,148,	3,18,	119,143,	123,149,	
124,150,	119,144,	125,151,	3,12,	
127,152,	119,145,	128,153,	129,154,	
130,155,	5,23,	5,24,	5,25,	
5,26,	5,27,	5,28,	3,12,	
5,29,	5,29,	5,29,	5,30,	
5,29,	5,31,	5,32,	5,29,	
5,33,	5,33,	131,156,	132,157,	
133,158,	141,160,	142,161,	143,162,	
5,33,	144,163,	5,29,	5,34,	
5,35,	5,29,	5,36,	145,164,	
5,29,	5,37,	5,26,	5,38,	
5,26,	5,39,	5,40,	5,41,	
146,165,	5,42,	147,166,	149,167,	
5,43,	150,168,	5,44,	5,45,	
5,46,	5,47,	5,48,	5,49,	
5,50,	152,169,	6,22,	153,170,	
5,26,	154,171,	155,172,	5,29,	
156,173,	5,29,	5,29,	157,174,	
160,175,	5,26,	5,26,	5,26,	
5,26,	5,26,	161,176,	163,177,	
164,178,	165,179,	6,23,	6,24,	
6,25,	166,180,	5,26,	6,28,	
167,181,	6,29,	6,29,	6,29,	
169,182,	6,29,	6,31,	6,32,	
6,29,	170,183,	171,184,	172,185,	
5,29,	173,186,	174,187,	176,188,	
177,189,	178,190,	180,191,	6,29,	
6,34,	6,35,	6,29,	6,36,	
182,192,	6,29,	183,193,	6,26,	
6,38,	6,26,	184,194,	6,40,	
6,41,	185,195,	6,42,	190,196,	
192,197,	6,43,	193,198,	6,44,	
6,45,	6,46,	6,47,	6,48,	
6,49,	6,50,	194,199,	195,200,	
196,201,	197,202,	198,203,	199,204,	
6,29,	200,205,	6,29,	6,29,	
7,51,	201,206,	6,26,	203,207,	
6,26,	6,26,	6,26,	205,208,	
7,51,	7,52,	206,209,	209,210,	
7,53,	0,0,	18,61,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	18,61,	18,62,	
0,0,	0,0,	18,63,	0,0,	
0,0,	6,29,	0,0,	0,0,	
0,0,	0,0,	0,0,	7,51,	
7,51,	7,54,	0,0,	0,0,	
7,55,	0,0,	7,51,	0,0,	
0,0,	0,0,	0,0,	7,51,	
7,51,	18,61,	18,61,	0,0,	
0,0,	0,0,	0,0,	7,51,	
18,61,	25,69,	0,0,	0,0,	
0,0,	18,64,	18,65,	0,0,	
7,51,	25,69,	25,0,	0,0,	
7,51,	18,65,	64,110,	64,110,	
64,110,	64,110,	64,110,	64,110,	
64,110,	64,110,	18,61,	0,0,	
0,0,	0,0,	18,61,	0,0,	
0,0,	0,0,	0,0,	7,51,	
0,0,	0,0,	0,0,	7,56,	
25,69,	25,69,	0,0,	0,0,	
0,0,	7,51,	0,0,	25,69,	
0,0,	18,66,	0,0,	0,0,	
25,69,	25,69,	0,0,	0,0,	
0,0,	7,51,	0,0,	18,67,	
25,69,	105,134,	105,134,	105,134,	
105,134,	105,134,	105,134,	105,134,	
105,134,	25,69,	0,0,	18,67,	
0,0,	25,69,	32,74,	32,74,	
32,74,	32,74,	32,74,	32,74,	
32,74,	32,74,	32,74,	32,74,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	26,70,	
25,69,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	25,69,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	0,0,	25,69,	0,0,	
0,0,	0,0,	0,0,	0,0,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	0,0,	0,0,	
0,0,	0,0,	26,70,	0,0,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	26,70,	26,70,	
26,70,	26,70,	30,72,	30,72,	
30,72,	0,0,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	0,0,	30,72,	30,72,	
30,72,	0,0,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	0,0,	30,72,	
30,72,	30,72,	0,0,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	30,72,	30,72,	30,72,	
30,72,	0,0,	30,72,	31,73,	
31,73,	31,73,	0,0,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	0,0,	31,73,	
31,73,	31,73,	0,0,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	0,0,	
31,73,	31,73,	31,73,	0,0,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	31,73,	31,73,	
31,73,	31,73,	33,75,	31,73,	
33,76,	33,76,	33,76,	33,76,	
33,76,	33,76,	33,76,	33,76,	
33,76,	33,76,	56,102,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	56,102,	56,103,	
0,0,	33,77,	56,104,	0,0,	
60,60,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
60,60,	60,58,	0,0,	0,0,	
60,109,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	56,102,	56,102,	0,0,	
0,0,	0,0,	0,0,	0,0,	
56,102,	33,77,	0,0,	0,0,	
0,0,	56,105,	56,106,	60,60,	
60,60,	0,0,	0,0,	0,0,	
0,0,	56,106,	60,60,	0,0,	
0,0,	0,0,	0,0,	60,60,	
60,60,	0,0,	56,102,	0,0,	
0,0,	0,0,	56,102,	60,60,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
60,60,	0,0,	0,0,	0,0,	
60,60,	0,0,	0,0,	0,0,	
0,0,	56,107,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	56,108,	
0,0,	0,0,	0,0,	60,60,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	56,108,	
0,0,	60,60,	65,111,	65,111,	
65,111,	65,111,	65,111,	65,111,	
65,111,	65,111,	65,111,	65,111,	
0,0,	60,60,	66,112,	66,112,	
66,112,	66,112,	66,112,	66,112,	
66,112,	66,112,	66,112,	66,112,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	66,112,	
66,112,	66,112,	66,112,	66,112,	
66,112,	75,75,	75,75,	75,75,	
75,75,	75,75,	75,75,	75,75,	
75,75,	75,75,	75,75,	106,135,	
106,135,	106,135,	106,135,	106,135,	
106,135,	106,135,	106,135,	106,135,	
106,135,	0,0,	75,113,	0,0,	
0,0,	0,0,	0,0,	66,112,	
66,112,	66,112,	66,112,	66,112,	
66,112,	77,114,	0,0,	77,114,	
0,0,	0,0,	77,115,	77,115,	
77,115,	77,115,	77,115,	77,115,	
77,115,	77,115,	77,115,	77,115,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	75,113,	107,136,	
107,136,	107,136,	107,136,	107,136,	
107,136,	107,136,	107,136,	107,136,	
107,136,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
107,136,	107,136,	107,136,	107,136,	
107,136,	107,136,	113,137,	0,0,	
113,137,	0,0,	0,0,	113,138,	
113,138,	113,138,	113,138,	113,138,	
113,138,	113,138,	113,138,	113,138,	
113,138,	114,139,	114,139,	114,139,	
114,139,	114,139,	114,139,	114,139,	
114,139,	114,139,	114,139,	0,0,	
107,136,	107,136,	107,136,	107,136,	
107,136,	107,136,	115,115,	115,115,	
115,115,	115,115,	115,115,	115,115,	
115,115,	115,115,	115,115,	115,115,	
137,159,	137,159,	137,159,	137,159,	
137,159,	137,159,	137,159,	137,159,	
137,159,	137,159,	138,138,	138,138,	
138,138,	138,138,	138,138,	138,138,	
138,138,	138,138,	138,138,	138,138,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+-45,	0,		0,	
yycrank+-13,	yysvec+3,	0,	
yycrank+-116,	0,		0,	
yycrank+-189,	yysvec+5,	0,	
yycrank+-283,	0,		0,	
yycrank+-4,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+3,	0,		yyvstop+3,
yycrank+21,	0,		yyvstop+5,
yycrank+0,	0,		yyvstop+7,
yycrank+0,	0,		yyvstop+10,
yycrank+6,	0,		yyvstop+13,
yycrank+0,	0,		yyvstop+16,
yycrank+0,	yysvec+11,	yyvstop+20,
yycrank+0,	0,		yyvstop+23,
yycrank+-297,	0,		yyvstop+27,
yycrank+0,	0,		yyvstop+30,
yycrank+0,	0,		yyvstop+33,
yycrank+0,	0,		yyvstop+37,
yycrank+8,	0,		yyvstop+40,
yycrank+3,	0,		yyvstop+43,
yycrank+0,	0,		yyvstop+46,
yycrank+-340,	0,		yyvstop+50,
yycrank+391,	0,		yyvstop+54,
yycrank+3,	0,		yyvstop+58,
yycrank+0,	yysvec+11,	yyvstop+62,
yycrank+0,	0,		yyvstop+66,
yycrank+478,	0,		yyvstop+70,
yycrank+567,	0,		yyvstop+75,
yycrank+362,	0,		yyvstop+80,
yycrank+644,	0,		yyvstop+84,
yycrank+0,	0,		yyvstop+88,
yycrank+4,	0,		yyvstop+92,
yycrank+6,	0,		yyvstop+96,
yycrank+7,	yysvec+26,	yyvstop+100,
yycrank+3,	yysvec+26,	yyvstop+104,
yycrank+14,	yysvec+26,	yyvstop+108,
yycrank+16,	yysvec+26,	yyvstop+112,
yycrank+4,	yysvec+26,	yyvstop+116,
yycrank+3,	yysvec+26,	yyvstop+120,
yycrank+8,	yysvec+26,	yyvstop+124,
yycrank+12,	yysvec+26,	yyvstop+128,
yycrank+22,	yysvec+26,	yyvstop+132,
yycrank+38,	yysvec+26,	yyvstop+136,
yycrank+12,	yysvec+26,	yyvstop+140,
yycrank+3,	yysvec+26,	yyvstop+144,
yycrank+16,	yysvec+26,	yyvstop+148,
yycrank+28,	yysvec+26,	yyvstop+152,
yycrank+0,	0,		yyvstop+156,
yycrank+0,	0,		yyvstop+159,
yycrank+9,	0,		yyvstop+162,
yycrank+0,	yysvec+11,	yyvstop+165,
yycrank+4,	0,		yyvstop+168,
yycrank+-701,	0,		yyvstop+171,
yycrank+0,	yysvec+11,	0,	
yycrank+0,	0,		yyvstop+174,
yycrank+10,	0,		0,	
yycrank+-715,	0,		0,	
yycrank+0,	0,		yyvstop+176,
yycrank+0,	0,		yyvstop+178,
yycrank+11,	0,		yyvstop+180,
yycrank+306,	0,		yyvstop+182,
yycrank+766,	0,		yyvstop+184,
yycrank+778,	0,		yyvstop+187,
yycrank+0,	0,		yyvstop+189,
yycrank+0,	0,		yyvstop+192,
yycrank+-12,	yysvec+25,	yyvstop+194,
yycrank+0,	yysvec+26,	yyvstop+196,
yycrank+0,	0,		yyvstop+198,
yycrank+0,	0,		yyvstop+200,
yycrank+0,	0,		yyvstop+202,
yycrank+7,	yysvec+32,	yyvstop+204,
yycrank+801,	0,		yyvstop+206,
yycrank+0,	yysvec+33,	yyvstop+208,
yycrank+838,	0,		0,	
yycrank+0,	0,		yyvstop+210,
yycrank+0,	0,		yyvstop+212,
yycrank+0,	0,		yyvstop+214,
yycrank+3,	yysvec+26,	yyvstop+216,
yycrank+26,	yysvec+26,	yyvstop+218,
yycrank+29,	yysvec+26,	yyvstop+220,
yycrank+6,	yysvec+26,	yyvstop+222,
yycrank+4,	yysvec+26,	yyvstop+224,
yycrank+31,	yysvec+26,	yyvstop+226,
yycrank+36,	yysvec+26,	yyvstop+228,
yycrank+37,	yysvec+26,	yyvstop+230,
yycrank+0,	yysvec+26,	yyvstop+232,
yycrank+0,	yysvec+26,	yyvstop+235,
yycrank+52,	yysvec+26,	yyvstop+238,
yycrank+34,	yysvec+26,	yyvstop+240,
yycrank+0,	yysvec+26,	yyvstop+242,
yycrank+3,	yysvec+26,	yyvstop+245,
yycrank+39,	yysvec+26,	yyvstop+247,
yycrank+43,	yysvec+26,	yyvstop+249,
yycrank+4,	yysvec+26,	yyvstop+251,
yycrank+40,	yysvec+26,	yyvstop+253,
yycrank+9,	yysvec+26,	yyvstop+255,
yycrank+0,	yysvec+26,	yyvstop+257,
yycrank+0,	0,		yyvstop+260,
yycrank+0,	0,		yyvstop+262,
yycrank+0,	0,		yyvstop+264,
yycrank+13,	0,		yyvstop+266,
yycrank+349,	0,		yyvstop+268,
yycrank+811,	0,		yyvstop+270,
yycrank+855,	0,		yyvstop+273,
yycrank+0,	0,		yyvstop+275,
yycrank+-11,	yysvec+60,	0,	
yycrank+0,	yysvec+64,	yyvstop+278,
yycrank+0,	yysvec+65,	yyvstop+280,
yycrank+0,	yysvec+66,	yyvstop+282,
yycrank+883,	0,		0,	
yycrank+893,	0,		0,	
yycrank+910,	0,		yyvstop+284,
yycrank+0,	yysvec+26,	yyvstop+286,
yycrank+58,	yysvec+26,	yyvstop+289,
yycrank+59,	yysvec+26,	yyvstop+291,
yycrank+65,	yysvec+26,	yyvstop+293,
yycrank+50,	yysvec+26,	yyvstop+295,
yycrank+48,	yysvec+26,	yyvstop+297,
yycrank+59,	yysvec+26,	yyvstop+299,
yycrank+73,	yysvec+26,	yyvstop+301,
yycrank+75,	yysvec+26,	yyvstop+303,
yycrank+62,	yysvec+26,	yyvstop+305,
yycrank+0,	yysvec+26,	yyvstop+307,
yycrank+75,	yysvec+26,	yyvstop+310,
yycrank+81,	yysvec+26,	yyvstop+312,
yycrank+80,	yysvec+26,	yyvstop+314,
yycrank+72,	yysvec+26,	yyvstop+316,
yycrank+81,	yysvec+26,	yyvstop+318,
yycrank+82,	yysvec+26,	yyvstop+320,
yycrank+88,	yysvec+26,	yyvstop+322,
yycrank+0,	yysvec+105,	yyvstop+324,
yycrank+0,	yysvec+106,	yyvstop+326,
yycrank+0,	yysvec+107,	yyvstop+328,
yycrank+920,	0,		0,	
yycrank+930,	0,		yyvstop+330,
yycrank+0,	yysvec+114,	yyvstop+332,
yycrank+0,	yysvec+26,	yyvstop+334,
yycrank+96,	yysvec+26,	yyvstop+337,
yycrank+105,	yysvec+26,	yyvstop+340,
yycrank+101,	yysvec+26,	yyvstop+342,
yycrank+94,	yysvec+26,	yyvstop+344,
yycrank+97,	yysvec+26,	yyvstop+346,
yycrank+115,	yysvec+26,	yyvstop+348,
yycrank+125,	yysvec+26,	yyvstop+350,
yycrank+0,	yysvec+26,	yyvstop+352,
yycrank+126,	yysvec+26,	yyvstop+355,
yycrank+117,	yysvec+26,	yyvstop+357,
yycrank+0,	yysvec+26,	yyvstop+359,
yycrank+119,	yysvec+26,	yyvstop+362,
yycrank+126,	yysvec+26,	yyvstop+364,
yycrank+136,	yysvec+26,	yyvstop+366,
yycrank+133,	yysvec+26,	yyvstop+368,
yycrank+132,	yysvec+26,	yyvstop+370,
yycrank+129,	yysvec+26,	yyvstop+372,
yycrank+0,	yysvec+26,	yyvstop+374,
yycrank+0,	yysvec+137,	yyvstop+377,
yycrank+142,	yysvec+26,	yyvstop+379,
yycrank+135,	yysvec+26,	yyvstop+381,
yycrank+0,	yysvec+26,	yyvstop+383,
yycrank+140,	yysvec+26,	yyvstop+386,
yycrank+141,	yysvec+26,	yyvstop+388,
yycrank+151,	yysvec+26,	yyvstop+390,
yycrank+143,	yysvec+26,	yyvstop+392,
yycrank+152,	yysvec+26,	yyvstop+394,
yycrank+0,	yysvec+26,	yyvstop+396,
yycrank+145,	yysvec+26,	yyvstop+399,
yycrank+168,	yysvec+26,	yyvstop+401,
yycrank+170,	yysvec+26,	yyvstop+403,
yycrank+169,	yysvec+26,	yyvstop+405,
yycrank+157,	yysvec+26,	yyvstop+407,
yycrank+164,	yysvec+26,	yyvstop+409,
yycrank+0,	yysvec+26,	yyvstop+411,
yycrank+174,	yysvec+26,	yyvstop+414,
yycrank+164,	yysvec+26,	yyvstop+416,
yycrank+178,	yysvec+26,	yyvstop+418,
yycrank+0,	yysvec+26,	yyvstop+420,
yycrank+178,	yysvec+26,	yyvstop+423,
yycrank+0,	yysvec+26,	yyvstop+425,
yycrank+179,	yysvec+26,	yyvstop+428,
yycrank+170,	yysvec+26,	yyvstop+430,
yycrank+173,	yysvec+26,	yyvstop+432,
yycrank+188,	yysvec+26,	yyvstop+434,
yycrank+0,	yysvec+26,	yyvstop+436,
yycrank+0,	yysvec+26,	yyvstop+439,
yycrank+0,	yysvec+26,	yyvstop+442,
yycrank+0,	yysvec+26,	yyvstop+445,
yycrank+194,	yysvec+26,	yyvstop+448,
yycrank+0,	yysvec+26,	yyvstop+450,
yycrank+181,	yysvec+26,	yyvstop+453,
yycrank+197,	yysvec+26,	yyvstop+455,
yycrank+192,	yysvec+26,	yyvstop+457,
yycrank+206,	yysvec+26,	yyvstop+459,
yycrank+208,	yysvec+26,	yyvstop+461,
yycrank+208,	yysvec+26,	yyvstop+463,
yycrank+196,	yysvec+26,	yyvstop+465,
yycrank+210,	yysvec+26,	yyvstop+467,
yycrank+199,	yysvec+26,	yyvstop+469,
yycrank+200,	yysvec+26,	yyvstop+471,
yycrank+0,	yysvec+26,	yyvstop+473,
yycrank+204,	yysvec+26,	yyvstop+476,
yycrank+0,	yysvec+26,	yyvstop+478,
yycrank+208,	yysvec+26,	yyvstop+481,
yycrank+212,	yysvec+26,	yyvstop+483,
yycrank+0,	yysvec+26,	yyvstop+485,
yycrank+0,	yysvec+26,	yyvstop+488,
yycrank+226,	yysvec+26,	yyvstop+491,
yycrank+0,	yysvec+26,	yyvstop+493,
0,	0,	0};
struct yywork *yytop = yycrank+987;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,'$' ,'%' ,'%' ,01  ,
'%' ,'%' ,'%' ,'+' ,'%' ,'+' ,'%' ,'%' ,
'0' ,'1' ,'1' ,'1' ,'1' ,'1' ,'1' ,'1' ,
'8' ,'8' ,'%' ,01  ,'%' ,'%' ,'%' ,01  ,
'%' ,'A' ,'A' ,'A' ,'A' ,'E' ,'A' ,'$' ,
'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,
'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,
'X' ,'$' ,'$' ,'%' ,01  ,'%' ,'%' ,'$' ,
01  ,'A' ,'b' ,'A' ,'A' ,'E' ,'b' ,'$' ,
'$' ,'$' ,'$' ,'$' ,'$' ,'$' ,'n' ,'$' ,
'$' ,'$' ,'n' ,'$' ,'n' ,'$' ,'n' ,'$' ,
'X' ,'$' ,'$' ,01  ,'%' ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
1,1,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*
 * (c) Copyright 1990, OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * OSF/1 Release 1.0
*/
/*
#
# IBM CONFIDENTIAL
# Copyright International Business Machines Corp. 1989
# Unpublished Work
# All Rights Reserved
# Licensed Material - Property of IBM
#
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# 
*/
/* @(#)ncform	1.3  com/lib/l,3.1,8951 9/7/89 18:48:47 */
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
unsigned char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char yysbuf[YYLMAX];
unsigned char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	unsigned char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
            if (yylastch >= yytext + YYLMAX) {
                fprintf(yyout, "Maximum token length exceeded\n");
                yytext[YYLMAX] = 0;
                return 0;
            }
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( yyt > yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if(yyt < yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
                if (yyleng >= YYLMAX) {
                    fprintf(yyout, "Maximum token length exceeded\n");
                    yytext[YYLMAX] = 0;
                    return 0;
                }
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
yyback(p, m)
	int *p;
{
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
yyinput(){
	return(input());
	}
yyoutput(c)
  int c; {
	output(c);
	return 0;
	}
yyunput(c)
   int c; {
	unput(c);
	return 0;
	}
