/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef LOCAL_UNITS_H
#define LOCAL_UNITS_H

#include "derived_unit.h"

GenieWorkspace create_unit(const char* name, const char* label, const char* components, double scale);

String get_unit_properties(const String& encoded_unit);
const DerivedUnit& lookup_unit(const String& encoded_unit);

String get_unit_properties(const GenieWorkspace& gw);		// gw is the encoded unit workspace
const DerivedUnit& lookup_unit(const GenieWorkspace& gw);
double unit_convert(const GenieWorkspace& unit1, const GenieWorkspace& unit2);
GenieWorkspace get_unit_dimensions(const GenieWorkspace& unit);
String get_known_units();

GenieWorkspace unit_multiply(const GenieWorkspace& unit1, const GenieWorkspace& unit2);

#endif /* LOCAL_UNITS_H */
