C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C
C *** This function is called on non-dynamic library systems by MODULE:EXECUTE
C *** And can be used to test modules that have been linked into genie
C
      SUBROUTINE MODULE_TEST_FUNCTION(PARS_GET, PARS_PUT)
      IMPLICIT NONE
      CHARACTER*10 SA(5)
      EXTERNAL PARS_GET, PARS_PUT
      CALL MODULE_INFORMATION('MODULE_TEST_FUNCTION called ... ')
C
C *** Add "../library/mari_get_2d_file.f" (containing the SUBROUTINE G_GET_2D_FILE) to GENIE_FOR in Makefile
C
C      CALL G_GET_2D_FILE(PARS_GET, PARS_PUT)
C
      SA(1) = 'Hello'
      SA(2) = 'Junk'
      SA(3) = 'More Junk'
      CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'SA', SA, 5)
      END
C
C (coord_tran_func_t) function for draw/contour/function and draw/cellarray/function
C This is called if we are on a non-dynamic loading system
C
C If the contour values array is of size 10x10, then the contour function
C will be called with X [VAL_IN(1)] and Y [VAL_IN(2)] between 0.0 and 9.0 and an estimate of
C the Z value [VAL_IN[3]] at the point (unless labelling) - it should return the world X and Y values
C in VAL_OUT(1) and VAL_OUT(2). The array element FLAGS(1) is known as the
C visibility flag. On input it is 1 if the routine thinks the point should
C be drawn (which it usually does, unless this is a contour plot with blanking);
C if the point should not be drawn, set FLAGS(1) = 0
C
C For a cellarray, this routine is called with X and Y world coordinates and
C should return the X and Y  indexes into the values array (i.e. 0.0 to 9.0)
C which are then used to calculate the Z values
C
      FUNCTION SAMPLE_GENIE_COORD_TRAN_FUNC(FLAGS, VAL_IN, VAL_OUT)
      IMPLICIT NONE
      INTEGER SAMPLE_GENIE_COORD_TRAN_FUNC, FLAGS(*)
      DOUBLE PRECISION VAL_IN(3), VAL_OUT(2)
C      WRITE(6,*) VAL_IN(1),VAL_IN(2),VAL_IN(3)
C Simple contour
C      VAL_OUT(1) = VAL_IN(1)
C      VAL_OUT(2) = VAL_IN(2)
C 10x10 cell array
      IF (VAL_IN(1) .GE. 0.0 .AND. VAL_IN(1) .LE. 9.0) THEN
          VAL_OUT(1) = VAL_IN(1)
      ELSE
          VAL_OUT(1) = -1.0
      ENDIF
      IF (VAL_IN(2) .GE. 0.0 .AND. VAL_IN(2) .LE. 9.0) THEN
          VAL_OUT(2) = VAL_IN(2)
      ELSE
          VAL_OUT(2) = -1.0
      ENDIF
      SAMPLE_GENIE_COORD_TRAN_FUNC = 0
      RETURN
      END
C
