/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef IOFUNCS__
#define IOFUNCS__

#ifdef __cplusplus
extern "C" {
#endif

int io_open_channel(const char path[], int flags, int mode);
int io_close_channel(int fd);
int io_write_channel(int fd, const char string[] );
int io_read_channel(int fd, char buffer[], size_t len );
void io_fflush(void);
void io_perror( int line, const char file[], const char routine[] );
void io_terminal_wait(void);
void send_command(char *command);

#ifdef __cplusplus
}
#endif

#endif /* IOFUCNCS__ */
