C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
c	PROGRAM PGLINK.FOR
C
C	This program provides the links needed under the UNIX
C	operating system to allow the C++ of Genie to pass 
C	character strings by reference to the FORTRAN PGPLOT
C	library.
C
C	There is a subroutine written for each PGPLOT routine
C	that passes a character string.
C
C
C *****
	SUBROUTINE GRESC_(STRING)

	IMPLICIT	NONE
        CHARACTER*512	EXTRACT_STRING, EX
	INTEGER		STRING(*)
	EXTERNAL 	GRESC

	EX = EXTRACT_STRING(STRING(2), STRING(1))
	CALL GRESC(EX(:STRING(1)))
	RETURN
	END

	INTEGER FUNCTION PGOPEN_(STRING)

	IMPLICIT	NONE
        CHARACTER*512	EXTRACT_STRING
	INTEGER		PGOPEN, STRING(*)
        EXTERNAL 	PGOPEN

	PGOPEN_ = PGOPEN(EXTRACT_STRING(STRING(2), STRING(1)))
	RETURN
	END

	SUBROUTINE PGBEGIN_( I1, STRING, I2, I3)

	IMPLICIT	NONE
        CHARACTER*512	EXTRACT_STRING
	INTEGER		STRING(*)
	INTEGER		I1, I2, I3

	CALL PGBEGIN(I1, EXTRACT_STRING(STRING(2), STRING(1) ), I2, I3 )
	RETURN
	END

C *****
	SUBROUTINE PGBOX_(STRING1, R1, I1,STRING2, R2, I2)

	IMPLICIT	NONE
        CHARACTER*512	EXTRACT_STRING
	INTEGER		STRING1(*),STRING2(*)
	INTEGER		I1, I2
	REAL		R1,R2

	CALL PGBOX(EXTRACT_STRING(STRING1(2), STRING1(1)), R1,I1, 
     1		  EXTRACT_STRING(STRING2(2), STRING2(1)) ,R2, I2)
	RETURN
	END

C *****
	INTEGER FUNCTION PGCURSE_(R1,R2, STRING1)

	IMPLICIT	NONE
        CHARACTER*512	EXTRACT_STRING
	CHARACTER*1	LETTER
	INTEGER		PGCURSE
	INTEGER		STRING1(*)
	REAL		R1,R2

	LETTER = EXTRACT_STRING(STRING1(2), STRING1(1))
	PGCURSE_ = PGCURSE(R1, R2,LETTER)
	CALL REPLACE_STRING(LETTER, 1, STRING1)
	RETURN
	END

C *****
	SUBROUTINE PGLABEL_(STRING1, STRING2, STRING3)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*),STRING2(*),STRING3(*)

	CALL PGLABEL(EXTRACT_STRING(STRING1(2), STRING1(1)),
     1		  EXTRACT_STRING(STRING2(2), STRING2(1)),
     2		  EXTRACT_STRING(STRING3(2), STRING3(1)))
	RETURN
	END

C *****
C	SUBROUTINE PGLEN_(I1, STRING1, R1, R2)
C
C	IMPLICIT	NONE
C        CHARACTER*512   EXTRACT_STRING
C	INTEGER		STRING1(*)
C	INTEGER		I1
C	REAL		R1,R2
C
C	CALL PGLEN(I1, EXTRACT_STRING(STRING1(2), STRING1(1)),
C     1		  R1, R2)
C	END

C *****
	SUBROUTINE PGMTEXT_(STRING1, R1, R2, R3, STRING2)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*),STRING2(*)
	REAL		R1,R2,R3

	CALL PGMTEXT(EXTRACT_STRING(STRING1(2), STRING1(1)),
     1		  R1, R2, R3,
     2	          EXTRACT_STRING(STRING2(2), STRING2(1)))
	RETURN
	END

C *****
	SUBROUTINE PGNUMB_(I1, I2, I3, STRING1, I4)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*)
	INTEGER		I1,I2,I3,I4

	CALL PGNUMB(I1, I2, I3, EXTRACT_STRING(STRING1(2), STRING1(1)),I4)
	RETURN
	END

C *****
	SUBROUTINE PGPTEXT_(R1, R2, R3, R4, STRING1)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*)
	REAL		R1,R2,R3,R4

	CALL PGPTEXT(R1, R2, R3, R4,EXTRACT_STRING(STRING1(2),STRING1(1)))
	RETURN
	END

C *****
	SUBROUTINE PGQINF_(STRING1, STRING2, I1)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*), STRING2(*)
	INTEGER		I1

	CALL PGQINF(EXTRACT_STRING(STRING1(2), STRING1(1)),
     1		  EXTRACT_STRING(STRING2(2), STRING2(1)), I1)
	RETURN
	END

C *****
C	SUBROUTINE PGTBOX_(STRING1, R1, I1, STRING2, R2, I2 )
C
C	IMPLICIT	NONE
C        CHARACTER*512   EXTRACT_STRING
C	INTEGER		STRING1(*),STRING2(*)
C	INTEGER		I1,I2
C	REAL		R1,R2
C
C	CALL PGTBOX(EXTRACT_STRING(STRING1(2), STRING1(1)), R1, I1,
C     1		    EXTRACT_STRING(STRING2(2), STRING2(1)), R2,I2)
C	END

C *****
	SUBROUTINE PGTEXT_(R1, R2, STRING1)

	IMPLICIT	NONE
        CHARACTER*512   EXTRACT_STRING
	INTEGER		STRING1(*)
	REAL		R1,R2

	CALL PGTEXT(R1, R2, EXTRACT_STRING(STRING1(2), STRING1(1)))
	RETURN
	END
C *****
	SUBROUTINE PGSCRN_(I1, STRING1, I2)
	IMPLICIT NONE
	INTEGER I1, I2
	INTEGER STRING1(*)
	CHARACTER*512 EXTRACT_STRING
	CALL PGSCRN(I1, EXTRACT_STRING(STRING1(2), STRING1(1)), I2)
	RETURN
	END

C *****
	SUBROUTINE PGCONLX_(A, IDIM, JDIM, I1, I2, J1, J2, C,
     + FUNC, ILABEL, INTVAL, MININT)
	IMPLICIT NONE
        INTEGER IDIM, JDIM, I1, J1, I2, J2, INTVAL, MININT
        REAL A(IDIM,JDIM), C
        EXTERNAL FUNC
 	INTEGER ILABEL(*)
	CHARACTER*512 EXTRACT_STRING
	CALL PGCONLX(A, IDIM, JDIM, I1, I2, J1, J2, C,
     + FUNC, EXTRACT_STRING(ILABEL(2), ILABEL(1)), INTVAL, MININT)
	RETURN
	END

