/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "geniedefs.h"
#include "g_types.h"
#include "Pginclude.h"
#include "polygon_array.h"
#include "pg_coord_trans_func.h"

static const char* rcsid = "@(#)$Id: polygon_array.cxx,v 1.1 1998/06/16 22:33:47 faa Exp $";
USE_RCSID(rcsid);

PolygonArray::PolygonArray(g_real* values, int nx_values, int ny_values, 
	g_real fg, g_real bg, int type, int mode, g_integer* table, int ntab, 
	TwoDimensionalCoordinateTransformFunction* ctf) :
CellArray(values, nx_values, ny_values, fg, bg, type, mode, table, ntab, ctf)
{
}

PolygonArray::~PolygonArray()
{
}

void PolygonArray::display()
{
    displayPlot();
}

void PolygonArray::displayPlot()
{
    PGCoordinateTransformFunction* pg_func = (PGCoordinateTransformFunction*)this->function();
    pg_func->setPointers();
    pg_cont_lab_func_t func = pg_func->contourLabelFunction;
    pgpolyarray(m_values.values(), m_values.dims(0), m_values.dims(1), 1, m_values.dims(0), 1, m_values.dims(1),
		   m_fg, m_bg, func, m_table, m_ntab, m_type, m_mode);
}

