/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef SMALLTALK_OBJECT
#define SMALLTALK_OBJECT

// 
// Class for encapsulating a Smalltalk object into Genie
//
// Author:	Freddie Akeroyd, 1/11/96
//

class SmalltalkObject
{
    private:
	OOP m_value;
	OOP m_class;
	OOP m_instVarArray;
	int m_numInstVars;
    
	int lookupName(const char* name);
	int setup();

    public:
	OOP at(const char* name);
	OOP arrayAt(int i);
	int arrayLength();
	int atPut(const char* name, OOP oop);
	int arrayAtPut(int i, OOP oop);
	SmalltalkObject(OOP parameters, int location);
	SmalltalkObject(OOP value);
	SmalltalkObject(const char* type);
	operator OOP() { return m_value; }
	OOP operator()(const char* name) { return at(name); }
	int operator()(const char* name, OOP oop) { return atPut(name, oop); }
	fromString(const char* name, const char* value);
	ostream& print(ostream& os) const;
};

inline ostream& operator<<(ostream& os, const SmalltalkObject& s)
{
    return s.print(os);
}

#endif /* SMALLTALK_OBJECT */
