/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef TWO_DIMENSIONAL_PLOT_H
#define TWO_DIMENSIONAL_PLOT_H

#include "n_d_plot.h"
#include "two_d_coord_trans_func.h"

class TwoDimensionalPlot : public NDimensionalPlot
{
    public:
	int setupValues(g_real* values, int dim1, int dim2);
	int setupFunction(coord_tran_func_t func);
	int setupFunction(g_real* x, int* x_dims, int nx_dims, CoordinateTransformMode x_mode, 
				g_real*y, int* y_dims, int ny_dims, CoordinateTransformMode y_mode);
	int setupFunction(g_real* matrix);
	TwoDimensionalPlot(g_real* values, int dim1, int dim2, TwoDimensionalCoordinateTransformFunction* ctf);
	TwoDimensionalPlot() : NDimensionalPlot() {}
};

#endif /* TWO_DIMENSIONAL_PLOT_H */
