/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef _WIN32
#	include <sys/utsname.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "vms_uname.h"

int uname(struct utsname* name)
{
    static char buffer[100];

#if defined(__VMS) && __VMS_VER < 70000000
    char* nodename = getenv("UCX$INET_HOST");

    static char* sysname = "VMS";
    static char* version = "";
    static char* release = "6.2";
    static char* machine = "Alpha";
#endif

#ifdef _WIN32
    char* nodename = getenv("COMPUTERNAME");
    char* sysname = getenv("OS");
    static char* version = "";
    static char* release = buffer;
    char* machine = getenv("PROCESSOR_ARCHITECTURE");

    sprintf(buffer, "%d.%d", _winmajor, _winminor);

#endif

    strncpy(name->sysname, (sysname != 0 ? sysname :   "<unknown>"), _SYS_NMLN);
    strncpy(name->nodename,(nodename != 0 ? nodename : "<unknown>"), _SYS_NMLN);
    strncpy(name->release, (release != 0 ? release :   "<unknown>"), _SYS_NMLN);
    strncpy(name->version, (version != 0 ? version :   "<unknown>"), _SYS_NMLN);
    strncpy(name->machine, (machine != 0 ? machine :   "<unknown>"), _SYS_NMLN);
    return 0;
}
