/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef VMS_PASSWORD_FUNCS
#define VMS_PASSWORD_FUNCS

#ifndef _WIN32
#	include <unixlib.h>
#endif

typedef unsigned uid_t;
typedef unsigned short gid_t;

struct passwd
{
    char *      pw_name;
    uid_t       pw_uid;
    gid_t       pw_gid;
    char *      pw_dir;
    char *      pw_shell;
};

#ifdef __cplusplus
extern "C"
{
#endif
    extern struct passwd* getpwuid(uid_t);
    extern char* getlogin(void);
    extern struct passwd* getpwnam(const char*);
#ifdef __cplusplus
}
#endif

#endif /* VMS_PASSWORD_FUNCS */
