C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C
C *** no write/minimum option ***
C
C To write a G2 intermediate file ... hacked from G2 code
C
C IMODE = 1 for Append to existing file
C         2 for New file
C
C *** error codes
C
C 0 = OK
C 1 = File already exists (new)
C 2 = error in opening file
C 3 = Invalid IMODE
C 4 = error in getsect
C 6 = address of X-values section or Detector section, Code needs updating to cope with this file
C 8 = Code needs updating to cope with this file
C 10 = illegal block number
C 12 = file not open
C 14 = Error in LOCAL_TO_VAXF
C
	SUBROUTINE WRITE_INT(IUNIT,FILENAME,LENNAME,LEN_STREAMS,XARRAY,
     1                      YARRAY,EARRAY,NO_OF_SPECTRA,NO_SPECTRUM,
     2			    NPT,DELTA,RUN_NUMBER,XCODE,
     3                      YCODE,E_MODE,FI,L1,L2,E_FIXED,TTHET,
     4			    RUN_DURATION,INST_NAME,LONG_TITLE,
     5			    RUN_USER,START_TIME,WS_HISTORY,
     6			    XCAPTION,YCAPTION,IMODE,MINIMUM,
     7			    DAT_FILE, L_DAT_FILE, USER_PAR, IERROR)
	IMPLICIT NONE
C
C    FILENAME is the filename 
C    LENNAME is the length of the filename
C    IERROR  is the status return
C    IBLOCK is the block number to be read from the file
C    IUNIT
C
      INTEGER*4 REC_LEN,NEXT_REC
	INTEGER*4 LEN_STREAMS, CH_OF_YMIN, LENNAME, IERROR
	INTEGER*4 CH_OF_YMAX, L_DAT_FILE, NPT, IMODE, EXTRA, TOTAL
	INTEGER*4 IWORK(256), INST_STR, LEN_PDFN, NO_SPECTRUM
	REAL*4 RWORK(256), FI, XMN, XMX, YMN, YMX, PI
	CHARACTER*1024 CWORK
	CHARACTER*75 DAT_FILE
	CHARACTER*20 NAME
	REAL*4 USER_PAR(30), TUSER_PAR(30),L1,L2
C
	LOGICAL EOD,FOUND,OPENFILE,SUCCESS
	CHARACTER*80 FILENAME,NAMEFILE
	INTEGER NO_OF_SPECTRA,IUNIT,I,J,K,KK,ISTATUS,II,IOERR
	INTEGER LEN_PBLOCKS,LEN_XBLOCKS,LEN_YBLOCKS,LEN_EBLOCKS
	INTEGER ADD_SPECTRA
	INTEGER*4 XCODE, YCODE, E_MODE, RUN_NUMBER, INST_CODE
	CHARACTER*200 WS_HISTORY
	CHARACTER*80 LONG_TITLE
	CHARACTER*8 INST_NAME
	CHARACTER*40 XCAPTION, YCAPTION, MCAPTION
	CHARACTER*20 RUN_USER, START_TIME                   
	INTEGER*4 MINIMUM	
	INTEGER NPOINTS_SAVE
	CHARACTER*7 FSTATUS
	REAL*4 DELTA, RUN_DURATION, TTHET, E_FIXED, XARRAY(NPT+1), 
     1      YARRAY(NPT), EARRAY(NPT)
	INTEGER*4 NO_SPCTRUM
	EQUIVALENCE (IWORK,CWORK), (IWORK,RWORK)
        COMMON /G2WRITE/ NEXT_REC
	EXTERNAL LOCAL_TO_VAXF, VAXF_TO_LOCAL, FERROR_ADD, G2_INT_COMPAT
	EXTERNAL LOCAL_TO_VAX_INTS, VAX_TO_LOCAL_INTS, LOCAL_TO_VAX_INT
	EXTERNAL IFORTRECSIZE
	INTEGER LOCAL_TO_VAX_INT,IFORTRECSIZE
C determine the RECL parameter value for 512 byte records
        REC_LEN = 512 / IFORTRECSIZE()
C
	PI=ACOS(-1.0)
	NAMEFILE=' '
	MCAPTION=' '
        NEXT_REC=1
	INQUIRE(FILE=FILENAME(:LENNAME), EXIST=FOUND)
	IF (IMODE .EQ. 1) THEN
	    FSTATUS='OLD'
	    IF (.NOT. FOUND) THEN
		CALL FERROR_ADD('INFORMATION', 
     1	'WRITE_INT: File not found - creating new one', ' ')
	  	FSTATUS='NEW'
	    ENDIF
	ELSE IF (IMODE .EQ. 2) THEN
	    FSTATUS='NEW'
	    IF (FOUND) THEN
	        FSTATUS='UNKNOWN'
		CALL FERROR_ADD('INFORMATION', 
     1			'WRITE_INT: Overwriting existing file', ' ')
	 	CALL REMOVE_FILE(FILENAME(:LENNAME))
	    ENDIF
	ELSE
	    CALL FERROR_ADD('WRITE_INT', 'Invalid mode', ' ')
	    IERROR = 3
	    RETURN
	ENDIF
	IF (MINIMUM .EQ. 0) THEN
	    npoints_save = len_streams			
	ELSE
	    npoints_save = npt + 1
	ENDIF
	len_pblocks = 155+30
	total = 3*npoints_save + len_pblocks
C round up size to a multiple of 512 bytes ... allows us to reopen and append
	extra = (total/128 + 1)*128 - total 
	len_eblocks = npoints_save + extra
	CALL G2_INT_COMPAT(CH_OF_YMIN, CH_OF_YMAX, INST_CODE,
     1				 INST_STR, XMN, XMX, YMN, YMX,
     2				 INST_NAME, XARRAY, YARRAY, NPT)
	    NAMEFILE=FILENAME
	    EOD=.FALSE.
	    CWORK(1:80)=' '
	    IWORK(21)=1		!VERSION
	    IWORK(22)=42	!address of History section
	    IWORK(23)=0		!address of Detector section
	    IWORK(24)=0		!address of X-values section
	    IWORK(25)=129	!address of Spectra section
	    IWORK(26)=0		!no. of spectra - to be completed later
	    IWORK(27)=len_pblocks	!length of P block(GENIE_HDR1+HDR2)
	    IWORK(28)=npoints_save	!length of x block					   !2
	    IWORK(29)=npoints_save	!length of y block					   !2
	    IWORK(30)=len_eblocks	!length of e block					   !2
	    IWORK(31)=0		!length of u1 block
	    IWORK(32)=0		!length of u2 block
	    IWORK(33)=0		!length of u3 block
	    IWORK(34)=0		!length of u4 block
	    IWORK(35)=0		!length of u5 block
	    IWORK(36)=0		!length of u6 block
	    IWORK(37)=0		!length of u7 block
	    IWORK(38)=0		!length of u8 block
	    IWORK(39)=0		!length of u9 block
	    IWORK(40)=0		!length of u10 block
	    IWORK(41)=0		!length of u11 block
	    CALL LOCAL_TO_VAX_INTS(IWORK(21), 21)
	    CWORK(165:364)=' '	!common history balnk so far
	    EOD=.FALSE.
C	    OPEN(UNIT=IUNIT,FILE=FILENAME(:LENNAME),STATUS=FSTATUS,
C     &	         RECORDTYPE='FIXED',RECL=REC_LEN,FORM='UNFORMATTED',
C     &	         ERR=910)
	    OPEN(UNIT=IUNIT,FILE=FILENAME(:LENNAME),STATUS=FSTATUS,
     &	         ACCESS='DIRECT',RECL=REC_LEN,FORM='UNFORMATTED', 
     &           ERR=910)
C *** UNKNOWN is used for overwriting a previous file
	IF ((FSTATUS .EQ. 'NEW') .OR. (FSTATUS .EQ. 'UNKNOWN')) THEN
	    CALL WRITE_DATA(EOD,IUNIT,IWORK,128,IERROR)
	    IF (IERROR .NE. 0) GOTO 930
	    NO_OF_SPECTRA=0
	ELSE
	    READ(IUNIT,REC=NEXT_REC,ERR=920) (IWORK(I),I=1,128)
	    CALL VAX_TO_LOCAL_INTS(IWORK(21), 21)
	    add_spectra=iwork(25)
	    NO_OF_SPECTRA=IWORK(26)
	    len_pblocks=iwork(27)
	    len_xblocks=iwork(28)
	    len_yblocks=iwork(29)
	    len_eblocks=iwork(30)
            npoints_save = len_xblocks
C	    CLOSE(IUNIT,ERR=940)
C	    OPEN(UNIT=IUNIT,FILE=FILENAME(:LENNAME),STATUS=FSTATUS,
C     &	         RECORDTYPE='FIXED',RECL=REC_LEN,FORM='UNFORMATTED',
C     &	         ERR=910,ACCESS='APPEND')
C *** Find end of file ***
            NEXT_REC=1+(add_spectra+(len_pblocks+len_xblocks+
     &                  len_yblocks+len_eblocks)*NO_OF_SPECTRA)/128
	ENDIF
        IF (npt+1 .gt. npoints_save) THEN
	    CALL FERROR_ADD('WRITE_INT', 
     &           'Too many data points for existing file', ' ')
	    CLOSE(IUNIT)
	    IERROR=2
	    NO_OF_SPECTRA=0
            RETURN
	ENDIF
C Get info from header 2 common block
C & write it out
	    EOD=.FALSE.
	    DO I=1,30
		TUSER_PAR(I) = USER_PAR(I)
	    ENDDO
	    CALL LOCAL_TO_VAXF(TUSER_PAR, 30, IERROR)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'USER_PAR'
C		GOTO 950
C	    ENDIF
	    CALL WRITE_DATA(EOD,IUNIT,TUSER_PAR,30,IERROR)
	    IF (IERROR .NE. 0) GOTO 930
C Get info from header 1 common block
C Put Abbreviations into history
	    IWORK(1)=LOCAL_TO_VAX_INT(ch_of_ymin)
	    IWORK(2)=LOCAL_TO_VAX_INT(ch_of_ymax)
	    RWORK(3)=delta
	    CALL LOCAL_TO_VAXF(rwork(3), 1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'DELTA'
C		GOTO 950
C	    ENDIF
	    IWORK(4)=LOCAL_TO_VAX_INT(l_dat_file)
	    CWORK(17:96)=dat_file
	    RWORK(25)=fi
	    CALL LOCAL_TO_VAXF(rwork(25), 1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'FI'
C		GOTO 950
C	    ENDIF
	    IWORK(26)=LOCAL_TO_VAX_INT(inst_code)
	    CWORK(105:112)=inst_name
	    IWORK(29)=LOCAL_TO_VAX_INT(inst_str)
	    IWORK(30)=LOCAL_TO_VAX_INT(xcode)
	    len_pdfn = lenname
	    IWORK(31)=LOCAL_TO_VAX_INT(len_pdfn)
	    RWORK(32)=L1
	    RWORK(33)=L2
	    CALL LOCAL_TO_VAXF(rwork(32), 2, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'L1 and L2'
C		GOTO 950
C	    ENDIF
	    CWORK(133:212)=long_title
	    IWORK(54)=LOCAL_TO_VAX_INT(no_spectrum)
	    IWORK(55)=LOCAL_TO_VAX_INT(npt)
	    IWORK(56)=LOCAL_TO_VAX_INT(run_number)
	    CWORK(225:244)=run_user
	    RWORK(62)=run_duration
	    CALL LOCAL_TO_VAXF(rwork(62), 1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'RUN_DURATION'
C		GOTO 950
C	    ENDIF
	    CWORK(249:268)=start_time
	    RWORK(68) = tthet * PI / 180.0
	    CALL LOCAL_TO_VAXF(rwork(68), 1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'TWO_THETA'
C		GOTO 950
C	    ENDIF
   	    CWORK(273:472)=ws_history
	    RWORK(119)=xmn
	    RWORK(120)=xmx
	    RWORK(121)=ymn
	    RWORK(122)=ymx
	    CALL LOCAL_TO_VAXF(rwork(119), 4, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'XMIN, XMAX, YMIN, YMAX'
C		GOTO 950
C	    ENDIF
	    CWORK(489:528)=xcaption
	    CWORK(529:568)=ycaption
	    CWORK(569:608)=mcaption
	    IWORK(153)=LOCAL_TO_VAX_INT(ycode)
	    IWORK(154)=LOCAL_TO_VAX_INT(e_mode)
	    RWORK(155)=e_fixed
	    CALL LOCAL_TO_VAXF(rwork(155), 1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'EFIXED'
C		GOTO 950
C	    ENDIF
	    CALL WRITE_DATA(EOD,IUNIT,IWORK,155,IERROR)
	    IF (IERROR .NE. 0) GOTO 930
C Write x,y,e array - 
	    CALL LOCAL_TO_VAXF(xarray, npt+1, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'X'
C		GOTO 950
C	    ENDIF
	    CALL LOCAL_TO_VAXF(yarray, npt, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'Y'
C		GOTO 950
C	    ENDIF
	    CALL LOCAL_TO_VAXF(earray, npt, ierror)
C	    IF (IERROR .NE. 0) THEN
C		NAME = 'E'
C		GOTO 950
C	    ENDIF
	    CALL WRITE_DATA(EOD,IUNIT,XARRAY,NPOINTS_save,IERROR)				
	    IF (IERROR .NE. 0) GOTO 930
	    CALL WRITE_DATA(EOD,IUNIT,YARRAY,NPOINTS_save,IERROR)		
	    IF (IERROR .NE. 0) GOTO 930
	    CALL WRITE_DATA(EOD,IUNIT,EARRAY,len_eblocks,IERROR)	
	    IF (IERROR .NE. 0) GOTO 930
	    CALL VAXF_TO_LOCAL(xarray, npt+1, ierror)
	    CALL VAXF_TO_LOCAL(yarray, npt, ierror)
	    CALL VAXF_TO_LOCAL(earray, npt, ierror)
C
	    NO_OF_SPECTRA=NO_OF_SPECTRA+1
C  close file
	    EOD=.TRUE.
	    CALL WRITE_DATA(EOD,IUNIT,IWORK,0,IERROR)
	    IF (IERROR .NE. 0) GOTO 930
	    CLOSE(UNIT=IUNIT,ERR=940)
	    OPEN(UNIT=IUNIT,FILE=NAMEFILE(:LENNAME),STATUS='OLD',
     +		ACCESS='DIRECT',FORM='UNFORMATTED',RECL=REC_LEN,ERR=910)
	    READ(IUNIT,REC=1,ERR=920) (IWORK(I),I=1,128)
	    IWORK(26)=LOCAL_TO_VAX_INT(NO_OF_SPECTRA)
	    WRITE(IUNIT,REC=1,ERR=930) (IWORK(I),I=1,128)
	    CLOSE(UNIT=IUNIT,ERR=940)
C
 	RETURN
 910	CALL FERROR_ADD('WRITE_INT', 
     1    'Unable to open intermediate file '//FILENAME(:LENNAME), ' ')
	IERROR=2
	    NO_OF_SPECTRA=0
	RETURN
 920	CALL FERROR_ADD('WRITE_INT', 
     1     'Unable to read intermediate file '//FILENAME(:LENNAME), ' ')
	IERROR=2
	    NO_OF_SPECTRA=0
	    CLOSE(UNIT=IUNIT,ERR=940)
	RETURN
 930	CALL FERROR_ADD('WRITE_INT', 
     1   'Unable to write intermediate file '//FILENAME(:LENNAME), ' ')
	IERROR=2
	    NO_OF_SPECTRA=0
	    CLOSE(UNIT=IUNIT,ERR=940)
	RETURN
 940	CALL FERROR_ADD('WRITE_INT', 
     1   'Unable to close intermediate file '//FILENAME(:LENNAME), ' ')
	IERROR=2
	    NO_OF_SPECTRA=0
	RETURN
C 950	CALL FERROR_ADD('WRITE_INT', 
C     1   'Error in LOCAL_TO_VAXF: '//NAME, ' ')
C	IERROR=14
C	    NO_OF_SPECTRA=0
C	RETURN
	END
c--------------------------------------------------------------------------
	SUBROUTINE WRITE_DATA(EOD,IUNIT,IVAL,N,IERROR)
	IMPLICIT NONE
	INTEGER BLOCKSIZE
	PARAMETER (BLOCKSIZE=128)
C  Routine to write out fixed length blocks(BLOCKSIZE integers) to a file
C  It accepts an array of values and splits it into blocks. Whenever part
C  of a block is left over it is stored for blocking at a later run of 
C  the routine. To clear  out the block at the end of a file a flag,EOD should
C  be set to .TRUE.
C
C  input parameters:
C	EOD	logical, .TRUE. if this is the last record, otherwise .FALSE.
C	IUNIT	unit number to write to
C	IVAL	array containing data
C	N	number of values to be written
	LOGICAL EOD
	INTEGER N,IUNIT,IERROR
	INTEGER*4 IVAL(*),NEXT_REC
	INTEGER ITOT,ILEFT,IPART,I,J,NBLOCKS,INEXT
	INTEGER IWORK(BLOCKSIZE)
C ensure IWORK cleared to start with and point to start of IWORK
        COMMON /G2WRITE/ NEXT_REC
	SAVE IWORK, INEXT
	DATA IWORK/BLOCKSIZE*0/,INEXT/1/
C
C
C  calculate total number of values to be written
	IERROR = 0
	ILEFT=N
	ITOT=ILEFT+INEXT-1
C
C  if at least 1 block then write out as many whole blocks as possible
	IF (ITOT.GT.BLOCKSIZE) THEN
C  First block is probably part IWORK, part IVAL
	    IPART=BLOCKSIZE+1-INEXT
	    WRITE(IUNIT,ERR=970,REC=NEXT_REC) (IWORK(I),I=1,INEXT-1),
     1                           (IVAL(I),I=1,IPART)
            NEXT_REC = NEXT_REC + 1
	    ITOT=ITOT-BLOCKSIZE
C  next blocks are all wholly IVAL
	    NBLOCKS=ITOT/BLOCKSIZE
	    IF (NBLOCKS.GT.0) THEN
	      DO 10 I=1,NBLOCKS
		WRITE(IUNIT,ERR=970,REC=NEXT_REC)(IVAL(IPART+(I-1)*BLOCKSIZE+J),
     +						J=1,BLOCKSIZE)
                NEXT_REC = NEXT_REC + 1
 10	      CONTINUE
	    ENDIF
C  then at the end there are probably a few values left over
	    ILEFT=ITOT-NBLOCKS*BLOCKSIZE
	    INEXT=1
	ENDIF
C  transfer the left overs into the temporary work space and save for next time
	IF (ILEFT.GT.0) THEN
	    DO 20 I=1,ILEFT
		IWORK(I+INEXT-1)=IVAL(N-ILEFT+I)
 20	    CONTINUE
	    INEXT=INEXT+ILEFT
	ENDIF
C  However if I've been told that this is the last block of this file
C  clear it out totally, providing there is something to clear out!
	IF (EOD .AND. (INEXT.GT.1)) THEN
	    WRITE(IUNIT,ERR=970,REC=NEXT_REC)(IWORK(I),I=1,INEXT-1)
            NEXT_REC = NEXT_REC + 1
	    INEXT = 1
	    DO I = 1, BLOCKSIZE
		IWORK(I) = 0
	    ENDDO
	ENDIF
	RETURN
 970    IERROR=1
	CALL FERROR_ADD('WRITE_DATA', ' ', ' ')
	RETURN
	END
C
	SUBROUTINE G2_INT_COMPAT(CH_OF_YMIN, CH_OF_YMAX, INST_CODE,
     1				 INST_STR, XMN, XMX, YMN, YMX,
     2				 INST_NAME, XARRAY, YARRAY, NPT)
	IMPLICIT NONE
	INTEGER*4 CH_OF_YMIN, INST_CODE, I, NPT
	INTEGER*4 CH_OF_YMAX
	INTEGER*4 INST_STR
	CHARACTER*8 INST_NAME
	REAL*4 XMN, XMX, YMN, YMX, XARRAY(NPT+1), YARRAY(NPT)
C
	INST_CODE = 10  ! dunno, but does this in G2 load command
	INST_STR = 7	! means file source in G2
C
	XMN = XARRAY(1)
	XMX = XARRAY(NPT+1)
C
	YMN = YARRAY(1)
	YMX = YARRAY(1)
	CH_OF_YMIN = 1
	CH_OF_YMAX = 1
	DO I = 2, NPT
	    IF (YARRAY(I) .GT. YMX) THEN
		YMX = YARRAY(I)
		CH_OF_YMAX = I
	    ENDIF
	    IF (YARRAY(I) .LT. YMN) THEN
		YMN = YARRAY(I)
		CH_OF_YMIN = I
	    ENDIF
	ENDDO
C
	RETURN
	END
C
        SUBROUTINE REMOVE_FILE(FILE)
	IMPLICIT NONE
	CHARACTER*(*) FILE
	INTEGER*4 IFILE(129)
	CALL REPLACE_STRING(FILE, LEN(FILE), IFILE)
	CALL TRUNCATE_FILE(IFILE)	
	RETURN
	END
C
