C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C
C   XEDRIV subroutine is part of the xedriver. It cannot be used without
C   the MOTIFDRIVER.C source code.
C   Any call that does not require specific information to be returned
C   is dealt with here.
C
C   Callout to C is only done if required.
C   There are also two functions to encode and decode strings
C   for passing to C, they will work on any OS that supports
C   the ASCII character set.
C
	SUBROUTINE XEDRIV(IFUNC, RBUF, NBUF, CHR, LCHR)

	IMPLICIT	NONE
	INTEGER 	IFUNC
	INTEGER		NBUF
	INTEGER		LCHR
	REAL		RBUF(*)
	CHARACTER*(*)	CHR
	CHARACTER*512	RETCHR
	CHARACTER*512	CVT_C_TO_F

	INTEGER		INTARR(20)
	INTEGER		STRING(512)

C
C **** ONLY go out to C if required
C
C (string not encoded if not required)
C (IFUNC = 2,3,6

	IF (IFUNC.NE.1.AND.IFUNC.NE.4.AND.IFUNC.NE.5.
     +		      AND.IFUNC.NE.7) THEN

C *** copy to an integer array
		INTARR(1) = IFUNC
		INTARR(2) = NBUF
		INTARR(3) = LCHR

		CALL NEWXEDRIVER(INTARR,RBUF, STRING(2))

C *** copy back from integer array
		NBUF = INTARR(2)
		LCHR = INTARR(3)
	
c *** decode string if required
		IF (IFUNC.EQ.17) THEN
		    RETCHR = CVT_C_TO_F(STRING)
		    CHR = RETCHR
		ENDIF
		RETURN

C 1
	ELSEIF (IFUNC.EQ.1) THEN
	    CHR = 'XWINDOW (Xwindow display)'
	    LCHR = 25
	    RETURN
C 4
	ELSEIF (IFUNC.EQ.4) THEN
	    CHR = 'ICNANRPNNN'
	    LCHR = 10
	    RETURN
C 5
	ELSEIF (IFUNC.EQ.5) THEN
	    CHR = 'PGPLOT'
	    LCHR = 6
	    RETURN
C 7
	ELSE 
	    RBUF(1) = 1.0
	    NBUF = 1
	ENDIF

	RETURN
	END
C
C =======================================================
C
	SUBROUTINE CVT_F_TO_C(STRING,ILEN,ISTR)
C *** character string STRING of length ILEN
C *** pack into integers in ISTR with a \0 terminator
	IMPLICIT NONE
	BYTE B(4)
	CHARACTER*(*) STRING
	INTEGER*4 I,II,I1,I2,J,IB,ISTR(*),ILEN,ILENT
	EQUIVALENCE (IB,B(1))
C
C *** determine real end of string ***
C
	ILENT=ILEN
 10	IF (STRING(ILENT:ILENT) .EQ. ' ') THEN
	   ILENT=ILENT-1
	   IF (ILENT .GT. 0) GOTO 10
	ENDIF
c	ISTR(1) = ILENT
	I1=ILENT/4
	I2=MOD(ILENT,4)
C
C *** pack four string characters into each integer
C
	DO I=1,I1
	   II=4*(I-1)
	   DO J=1,4
	      B(J)=ICHAR(STRING(II+J:II+J))
	   ENDDO
	   ISTR(I)=IB
	ENDDO
C
C *** finish off string and then \0 terminate ***
C
	DO J=1,4
	   B(J)=0
	ENDDO
	II=4*I1
	DO J=1,I2
	   B(J)=ICHAR(STRING(II+J:II+J))
	ENDDO
	ISTR(I1+1)=IB
	RETURN
	END
c----------------------------------------------------------------------------
c function
c DESCRIPTION: This routine extracts the string up to the given length

	CHARACTER*512 FUNCTION CVT_C_TO_F( STRING)

	IMPLICIT NONE
	BYTE STRING(*)
	INTEGER I

	CVT_C_TO_F = ' '	
	I = 1

10	IF (STRING(I+4).EQ.0) GOTO 20
	CVT_C_TO_F(I:I) = char(STRING(I+4))
	I = I + 1
	GOTO 10

20	END
