/*  Open GENIE, a program for neutron scattering data analysis & display
    ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
    Copyright (C) 1996,1997

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*  A Bison parser, made from yacccommands.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	OR	258
#define	AND	259
#define	PROCEDURE	260
#define	ENDPROCEDURE	261
#define	PARAMETERS	262
#define	FORWARD	263
#define	QUALIFIERS	264
#define	RESULT	265
#define	GLOBAL	266
#define	LOCAL	267
#define	LOOP	268
#define	FROM	269
#define	TO	270
#define	STEP	271
#define	RETURN	272
#define	ENDLOOP	273
#define	EXITIF	274
#define	CASE	275
#define	IS	276
#define	ENDCASE	277
#define	OTHERWISE	278
#define	IF	279
#define	ELSEIF	280
#define	ELSE	281
#define	ENDIF	282
#define	IDENTIFIER	283
#define	UINTEGER	284
#define	UREAL	285
#define	STRING	286
#define	COMMENT	287
#define	ENDCODE	288
#define	CODELINE	289
#define	ALIAS	290
#define	NOTEQUALS	291
#define	GEQUAL	292
#define	LEQUAL	293
#define	ENDOFLINE	294
#define	UPLUS	295
#define	UMINUS	296
#define	NOT	297
#define	RUBBISH	298

#line 1 "yacccommands.y"

#include <assert.h>
#include <stdarg.h>
#include "geniedefs.h"

#ifdef HAVE_ALLOCA_H		/* defined in config.h, which is included by geniedefs.h */
#include <alloca.h>
#endif /* HAVE_ALLOCA_H */

#ifdef _WIN32		/* defined in config.h, which is included by geniedefs.h */
#	include <malloc.h>
#endif /* HAVE_ALLOCA_H */

#include "parse_funcs.h"

static const char* rcsid = "@(#)$Id: yacccommands.c,v 1.61 1998/10/21 16:42:46 cmm Exp $";
USE_RCSID(rcsid);

/*

This is the GENIE-V3 parser
===========================

This file is pre-processed by yacc before compilation in C. This does mean that pure
C code and yacc syntax are hopelessly intermingled !  Any code delimited by %{ ... %}
is straight C which will pass unchanged into the yacc output.  As such it may contain
references to things produced by yacc.


===========================
Preamble and functions in C
===========================*/

#define INSIDE_PARSER__

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include "parsedefs.h"
#include "stmacros.h"		/* Macros containing bits of smalltalk code for parser (kept separate for tidyness) */

#ifndef __VMS				/* These don't work in POSIX 2.0 Yacc */
#undef YYDEBUG
#define YYDEBUG 1
extern int yydebug;			/* debug flag for YACC */
#endif


/*
    Definition of parse tree nodes and related functions.
    Note: This is not a comprehensive semantic parse tree,
    just a temporary represenatation of the translated GCL
    code as a tree of strings (to avoid copying).
*/
static node *get_node(void);

/*
 *  allocate storage for common variables defined in parsedefs.h
 *  see parsedefs.h for description
 */
int errors_found = 0;
int lines_parsed = 0;
int continuation_line = 0;
int auto_declare = 0;
int g_bUsingFile = 0;

/* Keep a list of parser nodes to ease garbage collection */
#define     OLD_NODES_MAX 100000   /* Number of old nodes recorded by nprintf */
static int  old_node_count = 0;
static node old_nodes[OLD_NODES_MAX];

int malloc_count = 0;

static node *addNode(node *original, node *newnode)
{
    assert(Valid(newnode));     /* original node can be null (to start a tree) but not the new list */
    assert(Valid(original) || !original);    /* Avoid half nodes of any sort */

    if (Valid(original))
    {
        original->next->side = addNode(original->next->side, newnode);
        return original;
    }
    else
        return newnode;        
}

/*#define addNode(a,b) ( (__LINE__>73)?(gprintif("%d ",__LINE__), addNode((a),(b)) ):addNode((a),(b)) )*/

node *newLeaf(const char* value)
{
    node *tmp;

    /* Allocate a node from the nodelist */
    tmp = get_node();

    tmp->next = (snode) malloc(sizeof(struct snode_struct));
    malloc_count++;
    tmp->next->side = NULL;   /* Leave this until another leaf is added by addNode */
    tmp->next->leaf = (char *) malloc(strlen(value)+1);
    malloc_count++;
    strcpy(tmp->next->leaf, value);
    tmp->valid = 1;                 /* This node is now allocated properly */

    return tmp;
}


void deleteNode(node *pnode)
{
    if (Valid(pnode))
    {
        /* Delete any nodes on the side chain */
        deleteNode( pnode->next->side );

        /* Delete leaf */
        free(pnode->next->leaf);
	    malloc_count--;
        pnode->next->leaf = NULL;

        /* Free up storage held by this node */
        free(pnode->next);
            malloc_count--;
	pnode->next = NULL;

        pnode->valid = 0;
    }
}


int nlength(node *pnode)
{
    if (Valid(pnode))
	    return strlen(pnode->next->leaf) + nlength(pnode->next->side);
    return 0;
}


static void prnNode(char *buffer, node *anode)
{
    if (Valid(anode))
    {
        strcat(buffer, anode->next->leaf);
        prnNode(buffer, anode->next->side);
    }
}


void printNode(char *buffer, node *anode)
{
    buffer[0] = '\0';
    prnNode(buffer, anode);
}


static void debugNode(node *anode)
{
    if (Valid(anode))
    {
        gprintdf(anode->next->leaf);
        debugNode(anode->next->side);
    }
    else
        gprintdf("(NULL)");
}


static node *copyNode(node *anode)
{
    node *tmp = NULL;

    if (Valid(anode))
    {
        tmp = newLeaf(anode->next->leaf);
        if ( Valid(anode->next->side) )
            addNode(tmp, copyNode(anode->next->side));
    }

    return tmp;
}

/*
 * Returns a pointer to an allcated node slot
 */

/* just out here for inspection */
static int i_max;

static node *get_node(void)
{
    node *result = NULL;

    if (old_node_count < OLD_NODES_MAX - 1)
    {
        /* Scan to the first free slot */
        for ( i_max=0; (i_max <= old_node_count) && old_nodes[i_max].valid; i_max++ );

        /* Now fill a used slot or create a new one depending on the result */
        if ( i_max > old_node_count )
            result = &old_nodes[++old_node_count];
        else
            result = &old_nodes[i_max];

        *result = NULL_NODE;
    }
    else
    {
        gprintef("Save aside list length for nodes exceeded,\n");
        gprintif("  Suggestion: increase OLD_NODES_MAX in parser)\n");
        exit(1);
    }

    return result;
}
        

/* Deletes any nodes left allocated to ensure memory security */
void sweep_nodes()
{
    int i;

    if (i_max > 1)
        gprintdf("Swept %d nodes\n", i_max);
    for ( i=0; i < old_node_count; i++)
        if (old_nodes[i].valid)
            deleteNode(&old_nodes[i]);
    old_node_count = 0;
}


/*
    nprintf
    =======
    Used like sprintf but nprintf constructs a parse tree made out of
    strings.  This avoids the massive duplication which occurs if the
    whole parse tree is created with sprintf (as it was before!)

    Calling nprintf with NULL instead of a format string is a special case
    which deletes the last n nodes (in reverse order). This is to allow
    a parser clean up of otherwise difficult to find nodes !

*/

void nprintf(node **result, const char* fmt, ...)
{
    static va_list	args, ap;
    static char    *s, fmtbuff[MAXSTRLEN];
    static const char *fp;
    static char    formtmp[MAXSTRLEN];

    fmtbuff[0] = formtmp[0] = '\0';
    va_start(args, fmt);

    *result = newLeaf("");        /* Just allocate a node */

    for (s = fmtbuff, fp = fmt, ap=args; fp && *fp; fp++)
    {
        if (*fp == '%')
        {
            fp++;
            switch (*fp)
            {
                case 'n':
                    *s = '\0';
                    vsprintf(formtmp, fmtbuff, ap);
                    *result = addNode(addNode(*result,newLeaf(formtmp)), va_arg(args, node*));
                    s = fmtbuff;    /* Reset for next part of format string */
                    ap = args;      /* Keep last position in args */
              	    break;

                default:
                    va_arg(args, void*);
                case '%':
                    *s++ = '%';
                    *s++ = *fp;
            }
        }
        else
            *s++ = *fp;
    }

    if ( s != fmtbuff )     /* if last thing in format was a %n there is nothing else to add */
    {
        *s = '\0';
        vsprintf(formtmp, fmtbuff, ap);
        *result = addNode(*result, newLeaf(formtmp));
    }
    va_end(args);

}

/*
Including the line below is a very NATTY DEBUGGING TECHNIQUE for the parser. In the event of
a parser crash, there is usually no sensible debugging information for the yacc actions.  This
prints out the position of all nprintfs up to the last one before the crash to show which
line number was the one which actually caused the explosion!
*/

/* #define nprintf (gprintdf("%d ", (long) __LINE__), &nprintf) */


/*
	Variables holding extra information about parser state
	======================================================
	(Organized under the appropriate syntactic constructs)
*/

/* File to take output of parser instrumentation if switched on */
FILE* g_fpTypeFile;

/*
 * General variables
 * ====================
 */


/* Some temporaries for assembling generated code into */

node *parseTree = NULL, *tmp1_tree = NULL, *tmp2_tree = NULL;

#define BUFFERLEN	MAXSTRLEN*2
char buffer1[BUFFERLEN];
char buffer2[BUFFERLEN];
char buffer3[BUFFERLEN];


/*
Procedure definition
--------------------
The syntactic construct for a procedure cannot be used recursively (ie, procedures cannot be defined
within procedures). The main use of temporary storage is to keep a track on information made available
early on in the procedure but used later or in several places in the code generation.
*/

enum	{ Local, Global, Result } Current_line_type ;	/* For recording the type of declaration line being parsed
							   (some of the code is common to all types) */

char	Current_procedure[MAXVARLEN];			/* The name of the procedure being parsed
							   - heavily used */

node	*Current_initializer;			/* Hold the body of a smalltalk method to initialize all local 
							   and global variables at the invocation of a procedure. This
							   is built incrementally throughout the declaration block */

char	Current_result[MAXVARLEN];			/* Holds the result returning string for a function method */


/* The following syntactic structures can be textually nested so some simple stacking macros are provided to make recording
   of control lvalues a little safer. */

/* for integers*/
#define PPUSH(stack, sp)	if ( sp < MAXNEST-1 ) stack[++sp] = 1; else \
	gprintef("parser: Attempted Pstack overflow\n");
#define PPOP(stack, sp)		if (sp > -1) stack[sp--] = 0; else \
	gprintef("parser: Attempted Pstack underflow\n");
#define PTOP(stack, sp)		stack[sp]

/* for strings */
#define SSPUSH(stack, sp)	if ( sp < MAXNEST-1 ) stack[++sp] = NULL; else \
	gprintef("parser: Attempted Sstack overflow\n");
#define SSPOP(stack, sp)	if (sp > -1) deleteNode(stack[sp--]); else \
	gprintef("parser: Attempted Sstack underflow\n");
#define SSTOP(stack, sp)	copyNode(stack[sp])


/*
Function invocation (Keyword, function or method syntax)
--------------------------------------------------------
Hold count of anonymous parameters found on a command line ie p1, p2..., pn
use a simple stack to allow saving of default paramter name counts when several
functions are used on one line (ie, when the syntax is used recursively).
*/

int Function_depth = -1;		/* Becomes 0 on entry to the first keyword or function */
int Param_no[MAXNEST];			/* Saves n for the p`nth' parameter */


/*
LOOP construct
--------------
This construct may also be used recursively which means we have to keep a record of nesting depth and also
record variables for inner and outer loops simultaneously.
*/

int Loop_depth = -1;			/* depth becomes 0 on entry into the first textual loop */
node *Loop_lvalue[MAXNEST];	    /* Holds the name of the loop control variable (it is an lvalue) */


/*
CASE construct
--------------
This construct may also be used recursively which means we have to keep a record of nesting depth and also
record variables for inner and outer case statements simultaneously.
*/

int Case_depth = -1;			/* depth becomes 0 on entry into the first textual loop */
node *Case_lvalue[MAXNEST];	    /* Holds the name of the case testing variable (it is an lvalue) */


/*
IF construct
--------------
This construct may also be used recursively which means we have to keep a record of nesting depth.
*/

int If_depth = -1;			/* depth becomes 0 on entry into the first textual IF */


/*
Arrays & structures
-------------------
Counter to give number of array index in multidimensional arrays (not a recursive construct)
*/

int Array_index_depth = -1;			/* Becomes 0 on entry to the first array index */
int Array_index_no[MAXNEST];

int method_flag;				/* Differentiates stucture references and method calls */
int structure_flag, keep_structure_flag;	/* flags whether the last l-value parsed was a structure or variable */
char	structure_name[MAXVARLEN],		/* keeps the name of the structure variable */
	keep_structure_name[MAXVARLEN];

/*
Passthru code blocks
---------------------
Section of escaped smalltalk code embedded into GCL (as with lots of startup files).
*/
int in_smalltalk = 0;


/*============== FUNCTIONS  ================*/



/*
 * Initializes static parser variables before initatiating a parse cycle
 */
void initialize_parser(int bUsingFile, int ydebflag)
{

/*    malloc_count = 0;       /* For debugging */

/*  Small test of tree builder (nprintf) + output */
#if 0
    node n,n1,n2;

    malloc_count = 0;
    nprintf(&n1, "Test%dnew", 34L);
    nprintf(&n, "Surr%nounded", n1);
    n2 = copyNode(n);
/*    gprintdf("malloc_count(A) = %d\n", malloc_count); */
    deleteNode(&n);
    nprintf(&n1, "Test%dnew", 34L);
    nprintf(&n, "Surr%noun%nded", n2, n1);
    debugNode(n);
    deleteNode(&n);
/*    gprintdf("\nmalloc_count(B) = %d\n", malloc_count); */
    malloc_count = 0;

#endif

#if 0
    node s, s1, s2, s3, s4, s5;
    malloc_count = 0;
    nprintf(&s2, "123%d456", 9999L, "asdf", 5.69, 1L, 2L, 3L, 4L, 5L);
    nprintf(&s5, "OOOOOO%sOOOOOOhhh!!!", "o");
    nprintf(&s4, "This is just a sub-leafy bit");
    nprintf(&s3, "12%n3%d456%n", s4, 9999L, s5, "asdf", 5.69, 1L, 2L, 3L, 4L, 5L);
    nprintf(&s1, "%d=%n=%f=(%n)", 1111L, s2, 45.88, s3);
    gprintdf("\ns1=");
    debugNode(s1);
    gprintdf("\nD=%d", nlength(&s1));
    s = copyNode(s1);
    deleteNode(&s1);

    gprintdf("\nWhat's left=");
    debugNode(s1);
    gprintdf("\nD=%d", nlength(&s1));
    gprintdf("\nCopied node=");
    debugNode(s);
    gprintdf("\nD=%d", nlength(&s));
    deleteNode(&s);
    gprintdf("\nWhat's left (of s)=");
    debugNode(s);
    gprintdf("\nD=%d", nlength(&s));
    gprintdf("\n");
    gprintdf("malloc_count(A) = %d\n", malloc_count);
#endif

/*
===Output===
s1=1111=1239999456=45.880000=(12This is just a sub-leafy bit39999456OOOOOOoOOOOOOhhh!!!)(NULL)
D=85
What's left=(NULL)
D=0
Copied node=1111=1239999456=45.880000=(12This is just a sub-leafy bit39999456OOOOOOoOOOOOOhhh!!!)(NULL)
D=85
What's left (of s)=(NULL)
D=0
malloc_count(A) = 0
============
*/


/* Initialize local variables */

    Current_initializer = newLeaf("");                               /* Start with an empty leaf */
    strcpy(Current_result, ".\nself up.\n^nil");
    strcpy(Current_procedure, "  <No current procedure>");

    Function_depth	= -1;
    Loop_depth		= -1;		/* Static variables in the parser */
    Case_depth		= -1;
    If_depth		= -1;
    Array_index_depth	= -1;

    in_smalltalk        = 0;            /* Flags that we are in a smalltalk code block */

    g_bUsingFile = bUsingFile;          /* Set global variable */

#ifndef __VMS				/* Doesn't work in POSIX 2.0 yacc */
    yydebug = ydebflag;
#endif

/*    gprintdf("malloc_count(A) = %d\n", malloc_count); */

    PPUSH(Param_no, Function_depth);	/* Almost part of the parsing but easier to do here */
    return;
}



void initialize_parser_stats()
{
    lines_parsed = 0;
    errors_found = 0;
    return;
}


void p_stats()
{
    gprintdf("nodes used = %d, allocated now = %d", old_node_count, i_max);
}


/*
 * To return parser output to the calling program
 */
node *interrogate_parser(int *errcnt, int *linecnt)
{
    *linecnt = lines_parsed;
    *errcnt = errors_found;	
    if (nlength(Current_initializer) == 0)
        deleteNode(Current_initializer);

    return parseTree;
}



/*
 * Store some sentinel values in the buffers to check for overflow later
 */
void fill_buffers()
{
    int i;

    for( i=0; i < BUFFERLEN; i++)
    {
	buffer1[i] = '~';
	buffer2[i] = '~';
	buffer3[i] = '~';
    }

    return;
}



/*
 * Sort out whether to use a prompt or not
 */
int prompt_mode()
{
    return !g_bUsingFile && !continuation_line &&
	(Current_procedure[0] == ' ') &&
	(Loop_depth == -1) &&
	(Case_depth == -1) &&
	(If_depth == -1) &&
	! in_smalltalk ;
}



/*
 * Count backwards to find the smallest free space left in a buffer after parsing
 */
int check_buffers()
{
    int i;

    for( i = BUFFERLEN - 1; i >= 0; i-- )
    {
    	if( buffer1[i] != '~') break;
    	if( buffer2[i] != '~') break;
    	if( buffer3[i] != '~') break;
    }
 
    return BUFFERLEN - (i + 1);
}



/* Action routine for debugging parser syntax */

static void Paction(char x[]) {
    gprintdf("%s\n", x);
}


/* replaces "+" signs where smalltalk doesn't like them */

static void ReplacePlusSigns( char Astring[] ){
    char *p;
    for( p=Astring; (p=strchr(p, '+')); *p++='0' );	/* Replaces any '+' characters in the string with a '0' */
    return;
}


/* Only define an executable Paction if in Parser debugging mode */

#ifdef _DEB_
/*#define PACTION(a,b,c,d,e,f) Paction(a,b,c,d,e,f);break;*/
#define LHS(x) x
#define RHS(x) x
#else

#if 0
#define PACTION(a,b,c,d,e,f) Paction(e);
#else
#define PACTION(a,b,c,d,e,f)
#endif

#define LHS(x) x.lhs
#define RHS(x) x.rhs
#endif

/* End C preamble */

#line 664 "yacccommands.y"
typedef union {					/* Declare returned value type */
    node        *nonterminal;
	int		    aninteger;
	double		areal;
	char		astring[MAXSTRLEN];
	char		terminal[MAXSTRLEN];
/*	char		nonterminal[MAXSTRLEN]; */

	char		debugging_string[MAXSTRLEN];

	struct
	{				/* define a structure for holding both halves of a split expression */
	    node *lhs;
	    node *rhs;
	} split_exp;

} YYSTYPE;
#line 685 "yacccommands.y"

#ifdef _DEB_
#define aninteger   debugging_string
#define areal	    debugging_string
#define astring	    debugging_string
#define terminal    debugging_string
#define nonterminal debugging_string
#define split_exp   debugging_string
#endif

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		285
#define	YYFLAG		-32768
#define	YYNTBASE	63

#define YYTRANSLATE(x) ((unsigned)(x) <= 298 ? yytranslate[x] : 138)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    54,    46,     2,    55,
    56,    48,    47,    59,    43,    57,    49,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    58,     2,    51,
    53,    52,     2,    61,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    60,     2,    44,    45,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    50,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    62
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     7,    10,    14,    18,    23,    26,
    28,    30,    33,    36,    38,    40,    42,    44,    47,    50,
    52,    54,    56,    59,    62,    64,    68,    73,    77,    80,
    83,    85,    88,    89,    94,    97,   101,   104,   107,   110,
   115,   120,   124,   129,   133,   136,   139,   141,   144,   146,
   149,   151,   155,   158,   162,   165,   167,   171,   174,   177,
   180,   184,   189,   193,   195,   198,   200,   203,   205,   206,
   210,   213,   214,   218,   221,   224,   227,   229,   231,   234,
   238,   241,   244,   248,   252,   253,   258,   259,   264,   265,
   270,   273,   276,   279,   284,   286,   288,   290,   292,   296,
   299,   301,   304,   305,   310,   311,   316,   320,   324,   328,
   332,   336,   340,   344,   348,   352,   356,   360,   364,   368,
   372,   376,   380,   384,   388,   390,   393,   396,   399,   404,
   406,   408,   410,   412,   416,   421,   424,   428,   431,   435,
   438,   442,   445,   449,   450,   451,   457,   459,   463,   465,
   468,   469,   473,   474,   479,   481,   484,   488,   490,   492,
   495,   499,   501,   503,   506,   510,   512,   515,   517,   519,
   522,   524,   527,   530,   533,   534,   539,   541
};

static const short yyrhs[] = {    64,
     0,   109,     0,   110,     0,     0,    99,   100,     0,    99,
    70,   100,     0,    99,    65,   100,     0,    99,    65,    70,
   100,     0,    66,    68,     0,    68,     0,    66,     0,    66,
    67,     0,    66,   110,     0,    67,     0,   101,     0,   102,
     0,   103,     0,    68,    69,     0,    68,   110,     0,    69,
     0,   105,     0,   107,     0,    70,   109,     0,    70,   110,
     0,   109,     0,    73,    70,    76,     0,    73,    70,    72,
    76,     0,    73,    72,    76,     0,    73,    76,     0,    75,
    70,     0,    75,     0,    13,   110,     0,     0,    13,    74,
    77,   110,     0,    73,   110,     0,    19,   114,   110,     0,
    75,   110,     0,    18,   110,     0,   132,    78,     0,   132,
    78,    16,   114,     0,    14,   114,    15,   114,     0,    83,
    80,    87,     0,    83,    80,    81,    87,     0,    83,    81,
    87,     0,    83,    87,     0,    80,    82,     0,    82,     0,
    86,    70,     0,    86,     0,    84,    70,     0,    84,     0,
    20,   114,   110,     0,    83,   110,     0,    21,    85,   110,
     0,    84,   110,     0,   114,     0,   114,    15,   114,     0,
    23,   110,     0,    86,   110,     0,    22,   110,     0,    24,
    89,    96,     0,    24,    89,    90,    96,     0,    89,    25,
    91,     0,    91,     0,    94,    70,     0,    94,     0,    92,
    70,     0,    92,     0,     0,   114,    93,   110,     0,    92,
   110,     0,     0,    26,    95,   110,     0,    94,   110,     0,
    27,   110,     0,    98,    33,     0,    33,     0,    34,     0,
    98,    34,     0,     5,    28,   110,     0,    99,   110,     0,
     6,   110,     0,     7,   128,   110,     0,     9,   118,   110,
     0,     0,    10,   104,   131,   110,     0,     0,    12,   106,
   130,   110,     0,     0,    11,   108,   130,   110,     0,     1,
   110,     0,   111,   110,     0,   123,   110,     0,    60,   114,
    44,   110,     0,    71,     0,    79,     0,    88,     0,    97,
     0,     8,    28,   110,     0,    17,   110,     0,    39,     0,
    32,    39,     0,     0,   132,   112,    53,   114,     0,     0,
   132,   113,    35,   114,     0,   114,    52,   114,     0,   114,
    51,   114,     0,   114,    53,   114,     0,   114,    37,   114,
     0,   114,    38,   114,     0,   114,    36,   114,     0,   114,
    46,   114,     0,   114,     3,   114,     0,   114,    47,   114,
     0,   114,    43,   114,     0,   114,     4,   114,     0,   114,
    48,   114,     0,   114,    49,   114,     0,   114,    50,   114,
     0,   114,    45,   114,     0,   114,    58,   114,     0,   114,
    61,   114,     0,    55,   114,    56,     0,   115,     0,    42,
   114,     0,    40,   114,     0,    41,   114,     0,    55,   114,
    56,   133,     0,    29,     0,    30,     0,    31,     0,   132,
     0,    28,    55,    56,     0,    28,   116,    55,    56,     0,
    28,   119,     0,    28,   116,   119,     0,    58,    28,     0,
   116,    58,    28,     0,    49,    28,     0,   117,    49,    28,
     0,    49,    28,     0,   118,    49,    28,     0,     0,     0,
    55,   120,   122,   121,    56,     0,   127,     0,   122,    59,
   127,     0,    28,     0,    28,   117,     0,     0,    28,   124,
   126,     0,     0,    28,   117,   125,   126,     0,   127,     0,
   126,   127,     0,    28,    53,   114,     0,   114,     0,   129,
     0,   128,   129,     0,    28,    53,    28,     0,    28,     0,
   131,     0,   130,   131,     0,    28,    53,   114,     0,    28,
     0,    28,   133,     0,    28,     0,   135,     0,   133,   135,
     0,   134,     0,   133,   134,     0,    57,   115,     0,    57,
    28,     0,     0,    60,   136,   137,    44,     0,   114,     0,
   137,    59,   114,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   764,   770,   776,   782,   795,   803,   810,   818,   829,   842,
   857,   872,   877,   882,   888,   893,   898,   904,   909,   914,
   920,   925,   931,   937,   942,   956,   965,   973,   981,   991,
   996,  1002,  1009,  1009,  1014,  1020,  1026,  1032,  1038,  1045,
  1054,  1063,  1069,  1075,  1081,  1088,  1093,  1099,  1104,  1110,
  1115,  1121,  1130,  1137,  1142,  1148,  1153,  1160,  1165,  1171,
  1180,  1185,  1191,  1197,  1204,  1210,  1217,  1224,  1232,  1233,
  1237,  1243,  1244,  1248,  1254,  1262,  1268,  1275,  1282,  1296,
  1307,  1313,  1321,  1327,  1333,  1333,  1339,  1339,  1345,  1345,
  1351,  1358,  1363,  1368,  1373,  1378,  1383,  1388,  1393,  1404,
  1417,  1423,  1436,  1436,  1456,  1456,  1477,  1482,  1487,  1492,
  1497,  1502,  1507,  1512,  1517,  1522,  1527,  1532,  1537,  1542,
  1547,  1552,  1557,  1562,  1567,  1572,  1577,  1582,  1587,  1597,
  1602,  1609,  1614,  1622,  1629,  1636,  1643,  1651,  1670,  1678,
  1685,  1693,  1707,  1722,  1722,  1723,  1728,  1733,  1739,  1746,
  1753,  1754,  1761,  1762,  1771,  1776,  1783,  1790,  1797,  1802,
  1808,  1827,  1846,  1851,  1857,  1880,  1904,  1919,  1929,  1934,
  1941,  1946,  1954,  1962,  1973,  1973,  1987,  1997
};

static const char * const yytname[] = {   "$","error","$illegal.","OR","AND",
"PROCEDURE","ENDPROCEDURE","PARAMETERS","FORWARD","QUALIFIERS","RESULT","GLOBAL",
"LOCAL","LOOP","FROM","TO","STEP","RETURN","ENDLOOP","EXITIF","CASE","IS","ENDCASE",
"OTHERWISE","IF","ELSEIF","ELSE","ENDIF","IDENTIFIER","UINTEGER","UREAL","STRING",
"COMMENT","ENDCODE","CODELINE","ALIAS","NOTEQUALS","GEQUAL","LEQUAL","ENDOFLINE",
"UPLUS","UMINUS","NOT","'-'","']'","'^'","'&'","'+'","'*'","'/'","'|'","'<'",
"'>'","'='","'%'","'('","')'","'.'","':'","','","'['","'@'","RUBBISH","program_unit",
"procedure","proc_top_block","proc_header","header_line","proc_decl","decl_line",
"block","loop_construct","exit_control","loop_line","@1","exitif_line","endloop_line",
"count_control","loop_range","case_construct","alternatives","otherwise_part",
"test_clause","case_line","is_line","case_range","otherwise_line","endcase_line",
"if_construct","elif_part","else_part","cond_block","expr_line","@2","else_line",
"@3","endif_line","code_block","code","proc_line","end_proc_line","param_line",
"qual_line","result_line","@4","local_line","@5","global_line","@6","command_line",
"end_of_line","assignment","@7","@8","expression","function_call","qual_list1",
"qual_list2","qual_defs","arguments","@9","@10","arg_list","keyword","@11","@12",
"fp_list","function_parameter","fp_defs","type_specifier","var_defs","variable_declarator",
"lvalue","struct_spec","method_ref","index_ref","@13","array_index",""
};
#endif

static const short yyr1[] = {     0,
    63,    63,    63,    63,    64,    64,    64,    64,    65,    65,
    65,    66,    66,    66,    67,    67,    67,    68,    68,    68,
    69,    69,    70,    70,    70,    71,    71,    71,    71,    72,
    72,    73,    74,    73,    73,    75,    75,    76,    77,    77,
    78,    79,    79,    79,    79,    80,    80,    81,    81,    82,
    82,    83,    83,    84,    84,    85,    85,    86,    86,    87,
    88,    88,    89,    89,    90,    90,    91,    91,    93,    92,
    92,    95,    94,    94,    96,    97,    97,    98,    98,    99,
    99,   100,   101,   102,   104,   103,   106,   105,   108,   107,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   110,   110,   112,   111,   113,   111,   114,   114,   114,   114,
   114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
   114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
   114,   114,   114,   115,   115,   115,   115,   116,   116,   117,
   117,   118,   118,   120,   121,   119,   122,   122,   123,   123,
   124,   123,   125,   123,   126,   126,   127,   127,   128,   128,
   129,   129,   130,   130,   131,   131,   132,   132,   133,   133,
   133,   133,   134,   134,   136,   135,   137,   137
};

static const short yyr2[] = {     0,
     1,     1,     1,     0,     2,     3,     3,     4,     2,     1,
     1,     2,     2,     1,     1,     1,     1,     2,     2,     1,
     1,     1,     2,     2,     1,     3,     4,     3,     2,     2,
     1,     2,     0,     4,     2,     3,     2,     2,     2,     4,
     4,     3,     4,     3,     2,     2,     1,     2,     1,     2,
     1,     3,     2,     3,     2,     1,     3,     2,     2,     2,
     3,     4,     3,     1,     2,     1,     2,     1,     0,     3,
     2,     0,     3,     2,     2,     2,     1,     1,     2,     3,
     2,     2,     3,     3,     0,     4,     0,     4,     0,     4,
     2,     2,     2,     4,     1,     1,     1,     1,     3,     2,
     1,     2,     0,     4,     0,     4,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     1,     2,     2,     2,     4,     1,
     1,     1,     1,     3,     4,     2,     3,     2,     3,     2,
     3,     2,     3,     0,     0,     5,     1,     3,     1,     2,
     0,     3,     0,     4,     1,     2,     3,     1,     1,     2,
     3,     1,     1,     2,     3,     1,     2,     1,     1,     2,
     1,     2,     2,     2,     0,     4,     1,     3
};

static const short yydefact[] = {     0,
     0,     0,     0,    33,     0,     0,     0,   151,     0,    77,
    78,   101,     0,     1,    95,     0,    96,     0,    97,    98,
     0,     0,     2,     3,     0,     0,   103,    91,     0,     0,
     0,    32,   100,   168,   130,   131,   132,     0,     0,     0,
     0,     0,   125,   133,     0,    64,     0,    69,     0,     0,
   175,   153,     0,   167,   171,   169,   102,     0,     0,     0,
     0,     0,     0,    29,    25,    35,     0,     0,     0,     0,
     0,    47,     0,     0,    45,    53,    76,    79,     0,     0,
     0,    85,    89,    87,     0,    11,    14,    10,    20,     0,
     5,    15,    16,    17,    21,    22,    81,    92,    93,     0,
     0,    80,    99,   168,     0,     0,   144,     0,     0,   136,
   127,   128,   126,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    52,     0,    72,     0,     0,     0,    61,     0,    71,
     0,   140,   174,   173,     0,     0,     0,   168,   158,   152,
   155,   172,   170,     0,    38,     0,     0,    26,    23,    24,
    28,     0,    37,     0,    56,    60,    58,     0,    46,    42,
    44,     0,    55,     0,    59,    82,   162,     0,   159,     0,
     0,     0,     0,     0,     0,     7,    12,     9,    13,    18,
    19,     6,     0,     0,    34,     0,    39,   134,     0,   138,
   144,     0,   137,   124,   114,   117,   112,   110,   111,   116,
   121,   113,   115,   118,   119,   120,   108,   107,   109,   122,
   123,    63,     0,    75,    62,     0,    74,    70,   177,     0,
   141,   154,     0,   156,    94,    36,    27,    54,     0,    43,
     0,    83,   160,   142,     0,    84,   166,     0,     0,   163,
     0,     8,   104,   106,     0,     0,   145,   147,   135,   139,
   129,    73,   176,     0,   157,    57,   161,   143,     0,    86,
    90,   164,    88,     0,    40,     0,     0,   178,   165,    41,
   148,   146,     0,     0,     0
};

static const short yydefgoto[] = {   283,
    14,    85,    86,    87,    88,    89,    61,    15,    62,    16,
    31,    63,    64,   105,   197,    17,    70,    71,    72,    18,
    73,   164,    74,    75,    19,    45,   136,    46,    47,   141,
   137,   223,   138,    20,    21,    22,    91,    92,    93,    94,
   182,    95,   184,    96,   183,    65,   160,    25,   100,   101,
   149,    43,   109,    52,   181,   110,   199,   277,   257,    26,
    53,   147,   150,   151,   178,   179,   249,   250,    44,    54,
    55,    56,   145,   230
};

static const short yypact[] = {   221,
    36,   -11,    -5,    36,    36,   346,   346,   280,   -24,-32768,
-32768,-32768,   346,-32768,-32768,   438,-32768,   185,-32768,-32768,
     9,   289,-32768,-32768,    36,    36,    21,-32768,    36,    36,
    30,-32768,-32768,    16,-32768,-32768,-32768,   346,   346,   346,
   346,   630,-32768,-32768,    72,-32768,   330,   782,    32,    42,
-32768,   -20,   619,   -13,-32768,-32768,-32768,   649,    36,   346,
   438,    64,   468,-32768,-32768,-32768,   346,    36,    36,    85,
    65,-32768,   372,   486,-32768,-32768,-32768,-32768,    36,    74,
    51,-32768,-32768,-32768,   141,   854,-32768,    13,-32768,   516,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    50,
    97,-32768,-32768,   -13,    36,   119,    80,   109,    23,-32768,
-32768,-32768,-32768,   686,   346,   346,   346,   346,   346,   346,
   346,   346,   346,   346,   346,   346,   346,   346,   346,   346,
   346,-32768,   346,-32768,    36,   113,   534,-32768,   390,-32768,
    36,-32768,    31,-32768,   346,   116,   619,   204,   782,   619,
-32768,-32768,-32768,    36,-32768,   630,    64,-32768,-32768,-32768,
-32768,   564,-32768,    36,   712,-32768,-32768,    65,-32768,-32768,
-32768,   420,-32768,   582,-32768,-32768,    88,    -1,-32768,   123,
   -19,   125,   125,   125,   516,-32768,-32768,    13,-32768,-32768,
-32768,-32768,   346,   346,-32768,   346,   146,-32768,   619,-32768,
   101,   135,-32768,   -13,    14,   121,   801,   801,   801,    14,
   121,    45,    14,   121,   121,   121,   801,   801,   801,   227,
   227,-32768,    36,-32768,-32768,   612,-32768,-32768,   782,   -23,
-32768,   619,   346,-32768,-32768,-32768,-32768,-32768,   346,-32768,
   136,-32768,-32768,-32768,   139,-32768,   117,    36,    18,-32768,
    18,-32768,   782,   782,   763,   346,   112,-32768,-32768,-32768,
   -13,-32768,-32768,   346,   782,   782,-32768,-32768,   346,-32768,
-32768,-32768,-32768,   346,   782,   619,   120,   782,   782,   782,
-32768,-32768,   179,   181,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,    96,    98,   -62,    -8,-32768,   131,-32768,
-32768,-32768,   -53,-32768,-32768,-32768,-32768,   124,   127,-32768,
-32768,-32768,-32768,   -30,-32768,-32768,-32768,    53,-32768,-32768,
-32768,-32768,    59,-32768,-32768,-32768,   -80,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    11,   130,-32768,-32768,-32768,
    -6,   150,-32768,-32768,-32768,    93,-32768,-32768,-32768,-32768,
-32768,-32768,    58,  -148,-32768,    34,    29,  -166,     6,    10,
   -51,   -50,-32768,-32768
};


#define	YYLAST		893


static const short yytable[] = {    42,
    48,   234,   152,   153,   186,    27,    58,   158,   161,   192,
    23,  -150,     9,    90,    57,   248,    29,   116,  -150,    12,
   263,    27,    30,    83,    84,   190,   177,    27,   146,   245,
     9,   111,   112,   113,   114,   264,   106,    12,   139,   170,
   171,    77,    78,    50,     9,   247,    51,   115,   116,     9,
   258,    12,    27,   156,   162,  -105,    12,   104,   121,   142,
   165,   124,   125,   126,   172,   174,    27,     9,    27,   143,
   107,   159,    50,   108,    12,    51,   185,   201,    27,    27,
   202,    59,   272,   234,   272,   107,    68,   120,   108,   121,
    27,   123,   124,   125,   126,    27,   133,   134,   135,   180,
   159,   177,   193,   237,   252,    67,    68,    69,   205,   206,
   207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
   217,   218,   219,   220,   221,   190,    48,   281,   226,    24,
    28,   194,   196,    32,    33,   198,   200,   240,   229,   135,
   241,     1,    27,   231,    27,    66,    79,    76,     3,   159,
   244,    97,   247,     4,    98,    99,   259,     5,   102,   103,
     6,   256,   260,   267,     7,   121,   268,    27,     8,   269,
   276,   132,   159,    10,    11,   282,   140,    27,   284,    27,
   285,   187,   159,   188,   159,   222,   253,   254,   155,   255,
    27,   157,   163,   168,   225,   159,   169,   166,   167,   144,
    13,   203,   173,   175,   232,    67,    68,    69,   176,   152,
   153,   243,   251,   261,     0,   189,     9,   191,     0,     0,
    -4,     1,     0,    12,     0,     2,   265,     0,     3,   115,
   116,    27,   266,     4,   195,     0,   159,     5,     0,     0,
     6,     0,     0,     0,     7,     0,     0,     0,     8,   275,
     0,     0,     9,    10,    11,     0,   233,   278,   107,    12,
    50,   108,   279,    51,   224,     0,   227,   280,     0,   120,
   228,   121,   122,   123,   124,   125,   126,     0,     0,     0,
    13,     0,     0,   235,     0,   236,     0,     0,     0,     1,
     0,     0,     0,   238,    79,    80,     3,    81,    82,    83,
    84,     4,     0,     0,     0,     5,     0,   242,     6,     0,
   246,  -149,     7,     0,  -168,     0,     8,   191,  -149,     0,
     9,    10,    11,     0,     0,     0,     0,    12,    49,     0,
     1,     0,  -168,     0,     0,     0,    50,     3,     0,    51,
     0,     0,     4,     0,     0,     0,     5,     0,    13,     6,
     0,     0,   262,     7,   -68,   -68,   -68,     8,     0,     0,
     0,     9,    10,    11,     0,     0,     0,     0,    12,     0,
     0,     0,     1,    34,    35,    36,    37,   270,   271,     3,
   273,     0,     0,     0,     4,    38,    39,    40,     5,    13,
     1,     6,   -51,   -51,   -51,     7,     0,     3,     0,     8,
    41,     0,     4,     9,    10,    11,     5,     0,     0,     6,
    12,     0,     0,     7,   -67,   -67,   -67,     8,     0,     0,
     1,     9,    10,    11,     0,     0,     0,     3,    12,     0,
     0,    13,     4,     0,     0,     0,     5,     0,     1,     6,
   -50,   -50,   -50,     7,     0,     3,     0,     8,     0,    13,
     4,     9,    10,    11,     5,    59,    60,     6,    12,     0,
     0,     7,     0,     0,     0,     8,     0,     0,     1,     9,
    10,    11,     0,     0,     0,     3,    12,     0,     0,    13,
     4,     0,     0,     0,     5,   -31,     1,     6,     0,     0,
     0,     7,     0,     3,     0,     8,     0,    13,     4,     9,
    10,    11,     5,     0,     0,     6,    12,   -49,     0,     7,
     0,     0,     0,     8,     0,     0,     1,     9,    10,    11,
     0,    79,     0,     3,    12,     0,     0,    13,     4,     0,
     0,     0,     5,     0,     1,     6,     0,     0,     0,     7,
     0,     3,     0,     8,     0,    13,     4,     9,    10,    11,
     5,     0,     0,     6,    12,     0,     0,     7,     0,     0,
   -66,     8,     0,     0,     1,     9,    10,    11,     0,     0,
     0,     3,    12,     0,     0,    13,     4,     0,     0,     0,
     5,   -30,     1,     6,     0,     0,     0,     7,     0,     3,
     0,     8,     0,    13,     4,     9,    10,    11,     5,     0,
     0,     6,    12,   -48,     0,     7,     0,     0,     0,     8,
     0,     0,     1,     9,    10,    11,     0,     0,     0,     3,
    12,     0,     0,    13,     4,     0,     0,     0,     5,     0,
     0,     6,   115,   116,     0,     7,     0,     0,   -65,     8,
     0,    13,     0,     9,    10,    11,   148,    35,    36,    37,
    12,   115,   116,     0,     0,     0,     0,     0,    38,    39,
    40,     9,     0,     0,     0,   117,   118,   119,    12,     0,
     0,    13,   120,    41,   121,   122,   123,   124,   125,   126,
   127,   128,   129,     0,   117,   118,   119,   130,   115,   116,
   131,   120,   154,   121,   122,   123,   124,   125,   126,   127,
   128,   129,     0,     0,     0,     0,   130,     0,     0,   131,
     0,     0,     0,     0,   115,   116,     0,     0,     0,     0,
     0,   117,   118,   119,     0,     0,   239,     0,   120,     0,
   121,   122,   123,   124,   125,   126,   127,   128,   129,     0,
     0,   204,     0,   130,     0,     0,   131,   117,   118,   119,
     0,     0,     0,     0,   120,     0,   121,   122,   123,   124,
   125,   126,   127,   128,   129,   115,   116,     0,     0,   130,
     0,     0,   131,     0,     0,     0,     0,   274,     0,     0,
     0,     0,     0,     0,   115,   116,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   117,   118,
   119,     0,     0,   115,   116,   120,     0,   121,   122,   123,
   124,   125,   126,   127,   128,   129,     0,   117,   118,   119,
   130,     0,     0,   131,   120,     0,   121,   122,   123,   124,
   125,   126,   127,   128,   129,     0,-32768,-32768,-32768,   130,
     0,     0,   131,   120,     0,   121,   122,   123,   124,   125,
   126,-32768,-32768,-32768,     0,     0,     0,     0,   130,     0,
    80,   131,    81,    82,    83,    84,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     9,     0,     0,     0,     0,
     0,     0,    12
};

static const short yycheck[] = {     6,
     7,   150,    54,    54,    85,     0,    13,    61,    62,    90,
     0,    32,    32,    22,    39,   182,    28,     4,    39,    39,
    44,    16,    28,    11,    12,    88,    28,    22,    49,    49,
    32,    38,    39,    40,    41,    59,    31,    39,    47,    70,
    71,    33,    34,    57,    32,    28,    60,     3,     4,    32,
   199,    39,    47,    60,    63,    35,    39,    28,    45,    28,
    67,    48,    49,    50,    73,    74,    61,    32,    63,    28,
    55,    61,    57,    58,    39,    60,    85,    55,    73,    74,
    58,    18,   249,   232,   251,    55,    22,    43,    58,    45,
    85,    47,    48,    49,    50,    90,    25,    26,    27,    49,
    90,    28,    53,   157,   185,    21,    22,    23,   115,   116,
   117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
   127,   128,   129,   130,   131,   188,   133,   276,   137,     0,
     1,    35,    14,     4,     5,    56,    28,   168,   145,    27,
    53,     1,   137,    28,   139,    16,     6,    18,     8,   139,
    28,    22,    28,    13,    25,    26,    56,    17,    29,    30,
    20,    16,    28,    28,    24,    45,    28,   162,    28,    53,
    59,    42,   162,    33,    34,    56,    47,   172,     0,   174,
     0,    86,   172,    86,   174,   133,   193,   194,    59,   196,
   185,    61,    63,    70,   136,   185,    70,    68,    69,    50,
    60,   109,    73,    74,   147,    21,    22,    23,    79,   261,
   261,   178,   184,   204,    -1,    86,    32,    88,    -1,    -1,
     0,     1,    -1,    39,    -1,     5,   233,    -1,     8,     3,
     4,   226,   239,    13,   105,    -1,   226,    17,    -1,    -1,
    20,    -1,    -1,    -1,    24,    -1,    -1,    -1,    28,   256,
    -1,    -1,    32,    33,    34,    -1,    53,   264,    55,    39,
    57,    58,   269,    60,   135,    -1,   137,   274,    -1,    43,
   141,    45,    46,    47,    48,    49,    50,    -1,    -1,    -1,
    60,    -1,    -1,   154,    -1,   156,    -1,    -1,    -1,     1,
    -1,    -1,    -1,   164,     6,     7,     8,     9,    10,    11,
    12,    13,    -1,    -1,    -1,    17,    -1,   178,    20,    -1,
   181,    32,    24,    -1,    35,    -1,    28,   188,    39,    -1,
    32,    33,    34,    -1,    -1,    -1,    -1,    39,    49,    -1,
     1,    -1,    53,    -1,    -1,    -1,    57,     8,    -1,    60,
    -1,    -1,    13,    -1,    -1,    -1,    17,    -1,    60,    20,
    -1,    -1,   223,    24,    25,    26,    27,    28,    -1,    -1,
    -1,    32,    33,    34,    -1,    -1,    -1,    -1,    39,    -1,
    -1,    -1,     1,    28,    29,    30,    31,   248,   249,     8,
   251,    -1,    -1,    -1,    13,    40,    41,    42,    17,    60,
     1,    20,    21,    22,    23,    24,    -1,     8,    -1,    28,
    55,    -1,    13,    32,    33,    34,    17,    -1,    -1,    20,
    39,    -1,    -1,    24,    25,    26,    27,    28,    -1,    -1,
     1,    32,    33,    34,    -1,    -1,    -1,     8,    39,    -1,
    -1,    60,    13,    -1,    -1,    -1,    17,    -1,     1,    20,
    21,    22,    23,    24,    -1,     8,    -1,    28,    -1,    60,
    13,    32,    33,    34,    17,    18,    19,    20,    39,    -1,
    -1,    24,    -1,    -1,    -1,    28,    -1,    -1,     1,    32,
    33,    34,    -1,    -1,    -1,     8,    39,    -1,    -1,    60,
    13,    -1,    -1,    -1,    17,    18,     1,    20,    -1,    -1,
    -1,    24,    -1,     8,    -1,    28,    -1,    60,    13,    32,
    33,    34,    17,    -1,    -1,    20,    39,    22,    -1,    24,
    -1,    -1,    -1,    28,    -1,    -1,     1,    32,    33,    34,
    -1,     6,    -1,     8,    39,    -1,    -1,    60,    13,    -1,
    -1,    -1,    17,    -1,     1,    20,    -1,    -1,    -1,    24,
    -1,     8,    -1,    28,    -1,    60,    13,    32,    33,    34,
    17,    -1,    -1,    20,    39,    -1,    -1,    24,    -1,    -1,
    27,    28,    -1,    -1,     1,    32,    33,    34,    -1,    -1,
    -1,     8,    39,    -1,    -1,    60,    13,    -1,    -1,    -1,
    17,    18,     1,    20,    -1,    -1,    -1,    24,    -1,     8,
    -1,    28,    -1,    60,    13,    32,    33,    34,    17,    -1,
    -1,    20,    39,    22,    -1,    24,    -1,    -1,    -1,    28,
    -1,    -1,     1,    32,    33,    34,    -1,    -1,    -1,     8,
    39,    -1,    -1,    60,    13,    -1,    -1,    -1,    17,    -1,
    -1,    20,     3,     4,    -1,    24,    -1,    -1,    27,    28,
    -1,    60,    -1,    32,    33,    34,    28,    29,    30,    31,
    39,     3,     4,    -1,    -1,    -1,    -1,    -1,    40,    41,
    42,    32,    -1,    -1,    -1,    36,    37,    38,    39,    -1,
    -1,    60,    43,    55,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    -1,    36,    37,    38,    58,     3,     4,
    61,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    -1,    -1,    -1,    -1,    58,    -1,    -1,    61,
    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,    -1,
    -1,    36,    37,    38,    -1,    -1,    15,    -1,    43,    -1,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
    -1,    56,    -1,    58,    -1,    -1,    61,    36,    37,    38,
    -1,    -1,    -1,    -1,    43,    -1,    45,    46,    47,    48,
    49,    50,    51,    52,    53,     3,     4,    -1,    -1,    58,
    -1,    -1,    61,    -1,    -1,    -1,    -1,    15,    -1,    -1,
    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,
    38,    -1,    -1,     3,     4,    43,    -1,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    -1,    36,    37,    38,
    58,    -1,    -1,    61,    43,    -1,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    -1,    36,    37,    38,    58,
    -1,    -1,    61,    43,    -1,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    -1,    -1,    -1,    -1,    58,    -1,
     7,    61,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
    -1,    -1,    39
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 765 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<procedure>", yyval.nonterminal);
            			nprintf(&parseTree, "\"Procedure class definition:\n ===========================\"\n%n\n\n", yyvsp[0].nonterminal);
                        YYABORT;
        		    ;
    break;}
case 2:
#line 771 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<command_line>", yyval.nonterminal);
            			nprintf(&parseTree, "%n!\n", yyvsp[0].nonterminal);
            			YYABORT;
        		    ;
    break;}
case 3:
#line 777 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<end_of_line>", yyval.nonterminal);
            			nprintf(&parseTree, "");					/* Do nothing with comment lines */
            			YYABORT;
        		    ;
    break;}
case 4:
#line 783 "yacccommands.y"
{
            			PACTION("", "", "", "", "<eof>", yyval.nonterminal);
            			nprintf(&parseTree, "");
        		    ;
    break;}
case 5:
#line 796 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_line> <end_proc_line>", yyval.nonterminal);
                    nprintf(&tmp2_tree, "('*** Empty procedure \"', self class name gtype, '\" called.') prnl");
                    PROCEDURE_BODY(&tmp1_tree,tmp2_tree, Current_procedure, Current_result)
        			nprintf(&yyval.nonterminal, "%n%n%n", yyvsp[-1].nonterminal,tmp1_tree, yyvsp[0].nonterminal);
        			strcpy(Current_procedure, "  <No current procedure>");
    		    ;
    break;}
case 6:
#line 804 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<proc_line> <block> <end_proc_line>", yyval.nonterminal);
        			PROCEDURE_BODY(&tmp1_tree, yyvsp[-1].nonterminal, Current_procedure, Current_result)
        			nprintf(&yyval.nonterminal, "%n%n%n", yyvsp[-2].nonterminal,tmp1_tree, yyvsp[0].nonterminal);
        			strcpy(Current_procedure, "  <No current procedure>");
    		    ;
    break;}
case 7:
#line 811 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<proc_line> <proc_header> <end_proc_line>", yyval.nonterminal);
        			nprintf(&tmp1_tree, "\"HEADER\n ------\"\n\n%n", yyvsp[-1].nonterminal);
                    nprintf(&yyval.nonterminal, "%n%n\n\n%n", yyvsp[-2].nonterminal, tmp1_tree, yyvsp[0].nonterminal);
        			strcpy(Current_result, ".\nself up.\n^nil");
        			strcpy(Current_procedure, "  <No current procedure>");
    		    ;
    break;}
case 8:
#line 819 "yacccommands.y"
{
        			PACTION(yyvsp[-3].nonterminal, yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "<proc_line> <proc_header> <block> <end_proc_line>", yyval.nonterminal);
        			nprintf(&tmp1_tree, "\"HEADER\n ------\"\n\n%n", yyvsp[-2].nonterminal);
                    PROCEDURE_BODY(&tmp2_tree, yyvsp[-1].nonterminal, Current_procedure, Current_result)
        			nprintf(&yyval.nonterminal, "%n%n\n\n%n%n", yyvsp[-3].nonterminal, tmp1_tree, tmp2_tree, yyvsp[0].nonterminal);
        			
        			strcpy(Current_result, ".\nself up.\n^nil");
        			strcpy(Current_procedure, "  <No current procedure>");
    		    ;
    break;}
case 9:
#line 830 "yacccommands.y"
{
			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_header> <proc_decl>", yyval.nonterminal);

			/* when header is complete, append an initializer method for all variables */
			printNode(buffer1, Current_initializer);
			deleteNode(Current_initializer);
			if ( buffer1[0] != '\0' )
			    buffer1[strlen(buffer1)-2] = '\0';	    /* If variables have been added, clip the string short */

			nprintf(&yyval.nonterminal, "%n\n!\n\n%n\n!\n\n!%s methodsFor: 'initializing'!\n\ninitVars\ngXUself _ GlobalWorkspaceThis.\nGlobalWorkspaceThis _ nil.\n%s\n!!",
				yyvsp[-1].nonterminal, yyvsp[0].nonterminal, Current_procedure, buffer1);
		    ;
    break;}
case 10:
#line 843 "yacccommands.y"
{
			PACTION(yyvsp[0].nonterminal, "", "", "", "<proc_decl>", yyval.nonterminal);
			/* when header is complete, append an initializer method for all variables */
			printNode(buffer1, Current_initializer);
			deleteNode(Current_initializer);

			if ( strlen(buffer1) > 0 )
			    buffer1[strlen(buffer1)-2] = '\0';
			else
			    buffer1[0]= '\0';

			nprintf(&yyval.nonterminal, "%n\n!\n\n!%s methodsFor: 'initializing'!\n\ninitVars\ngXUself _ GlobalWorkspaceThis.\nGlobalWorkspaceThis _ nil.\n%s\n!!",
					yyvsp[0].nonterminal, Current_procedure, buffer1);
		    ;
    break;}
case 11:
#line 858 "yacccommands.y"
{
			PACTION(yyvsp[0].nonterminal, "", "", "", "<proc_header>", yyval.nonterminal);
			/* when header is complete, append an initializer method for all variables */
			printNode(buffer1,Current_initializer);
			deleteNode(Current_initializer);
			if ( strlen(buffer1) > 0 )
			    buffer1[strlen(buffer1)-2] = '\0';
			else
			    buffer1[0]= '\0';

			nprintf(&yyval.nonterminal, "%n\n!\n\n!%s methodsFor: 'initializing'!\n\ninitVars\ngXUself _ GlobalWorkspaceThis.\nGlobalWorkspaceThis _ nil.\n%s\n!!",
				yyvsp[0].nonterminal, Current_procedure, buffer1);
		    ;
    break;}
case 12:
#line 873 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_header> <header_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n!\n\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);		/* Concatenate header lines */
    		    ;
    break;}
case 13:
#line 878 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_header> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);				/* Ignore the comment lines */
    		    ;
    break;}
case 14:
#line 883 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<header_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 15:
#line 889 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<param_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "\"parameters\n ----------\"\n\n%s\n\n%n", Current_procedure, yyvsp[0].nonterminal);
    		    ;
    break;}
case 16:
#line 894 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<qual_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "\"qualifiers\n ----------\"\n\n%s\n\n%n", Current_procedure, yyvsp[0].nonterminal);
    		    ;
    break;}
case 17:
#line 899 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<result_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "\"result\n ------\"\n\n%s\n\n%n", Current_procedure, yyvsp[0].nonterminal);
    		    ;
    break;}
case 18:
#line 905 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_decl> <decl_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n!\n\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);		/* Concatenate declaration lines */
    		    ;
    break;}
case 19:
#line 910 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_decl> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);				/* Ignore the comment lines */
    		    ;
    break;}
case 20:
#line 915 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<decl_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 21:
#line 921 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<local_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "\"Local variables\n ---------------\"\n\n%s\n\n%n", Current_procedure, yyvsp[0].nonterminal);
              ;
    break;}
case 22:
#line 926 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<global_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "\"Global variables\n ----------------\"\n\n%s\n\n%n", Current_procedure, yyvsp[0].nonterminal);
    		    ;
    break;}
case 23:
#line 932 "yacccommands.y"
{
        			PACTION("*BLOCK*", yyvsp[0].nonterminal, "", "", "<block> <command_line>", yyval.nonterminal) ;
        			/* Build code into a method block */
        			nprintf(&yyval.nonterminal, "%n.\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 24:
#line 938 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<block> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 25:
#line 943 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<command_line>", yyval.nonterminal);
        			/* Add code for the command line to the method block for the class */
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 26:
#line 957 "yacccommands.y"
{
            			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<loop_line> <block> <endloop_line>", yyval.nonterminal);
                        assert(Valid(Loop_lvalue[Loop_depth]));
            			nprintf(&yyval.nonterminal, "Function new loop: %n [ %n\n%n ] \ncondition: [false] after: [ %nnil ]",
            				yyvsp[-2].nonterminal, SSTOP(Loop_lvalue,Loop_depth), yyvsp[-1].nonterminal, SSTOP(Loop_lvalue,Loop_depth));
            			SSPOP(Loop_lvalue, Loop_depth)
                        assert(!Valid(Loop_lvalue[Loop_depth+1]));
        		    ;
    break;}
case 27:
#line 966 "yacccommands.y"
{
            			PACTION(yyvsp[-3].nonterminal, yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "<loop_line> <block> <exit_control> <endloop_line>", yyval.nonterminal);
                        assert(Valid(Loop_lvalue[Loop_depth]));
            			nprintf(&yyval.nonterminal, "Function new loop: %n [ %n\n%n ] \n%n", yyvsp[-3].nonterminal, SSTOP(Loop_lvalue,Loop_depth), yyvsp[-2].nonterminal, yyvsp[-1].nonterminal);
            			SSPOP(Loop_lvalue, Loop_depth)
                        assert(!Valid(Loop_lvalue[Loop_depth+1]));
        		    ;
    break;}
case 28:
#line 974 "yacccommands.y"
{
            			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<loop_line> <exit_control> <endloop_line>", yyval.nonterminal);
                        assert(Valid(Loop_lvalue[Loop_depth]));
            			nprintf(&yyval.nonterminal, "Function new loop: %n [ %nnil ] \n%n", yyvsp[-2].nonterminal, SSTOP(Loop_lvalue,Loop_depth), yyvsp[-1].nonterminal);
            			SSPOP(Loop_lvalue, Loop_depth)
                        assert(!Valid(Loop_lvalue[Loop_depth+1]));
        		    ;
    break;}
case 29:
#line 982 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<loop_line> <endloop_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "('*** Empty loop executed (add a dummy statement to get an infinite loop)') prnl");
                        assert(Valid(Loop_lvalue[Loop_depth]));
            			SSPOP(Loop_lvalue, Loop_depth)
                        assert(!Valid(Loop_lvalue[Loop_depth+1]));
                        deleteNode(yyvsp[-1].nonterminal);    /* Need to eat up $1 here (it may contain unsed count control) */
        		    ;
    break;}
case 30:
#line 992 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<exitif_line> <block>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "condition: %n after: [ %n\n%n ]", yyvsp[-1].nonterminal, SSTOP(Loop_lvalue,Loop_depth), yyvsp[0].nonterminal);
        		    ;
    break;}
case 31:
#line 997 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<exitif_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "condition: %n after: [ %nnil ]", yyvsp[0].nonterminal, SSTOP(Loop_lvalue,Loop_depth));
        		    ;
    break;}
case 32:
#line 1003 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, "", "", "", "LOOP", yyval.nonterminal);
        			SSPUSH(Loop_lvalue, Loop_depth)
            	    nprintf(&Loop_lvalue[Loop_depth], "");  /* Need to make a null node here */
        			nprintf(&yyval.nonterminal,"");                        /* This node will be eaten higher up ! */
    		    ;
    break;}
case 33:
#line 1009 "yacccommands.y"
{ SSPUSH(Loop_lvalue, Loop_depth) ;
    break;}
case 34:
#line 1010 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-1].nonterminal, "", "", "LOOP <count_control> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n before:" , yyvsp[-1].nonterminal);
    		    ;
    break;}
case 35:
#line 1015 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<loop_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 36:
#line 1021 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, "", "", "EXITIF <expression>", yyval.nonterminal);
                    assert(Valid(Loop_lvalue[Loop_depth]));
        			nprintf(&yyval.nonterminal, "[ %n%n ]", SSTOP(Loop_lvalue,Loop_depth), yyvsp[-1].nonterminal);
    		    ;
    break;}
case 37:
#line 1027 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<exitif_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 38:
#line 1033 "yacccommands.y"
{
            			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "ENDLOOP <end_of_line>", yyval.nonterminal);
            			yyval.nonterminal = NULL;
        		    ;
    break;}
case 39:
#line 1039 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<lvalue> <loop_range>", yyval.nonterminal);
                        assert(!Valid(Loop_lvalue[Loop_depth]));
            			nprintf(&Loop_lvalue[Loop_depth], ":%n | ", yyvsp[-1].nonterminal);
            			nprintf(&yyval.nonterminal, "%n by: 1", yyvsp[0].nonterminal);
        		    ;
    break;}
case 40:
#line 1046 "yacccommands.y"
{
            			PACTION(yyvsp[-3].nonterminal, yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "<lvalue> <loop_range> STEP <expression>", yyval.nonterminal);
                        assert(!Valid(Loop_lvalue[Loop_depth]));
            			nprintf(&Loop_lvalue[Loop_depth], ":%n | ", yyvsp[-3].nonterminal);
            			nprintf(&yyval.nonterminal, "%n by: %n", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
        		    ;
    break;}
case 41:
#line 1055 "yacccommands.y"
{
            			PACTION(yyvsp[-3].terminal, yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "FROM <expression> TO <expression>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n to: %n", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
        		    ;
    break;}
case 42:
#line 1064 "yacccommands.y"
{
            			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<case_line> <alternatives> <endcase_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "Function new %n body: [ :caseTempVar :break |\n%n ]", yyvsp[-2].nonterminal, yyvsp[-1].nonterminal);
            			SSPOP(Case_lvalue,Case_depth)
        		    ;
    break;}
case 43:
#line 1070 "yacccommands.y"
{
            			PACTION(yyvsp[-3].nonterminal, yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "<case_line> <alternatives> <otherwise_part> <endcase_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "Function new %n body: [ :caseTempVar :break |\n%n.\n%n ]", yyvsp[-3].nonterminal, yyvsp[-2].nonterminal, yyvsp[-1].nonterminal);
            			SSPOP(Case_lvalue,Case_depth)
        		    ;
    break;}
case 44:
#line 1076 "yacccommands.y"
{
            			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "<case_line> <otherwise_part> <endcase_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "Function new %n body: [ :caseTempVar :break |\n%n ]", yyvsp[-2].nonterminal, yyvsp[-1].nonterminal);
            			SSPOP(Case_lvalue,Case_depth)
        		    ;
    break;}
case 45:
#line 1082 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<case_line> <endcase_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "nil \"(null case)\"");
            			SSPOP(Case_lvalue,Case_depth)
        		    ;
    break;}
case 46:
#line 1089 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<alternatives> <test_clause>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n.\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
        		    ;
    break;}
case 47:
#line 1094 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<test_clause>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
        		    ;
    break;}
case 48:
#line 1100 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<otherwise_line> <block>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
        		    ;
    break;}
case 49:
#line 1105 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<otherwise_line>", yyval.nonterminal);
                        yyval.nonterminal = NULL;
        		    ;
    break;}
case 50:
#line 1111 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<is_line> <block>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n [\n %n. break value ]", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
        		    ;
    break;}
case 51:
#line 1116 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<is_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n [\n nil. break value ]", yyvsp[0].nonterminal);
        		    ;
    break;}
case 52:
#line 1122 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "CASE <expression> <end_of_line>", yyval.nonterminal);
/*                    gprintdf("CASE depth = %d\n", Case_depth);*/
        			SSPUSH(Case_lvalue, Case_depth)
                    assert(!Valid(Case_lvalue[Case_depth]));
        			nprintf(&Case_lvalue[Case_depth], "caseTempVar");
        			nprintf(&yyval.nonterminal, "case: %n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 53:
#line 1131 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<case_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 54:
#line 1138 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "IS <case_range> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n ifTrue:", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 55:
#line 1143 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<is_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 56:
#line 1149 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n = %n)", SSTOP(Case_lvalue,Case_depth), yyvsp[0].nonterminal);
    		    ;
    break;}
case 57:
#line 1154 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> TO <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "((%n <= %n) & (%n <= %n))",yyvsp[-2].nonterminal, SSTOP(Case_lvalue,Case_depth),
    				    SSTOP(Case_lvalue,Case_depth), yyvsp[0].nonterminal );
    		    ;
    break;}
case 58:
#line 1161 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "OTHERWISE <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "");
    		    ;
    break;}
case 59:
#line 1166 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<otherwise_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "");
    		    ;
    break;}
case 60:
#line 1172 "yacccommands.y"
{
            			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "ENDCASE <end_of_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "");
        		    ;
    break;}
case 61:
#line 1181 "yacccommands.y"
{
            			PACTION(yyvsp[-2].terminal, yyvsp[-1].split_exp, yyvsp[0].nonterminal, "", "IF <elif_part> <endif_line>", yyval.nonterminal);
                        nprintf(&yyval.nonterminal, "%n%n", LHS(yyvsp[-1].split_exp), RHS(yyvsp[-1].split_exp) );
        		    ;
    break;}
case 62:
#line 1186 "yacccommands.y"
{
            			PACTION(yyvsp[-3].terminal, yyvsp[-2].split_exp, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "IF <elif_part> <else_part> <endif_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n %n %n", LHS(yyvsp[-2].split_exp), yyvsp[-1].nonterminal, RHS(yyvsp[-2].split_exp) );
        		    ;
    break;}
case 63:
#line 1192 "yacccommands.y"
{
			        PACTION(yyvsp[-2].split_exp, yyvsp[-1].terminal, yyvsp[0].split_exp, "", "<elif_part> ELSEIF <cond_block>", yyval.split_exp);
			        nprintf(&LHS(yyval.split_exp), "%n ifFalse: [ %n ]", LHS(yyvsp[-2].split_exp), LHS(yyvsp[0].split_exp) );
			        nprintf(&RHS(yyval.split_exp), "%n%n", RHS(yyvsp[0].split_exp), RHS(yyvsp[-2].split_exp) );
		        ;
    break;}
case 64:
#line 1198 "yacccommands.y"
{
			        PACTION(yyvsp[0].split_exp, "", "", "", "<cond_block>", yyval.split_exp);
			        nprintf(&LHS(yyval.split_exp), "%n %n", LHS(yyvsp[0].split_exp), RHS(yyvsp[0].split_exp) );
			        nprintf(&RHS(yyval.split_exp),"");
		        ;
    break;}
case 65:
#line 1205 "yacccommands.y"
{
			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<else_line> <block>", yyval.nonterminal);
			nprintf(&yyval.nonterminal, "ifFalse: [ \n%n ]", yyvsp[0].nonterminal);
			If_depth--;
		    ;
    break;}
case 66:
#line 1211 "yacccommands.y"
{
			PACTION(yyvsp[0].nonterminal, "", "", "", "<else_line>", yyval.nonterminal);
			nprintf(&yyval.nonterminal, "");
			If_depth--;
		    ;
    break;}
case 67:
#line 1218 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<expr_line> <block>", yyval.split_exp);
                    nprintf(&LHS(yyval.split_exp), "%n ifTrue: [ \n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
                    nprintf(&RHS(yyval.split_exp), "]");
        			If_depth--;
    		    ;
    break;}
case 68:
#line 1225 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<expr_line>", yyval.split_exp);
        			nprintf(&LHS(yyval.split_exp), "%n", yyvsp[0].nonterminal);
        			nprintf(&RHS(yyval.split_exp),"");
        			If_depth--;
    		    ;
    break;}
case 69:
#line 1232 "yacccommands.y"
{ If_depth++; ;
    break;}
case 70:
#line 1233 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[0].nonterminal, "", "", "<expression> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-2].nonterminal);
    		    ;
    break;}
case 71:
#line 1238 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<expr_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 72:
#line 1243 "yacccommands.y"
{ If_depth++; ;
    break;}
case 73:
#line 1244 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[0].nonterminal, "", "", "ELSE <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "");
    		    ;
    break;}
case 74:
#line 1249 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<else_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "");
    		    ;
    break;}
case 75:
#line 1255 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "ENDIF <end_of_line>", yyval.nonterminal);
                    yyval.nonterminal = NULL;
    		    ;
    break;}
case 76:
#line 1263 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].astring, "", "", "<code> ENDCODE", yyval.nonterminal);
                    in_smalltalk = 0;
        			nprintf(&yyval.nonterminal, "%n%s", yyvsp[-1].nonterminal, yyvsp[0].astring); 
    		    ;
    break;}
case 77:
#line 1269 "yacccommands.y"
{
        			PACTION(yyvsp[0].astring, "", "", "", "ENDCODE", yyval.nonterminal);
                    in_smalltalk = 0;
        			nprintf(&yyval.nonterminal, "%s",yyvsp[0].astring); 
    		    ;
    break;}
case 78:
#line 1276 "yacccommands.y"
{
        			lines_parsed++;
        			PACTION(yyvsp[0].astring, "", "", "", "CODELINE", yyval.nonterminal);
                    in_smalltalk = 1;
        			nprintf(&yyval.nonterminal, "%s\n", yyvsp[0].astring); 
    		    ;
    break;}
case 79:
#line 1283 "yacccommands.y"
{
        			lines_parsed++;
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].astring, "", "", "code CODELINE", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n%s\n", yyvsp[-1].nonterminal, yyvsp[0].astring); 
    		    ;
    break;}
case 80:
#line 1297 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "PROCEDURE IDENTIFIER <end_of_line>", yyval.nonterminal);
        			strcpy(Current_procedure,yyvsp[-1].terminal);
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "H%s\n", Current_procedure);
        			MangleProc(Current_procedure);

        			/* Create a subclass of Function under an appropriate identifier */
        			PROCEDURE_CLASS(&yyval.nonterminal, Current_procedure)
    		    ;
    break;}
case 81:
#line 1308 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<proc_line> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);		/* eat comments */
    		    ;
    break;}
case 82:
#line 1314 "yacccommands.y"
{
            			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "ENDPROCEDURE <end_of_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "\"End of procedure\"");
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "E\n");
        		    ;
    break;}
case 83:
#line 1322 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "PARAMETERS <fp_defs> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 84:
#line 1328 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "QUALIFIERS <qual_defs> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 85:
#line 1333 "yacccommands.y"
{ Current_line_type = Result; ;
    break;}
case 86:
#line 1334 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "RESULT <variable_declarator> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 87:
#line 1339 "yacccommands.y"
{ Current_line_type = Local; ;
    break;}
case 88:
#line 1340 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "LOCAL <var_defs> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 89:
#line 1345 "yacccommands.y"
{ Current_line_type = Global; ;
    break;}
case 90:
#line 1346 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "GLOBAL <var_defs> <end_of_line>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 91:
#line 1352 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<error> <end_of_line>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "nil \"(line with syntax error)\"");
                        /* Note: there is a node leak here as we cannot tell what has been half created */
                        yyerrok;
        		    ;
    break;}
case 92:
#line 1359 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<assignment> <end_of_line>", yyval.nonterminal);
             			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal );
        		    ;
    break;}
case 93:
#line 1364 "yacccommands.y"
{
            			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<keyword> <end_of_line>", yyval.nonterminal);
             			nprintf(&yyval.nonterminal, "%n", yyvsp[-1].nonterminal );
        		    ;
    break;}
case 94:
#line 1369 "yacccommands.y"
{
            			PACTION(yyvsp[-3].terminal, yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "[ <expression> ] <end_of_line>", yyval.nonterminal);
             			nprintf(&yyval.nonterminal, "%n", yyvsp[-2].nonterminal );
        		    ;
    break;}
case 95:
#line 1374 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<loop_construct>", yyval.nonterminal);
        		        nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal );
        		    ;
    break;}
case 96:
#line 1379 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<loop_construct>", yyval.nonterminal);
        		        nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal );
        		    ;
    break;}
case 97:
#line 1384 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<if_construct>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal );
        		    ;
    break;}
case 98:
#line 1389 "yacccommands.y"
{
            			PACTION(yyvsp[0].nonterminal, "", "", "", "<code_block>", yyval.nonterminal);
            			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal );
        		    ;
    break;}
case 99:
#line 1394 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "FORWARD IDENTIFIER <end_of_line>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-1].terminal);
        			MangleProc(buffer1);
        		        nprintf(&yyval.nonterminal, "((Smalltalk at: #%s ifAbsent: [Smalltalk at: #%s put: \
				  'Procedure \"%s\" has only been FORWARD declared, it must also have a PROCEDURE definition' ] ) \
				  isKindOf: Function class) ifTrue: \
				[ 'Warning: FORWARD statement for a previously defined procedure \"%s\" - no action taken' prinl ]",\
				   buffer1, buffer1, yyvsp[-1].terminal, yyvsp[-1].terminal);
        		    ;
    break;}
case 100:
#line 1405 "yacccommands.y"
{
        		        PACTION(yyvsp[-1].terminal, "", "", "", "RETURN <end_of_line>", yyval.nonterminal);
        		        nprintf(&yyval.nonterminal, "[nil%s] value", Current_result);
        		    ;
    break;}
case 101:
#line 1418 "yacccommands.y"
{
        			lines_parsed++;
        			PACTION(yyvsp[0].terminal, "", "", "", "ENDOFLINE", yyval.nonterminal);
        			yyval.nonterminal = NULL;		    /* Allow simple blank lines, (nothing to pass back) */
    		    ;
    break;}
case 102:
#line 1424 "yacccommands.y"
{
        			lines_parsed++;
        			PACTION(yyvsp[-1].astring, yyvsp[0].terminal, "", "", "COMMENT ENDOFLINE", yyval.nonterminal);
        			yyval.nonterminal = NULL;     /* Just parse comments, don't make use of them */
    		    ;
    break;}
case 103:
#line 1436 "yacccommands.y"
{ keep_structure_flag = structure_flag; strcpy(keep_structure_name, structure_name); ;
    break;}
case 104:
#line 1437 "yacccommands.y"
{
        			PACTION(yyvsp[-3].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<lvalue> = <expression>", yyval.nonterminal);

	                auto_declare = prompt_mode();

        			if (keep_structure_flag)		/* Element assign for structural lvalues */

        			    if (auto_declare)
                            {ASSIGN_STRUCT_I(&yyval.nonterminal, keep_structure_name, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "deepCopy");}
        			    else
                            {ASSIGN_STRUCT(&yyval.nonterminal, keep_structure_name, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "deepCopy");}

        			else					/* destructive copy for all other types */

        			    if (auto_declare)
                            {ASSIGN_ATOMIC_I(&yyval.nonterminal, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "deepCopy");}
        			    else
                            {ASSIGN_ATOMIC(&yyval.nonterminal, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "deepCopy");}
    		    ;
    break;}
case 105:
#line 1456 "yacccommands.y"
{ keep_structure_flag = structure_flag; strcpy(keep_structure_name, structure_name); ;
    break;}
case 106:
#line 1457 "yacccommands.y"
{
        			PACTION(yyvsp[-3].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<lvalue> ALIAS <expression>", yyval.nonterminal);

	                auto_declare = prompt_mode();

        			if (keep_structure_flag)		/* Element assign for structural lvalues */

        			    if (auto_declare)
                            {ASSIGN_STRUCT_I(&yyval.nonterminal, keep_structure_name, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "");}
        			    else
                            {ASSIGN_STRUCT(&yyval.nonterminal, keep_structure_name, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "");}

        			else					/* destructive copy for all other types */

        			    if (auto_declare)
                            {ASSIGN_ATOMIC_I(&yyval.nonterminal, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "");}
        			    else
                            {ASSIGN_ATOMIC(&yyval.nonterminal, yyvsp[-3].nonterminal, yyvsp[0].nonterminal, "");}
    		    ;
    break;}
case 107:
#line 1478 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> > <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n > %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 108:
#line 1483 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> < <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n < %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 109:
#line 1488 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> = <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n = %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 110:
#line 1493 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> GEQUAL <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n >= %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 111:
#line 1498 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> LEQUAL <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n <= %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 112:
#line 1503 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> NOTEQUALS <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n ~= %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 113:
#line 1508 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> & <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n , %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 114:
#line 1513 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> OR <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n | %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 115:
#line 1518 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> + <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n + %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 116:
#line 1523 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> - <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n - %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 117:
#line 1528 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> AND <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n & %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 118:
#line 1533 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> * <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n * %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 119:
#line 1538 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> / <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n / %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 120:
#line 1543 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> | <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n rem: %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 121:
#line 1548 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> | <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n raisedTo: %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 122:
#line 1553 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> ':' <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n to: %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 123:
#line 1558 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<expression> '@' <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n by: %n)", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 124:
#line 1563 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].terminal, "", "( <expression> )", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n)", yyvsp[-1].nonterminal);
    		    ;
    break;}
case 125:
#line 1568 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<function_call>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n)", yyvsp[0].nonterminal);
    		    ;
    break;}
case 126:
#line 1573 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "NOT <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n not", yyvsp[0].nonterminal);
    		    ;
    break;}
case 127:
#line 1578 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "UPLUS <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 128:
#line 1583 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "UMINUS <expression>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n negated", yyvsp[0].nonterminal);
    		    ;
    break;}
case 129:
#line 1588 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].split_exp, "( <expression> ) <struct_spec>", yyval.nonterminal);
        			if (method_flag)
        			    nprintf(&yyval.nonterminal,"(%n%n push %n)", LHS(yyvsp[0].split_exp), yyvsp[-2].nonterminal, RHS(yyvsp[0].split_exp));
				else
        			    nprintf(&yyval.nonterminal,"(%n%n%n)", LHS(yyvsp[0].split_exp), yyvsp[-2].nonterminal, RHS(yyvsp[0].split_exp));
        			structure_flag = 0;                 /* FALSE */
        			printNode(structure_name, yyvsp[-2].nonterminal);      /* Need to keep a copy in ASCII for comparison */
    		    ;
    break;}
case 130:
#line 1598 "yacccommands.y"
{
        			PACTION(yyvsp[0].aninteger, "", "", "", "UINTEGER", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%d", (long)yyvsp[0].aninteger);
    		    ;
    break;}
case 131:
#line 1603 "yacccommands.y"
{
        			PACTION(yyvsp[0].areal, "", "", "", "UREAL", yyval.nonterminal);
        			sprintf(buffer1, "%.15e", yyvsp[0].areal);
        			ReplacePlusSigns(buffer1);	/* Smalltalk doesn't like '+' signs. eg. change +5e+20 to 05e020 */
        			nprintf(&yyval.nonterminal, "%s", buffer1);
    		    ;
    break;}
case 132:
#line 1610 "yacccommands.y"
{
        			PACTION(yyvsp[0].astring, "", "", "", "STRING", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "'%s'", yyvsp[0].astring);
    		    ;
    break;}
case 133:
#line 1615 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<lvalue>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "(%n)", yyvsp[0].nonterminal);
    		    ;
    break;}
case 134:
#line 1623 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].terminal, "", "IDENTIFIER ( )", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-2].terminal);		    /* Build smalltalk command */
				MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: true; condEvaluate",buffer1 /*, lines_parsed+1*/);
    		    ;
    break;}
case 135:
#line 1630 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].terminal, "IDENTIFIER <qual_list1> ( )", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-3].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: true; %n; condEvaluate",buffer1 /*, lines_parsed+1*/, yyvsp[-2].nonterminal);
    		    ;
    break;}
case 136:
#line 1637 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "IDENTIFIER <arguments>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-1].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: true; %n; condEvaluate",buffer1 /*, lines_parsed+1 */, yyvsp[0].nonterminal);
    		    ;
    break;}
case 137:
#line 1644 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "IDENTIFIER <qual_list1> <arguments>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-2].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: true; %n; %n; condEvaluate",buffer1 /*, lines_parsed+1 */, yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 138:
#line 1652 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].terminal, "", "", ": IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "%s", buffer1 );
/*                    gprintdf("\033[34m\033[1mObsolete qualifier syntax on line %d, please change expressions like\n%s%s%s\033[0m",
                        lines_parsed+1,
                        "    \"function:qual1:qual2(x,y,z)\"\n",
                        "to use \"%\" instead of \":\" to separate the qualifiers, eg\n",
                        "    \"function%qual1%qual2(x,y,z)\"\n");
*/    		    ;
    break;}
case 139:
#line 1671 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].terminal, "", "<qual_list1> : IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "%n; %s", yyvsp[-2].nonterminal, buffer1);
    		    ;
    break;}
case 140:
#line 1679 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].terminal, "", "", "/ IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "%s", buffer1 );
    		    ;
    break;}
case 141:
#line 1686 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].terminal, "", "<qual_list2> / IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "%n; %s", yyvsp[-2].nonterminal, buffer1);
    		    ;
    break;}
case 142:
#line 1694 "yacccommands.y"
{						/* Syntactically the same as <qual_list2>, different semantics */
        			PACTION(yyvsp[-1].terminal, yyvsp[0].terminal, "", "", "/ IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "Q%s\n", buffer1);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "addInstVarName: #%s;\ncompile:\n'%s\n\t%s _ true';\ncompile:\n'%s: aBoolean\n\t%s _ aBoolean'", buffer1, buffer1, buffer1, buffer1, buffer1);

        			/* add a line to the initializer for this procedure (need to ensure qualifier is false by default) */
                    if (!Valid(Current_initializer)) Current_initializer = newLeaf("");
                    nprintf(&tmp1_tree, "%n\t%s _ false.\n",Current_initializer, buffer1);
                    nprintf(&Current_initializer, "%n",tmp1_tree);
    		    ;
    break;}
case 143:
#line 1708 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].terminal, "", "<qual_list2> / IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "Q%s\n", buffer1);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal, "%n;\n\naddInstVarName: #%s;\ncompile:\n'%s\n\t%s _ true';\ncompile:\n'%s: aBoolean\n\t%s _ aBoolean'", yyvsp[-2].nonterminal, buffer1, buffer1, buffer1, buffer1, buffer1);

        			/* add a line to the initializer for this procedure (need to ensure qualifier is false by default) */
                    if (!Valid(Current_initializer)) Current_initializer = newLeaf("");
        			nprintf(&tmp1_tree, "%n\t%s _ false.\n", Current_initializer, buffer1);
        			nprintf(&Current_initializer, "%n",tmp1_tree);
    		    ;
    break;}
case 144:
#line 1722 "yacccommands.y"
{ PPUSH(Param_no,Function_depth) ;
    break;}
case 145:
#line 1722 "yacccommands.y"
{ PPOP(Param_no,Function_depth) ;
    break;}
case 146:
#line 1723 "yacccommands.y"
{
        			PACTION(yyvsp[-4].terminal, yyvsp[-2].nonterminal, yyvsp[0].terminal, "", "( <arg_list> )", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[-2].nonterminal );
    		    ;
    break;}
case 147:
#line 1729 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<function_parameter>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 148:
#line 1734 "yacccommands.y"
{
        			PACTION(yyvsp[-2].nonterminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<arg_list> , <function_parameter>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n; %n", yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 149:
#line 1740 "yacccommands.y"
{
        			PACTION(yyvsp[0].terminal, "", "", "", "IDENTIFIER", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[0].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: false; condEvaluate", buffer1 /*, lines_parsed+1 */);
    		    ;
    break;}
case 150:
#line 1747 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", "IDENTIFIER <qual_list2>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-1].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: false; %n; condEvaluate", buffer1 /*, lines_parsed+1 */, yyvsp[0].nonterminal);
    		    ;
    break;}
case 151:
#line 1753 "yacccommands.y"
{ PPUSH(Param_no,Function_depth) ;
    break;}
case 152:
#line 1754 "yacccommands.y"
{
        			PACTION(yyvsp[-2].terminal, yyvsp[0].nonterminal, "", "", "IDENTIFIER <fp_list>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-2].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: false; %n; condEvaluate", buffer1 /*, lines_parsed+1 */, yyvsp[0].nonterminal);
        			PPOP(Param_no,Function_depth)				/* restore default param name count */
    		    ;
    break;}
case 153:
#line 1761 "yacccommands.y"
{ PPUSH(Param_no,Function_depth) ;
    break;}
case 154:
#line 1762 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-2].nonterminal, yyvsp[0].nonterminal, "", "IDENTIFIER <qual_list2> <fp_list>", yyval.nonterminal);
        			strcpy(buffer1,yyvsp[-3].terminal);		    /* Build smalltalk command */
        			MangleProc(buffer1);
        			nprintf(&yyval.nonterminal, "%s run line: 0 proc: self method: false; %n; %n; condEvaluate",buffer1 /*, lines_parsed+1 */, yyvsp[-2].nonterminal, yyvsp[0].nonterminal);
        			PPOP(Param_no,Function_depth)
    		    ;
    break;}
case 155:
#line 1772 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<function_parameter>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 156:
#line 1777 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<fp_list> <function_parameter>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n; %n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 157:
#line 1784 "yacccommands.y"
{
            				PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "IDENTIFIER = <expression>", yyval.nonterminal);
            				strcpy(buffer1,yyvsp[-2].terminal);
            				MangleVar(buffer1);
            				nprintf(&yyval.nonterminal, "%s:%n",buffer1, yyvsp[0].nonterminal);
        			    ;
    break;}
case 158:
#line 1791 "yacccommands.y"
{
            				PACTION(yyvsp[0].nonterminal, "", "", "", "<expression>", yyval.nonterminal);
        			        nprintf(&yyval.nonterminal, "p%d:%n", (long)PTOP(Param_no,Function_depth)++, yyvsp[0].nonterminal);
        			    ;
    break;}
case 159:
#line 1798 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<type_specifier>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 160:
#line 1803 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<fp_defs> <type_specifier>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n;\n\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 161:
#line 1809 "yacccommands.y"
{
            			PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].terminal, "", "IDENTIFIER = IDENTIFIER", yyval.nonterminal);
            			strcpy(buffer1,yyvsp[-2].terminal);
               			strcpy(buffer2,yyvsp[0].terminal);
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "P%s=%s\n", buffer1, buffer2);
            			MangleVar(buffer1);
                        	MangleType(buffer2);

            			nprintf(&yyval.nonterminal, "%s%s%s%s%s%s%s%s%s%s%s%s%s%d%s%s%s%s%s%s%s%s",
            				"addInstVarName: #", buffer1,
            				";\ncompile:\n'", buffer1, ": aVar\n",
        					"\taVar notNil ifTrue:[", buffer1, " _ self typeCheck: aVar shouldBe: ", buffer2,
    						" paramName: ''", buffer1, "'']';",
            				"\ncompile:\n'p", (long)PTOP(Param_no,Function_depth)++, ": aVar\n",
        					"\taVar notNil ifTrue:[", buffer1, " _ self typeCheck: aVar shouldBe: ", buffer2,
    						" paramName: ''", buffer1, "'']'" );
        		    ;
    break;}
case 162:
#line 1828 "yacccommands.y"
{
            			PACTION(yyvsp[0].terminal, "", "", "", "IDENTIFIER", yyval.nonterminal);
            			strcpy(buffer1,yyvsp[0].terminal);
				if (g_fpTypeFile != 0)
				    fprintf(g_fpTypeFile, "P%s\n", buffer1);
            			MangleVar(buffer1);

            			/* create instance variable */
        		        nprintf(&tmp1_tree, "addInstVarName: #%s;\n",buffer1);

            			/* create keyword entry (any type) */
            			nprintf(&tmp2_tree, "compile:\n'%s: aVar\n\taVar notNil ifTrue:[ %s _ aVar ]';\n", buffer1, buffer1);

            			/* create default entry (any type) */
            			nprintf(&yyval.nonterminal, "%n%ncompile:\n'p%d: aVar\n\taVar notNil ifTrue:[ %s _ aVar ]'",
            				tmp1_tree,tmp2_tree, (long)PTOP(Param_no,Function_depth)++, buffer1);
        		    ;
    break;}
case 163:
#line 1847 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<variable_declarator>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n", yyvsp[0].nonterminal);
    		    ;
    break;}
case 164:
#line 1852 "yacccommands.y"
{
        			PACTION(yyvsp[-1].nonterminal, yyvsp[0].nonterminal, "", "", "<var_defs> <variable_declarator>", yyval.nonterminal);
        			nprintf(&yyval.nonterminal, "%n;\n\n%n", yyvsp[-1].nonterminal, yyvsp[0].nonterminal);
    		    ;
    break;}
case 165:
#line 1858 "yacccommands.y"
{
            				PACTION(yyvsp[-2].terminal, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "IDENTIFIER = <expression>", yyval.nonterminal);
            				strcpy(buffer1,yyvsp[-2].terminal);
            				if ( Current_line_type == Local || Current_line_type == Result ) {
            					MangleVar(buffer1);

            					/* create instance variable */
            					nprintf(&yyval.nonterminal, "addInstVarName: #%s",buffer1);

            					/* add a line to the initializer for this procedure */
                                if (!Valid(Current_initializer)) Current_initializer = newLeaf("");
                                nprintf(&tmp1_tree, "%n\t%s _ %n.\n",Current_initializer, buffer1, yyvsp[0].nonterminal);
            					nprintf(&Current_initializer, "%n",tmp1_tree); /* Don't try to do this in one step, it won't work! */
            					if ( Current_line_type == Result )
            						sprintf(Current_result,".\nself up.\n^%s", buffer1); }
            				else {
            					MangleVar(buffer1);
            					/* create global variable if not already created by another procedure */
            					/* Initialize the variable only if it is currently set to nil */

            					nprintf(&yyval.nonterminal, "addPoolVar: #%s value: %n", buffer1, yyvsp[0].nonterminal); };
        			    ;
    break;}
case 166:
#line 1881 "yacccommands.y"
{
            				PACTION(yyvsp[0].terminal, "", "", "", "IDENTIFIER", yyval.nonterminal);
            				strcpy(buffer1, yyvsp[0].terminal);
            				if ( Current_line_type == Local  || Current_line_type == Result ) {
            					MangleVar(buffer1);

            					/* create instance variable */
            					nprintf(&yyval.nonterminal, "addInstVarName: #%s",buffer1);
            					if ( Current_line_type == Result )
            						sprintf(Current_result,".\nself up.\n^%s", buffer1); }
            				else {
            					MangleVar(buffer1);
            					/* create global variable if not already created by another procedure */
            					/* Initialize the variable only if it is currently set to nil */

            					nprintf(&yyval.nonterminal, "addPoolVar: #%s", buffer1); } ;
        			    ;
    break;}
case 167:
#line 1905 "yacccommands.y"
{
        		PACTION(yyvsp[-1].terminal, yyvsp[0].split_exp, "", "",  "IDENTIFIER <struct_spec>", yyval.nonterminal);

        		strcpy(buffer1, yyvsp[-1].terminal);

			MangleVar(buffer1);

        		if (method_flag)
			    nprintf(&yyval.nonterminal,"%n%s push %n",LHS(yyvsp[0].split_exp), buffer1, RHS(yyvsp[0].split_exp));
			else
			    nprintf(&yyval.nonterminal,"%n%s%n",LHS(yyvsp[0].split_exp), buffer1, RHS(yyvsp[0].split_exp));
        		structure_flag = 1; /* TRUE */
        		strcpy(structure_name, buffer1);
    		    ;
    break;}
case 168:
#line 1920 "yacccommands.y"
{
        			PACTION(yyvsp[0].terminal, "", "", "", "IDENTIFIER", yyval.nonterminal);

        			strcpy(buffer1, yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&yyval.nonterminal,"%s",buffer1);
        			structure_flag = 0; /* FALSE */
    		    ;
    break;}
case 169:
#line 1930 "yacccommands.y"
{
        			PACTION(yyvsp[0].split_exp, "", "", "", "<index_ref>", yyval.split_exp);
        			/* $$ = $1 */
    		    ;
    break;}
case 170:
#line 1935 "yacccommands.y"
{
        			PACTION(yyvsp[-1].split_exp, yyvsp[0].split_exp, "", "", "<struct_spec> <index_ref>", yyval.split_exp);

        			nprintf(&LHS(yyval.split_exp), "%n%n", LHS(yyvsp[0].split_exp),LHS(yyvsp[-1].split_exp));
        			nprintf(&RHS(yyval.split_exp), "%n%n", RHS(yyvsp[-1].split_exp),RHS(yyvsp[0].split_exp));
    		    ;
    break;}
case 171:
#line 1942 "yacccommands.y"
{
			PACTION(yyvsp[0].split_exp, "", "", "", "<method_ref>", yyval.split_exp);
        			/* $$ = $1 */
    		    ;
    break;}
case 172:
#line 1947 "yacccommands.y"
{
        			PACTION(yyvsp[-1].split_exp, yyvsp[0].split_exp, "", "", "<struct_spec> <method_ref>", yyval.split_exp);

        			nprintf(&LHS(yyval.split_exp), "%n%n", LHS(yyvsp[0].split_exp),LHS(yyvsp[-1].split_exp));
        			nprintf(&RHS(yyval.split_exp), "%n%n", RHS(yyvsp[-1].split_exp),RHS(yyvsp[0].split_exp));
    		    ;
    break;}
case 173:
#line 1955 "yacccommands.y"
{
       			PACTION(yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "", ". <function_call>", yyval.split_exp);
        		nprintf(&LHS(yyval.split_exp), "(" );
        		nprintf(&RHS(yyval.split_exp), ") %n", yyvsp[0].nonterminal);
        		method_flag = 1;

		  ;
    break;}
case 174:
#line 1963 "yacccommands.y"
{
        			PACTION(yyvsp[-1].terminal, yyvsp[0].terminal, "", "", ". IDENTIFIER", yyval.split_exp);

        			strcpy(buffer1, yyvsp[0].terminal);
        			MangleVar(buffer1);
        			nprintf(&LHS(yyval.split_exp), "(" );
        			nprintf(&RHS(yyval.split_exp), ") at:#%s", buffer1);
        		method_flag = 0;
    		    ;
    break;}
case 175:
#line 1973 "yacccommands.y"
{ PPUSH(Array_index_no,Array_index_depth) ;
    break;}
case 176:
#line 1974 "yacccommands.y"
{
        			PACTION(yyvsp[-3].terminal, yyvsp[-1].split_exp, yyvsp[0].terminal, "", "[ <array_index> ]", yyval.split_exp);
        			nprintf(&LHS(yyval.split_exp), "%n", LHS(yyvsp[-1].split_exp));
        			nprintf(&tmp1_tree, "%n; yourself)", RHS(yyvsp[-1].split_exp));
                    printNode(buffer1,tmp1_tree);
                    deleteNode(tmp1_tree);                         /* Remove this branch now it is not being used */

                    /* See note below in "array_index" */
        			nprintf(&RHS(yyval.split_exp), buffer1, PTOP(Array_index_no,Array_index_depth)-1);
        			PPOP(Array_index_no, Array_index_depth);
    		    ;
    break;}
case 177:
#line 1988 "yacccommands.y"
{
        			PACTION(yyvsp[0].nonterminal, "", "", "", "<expression>", yyval.split_exp);
        			nprintf(&LHS(yyval.split_exp), "(" );

                    /*                                   | 
                     * Note: The the %%d is OK here      V      ( it is instantiated above in "index_ref" with the value PTOP )
                     */
        			nprintf(&RHS(yyval.split_exp), ") at:((Array new:%%d) at: %d put: %n", (long)PTOP(Array_index_no,Array_index_depth)++, yyvsp[0].nonterminal);
    		    ;
    break;}
case 178:
#line 1998 "yacccommands.y"
{
        			PACTION(yyvsp[-2].split_exp, yyvsp[-1].terminal, yyvsp[0].nonterminal, "", "<array_index> , <expression>", yyval.split_exp);

        			/* Possible run time type check for integer expression value here */
        			nprintf(&LHS(yyval.split_exp), "%n", LHS(yyvsp[-2].split_exp));
        			nprintf(&RHS(yyval.split_exp), "%n; at: %d put: %n", RHS(yyvsp[-2].split_exp), (long)PTOP(Array_index_no,Array_index_depth)++, yyvsp[0].nonterminal);
    		    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 2005 "yacccommands.y"
