#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <genie_cmodule.h>
#include <genie_cmodule_ver.h>

void c_test(GenieWorkspace* pars_get, GenieWorkspace* pars_put)
{
    fort_real r;
    fort_int i, len;
    fort_real* ra;
    fort_int* ia;
    fort_int dims[2];
    char* s;
    int count;
    if (!cmodule_version_ok(CMODULE_MAJOR_VERSION, CMODULE_MINOR_VERSION))
	{
		cmodule_print("Library version mismatch for double_them", 						CMODULE_PRINT_ERROR);
		return;
	}
	cmodule_print("Running c_test", CMODULE_PRINT_INFORMATION);
    cmodule_get_real(pars_get, "Real", &r);
    r=r*2;
    cmodule_put_real(pars_put, "Real*2", r);
    cmodule_get_int(pars_get, "Integer", &i);
    i=i*2;
    cmodule_put_int(pars_put, "Integer*2", i);
    ra=NULL;
    cmodule_get_real_array(pars_get, "RealArray", &ra, &len);
    for (count=0; count<len; count++)
        ra[count] *= 2;
    cmodule_put_real_array(pars_put, "RealArray*2", ra, len);
    free(ra);
    ia=NULL;
    cmodule_get_int_array(pars_get, "IntegerArray", &ia, &len);
    for (count=0; count<len; count++)
        ia[count] *= 2;
    cmodule_put_int_array(pars_put, "IntegerArray*2", ia, len);
    free(ia);
    ra=NULL;
    cmodule_get_real_array(pars_get, "twod_RealArray", &ra, &len);
    for (count=0; count<len; count++)
        ra[count] *= 2;
    dims[0]=sqrt(len);
    dims[1]=dims[0];
    cmodule_put_nd_real_array(pars_put, "twod_RealArray*2", ra, dims, 2);
    free(ra);
    cmodule_get_string(pars_get, "String", &s);    
    cmodule_put_string(pars_put, "New_String", s);
    free(s);
}
