#include <stdio.h>
#include <genie_cmodule.h>
#include <genie_cmodule_ver.h>

void cmodule_test(GenieWorkspace* pars_get, GenieWorkspace* pars_put)
{
    fort_int major, minor;
    char* sa[] = { "kk", "oo" };
    fort_real r, *ra;
    fort_double d, *da;
    fort_int i, lsa, lra, lda, lia, *ia;
    char* s;
    fort_int dims_array[2];
    if (!cmodule_version_ok(CMODULE_MAJOR_VERSION, CMODULE_MINOR_VERSION))
    {
        cmodule_print("Library version mismatch in MY_C_MODULE",
		CMODULE_PRINT_ERROR);
        return;
    }
    printf("This module was linked against interface version %d.%d\n", 
	CMODULE_MAJOR_VERSION, CMODULE_MINOR_VERSION);
    cmodule_get_version(&major, &minor);
    printf("GENIE is providing interface version %d.%d\n", major, minor);
    cmodule_print("*** Running CMODULE_TEST ***", CMODULE_PRINT_INFORMATION); 
    cmodule_print("*** Testing GET ***", CMODULE_PRINT_NORMAL); 
    cmodule_get_real(pars_get, "R", &r);
    printf("Got real R = %f\n", r);
    cmodule_get_int(pars_get, "I", &i);
    printf("Got int I = %d\n", i);
    s = 0;
    cmodule_get_string(pars_get, "S", &s);
    printf("Got string S = %s\n", s);
    cmodule_get_double(pars_get, "D", &d);
    printf("Got double D = %f\n", d);
    ra = 0;
    cmodule_get_real_array(pars_get, "RA", &ra, &lra);
    printf("Got real array RA length %d\n", lra);
    for(i=0; i<lra; i++)
	printf("%f ", ra[i]);
    printf("\n");
    da = 0;
    cmodule_get_double_array(pars_get, "DA", &da, &lda);
    printf("Got double array DA length %d\n", lda);
    for(i=0; i<lda; i++)
	printf("%f ", da[i]);
    printf("\n");
    ia = 0;
    cmodule_get_int_array(pars_get, "IA", &ia, &lia);
    printf("Got int array IA length %d\n", lia);
    for(i=0; i<lia; i++)
	printf("%d ", ia[i]);
    printf("\n");
    cmodule_print("*** Testing PUT ***", CMODULE_PRINT_NORMAL); 
    cmodule_put_real(pars_put, "R", r);
    cmodule_put_int(pars_put, "I", i);
    cmodule_put_double(pars_put, "D", d);
    cmodule_put_string(pars_put, "S", s);
    lsa = sizeof(sa) / sizeof(char*);
    cmodule_put_string_array(pars_put, "SA", sa, lsa);
    cmodule_put_real_array(pars_put, "RA", ra, lra);
    cmodule_put_double_array(pars_put, "DA", da, lda);
    cmodule_put_int_array(pars_put, "IA", ia, lia);
    
    cmodule_print("Returning RA as a two D array NDRA", CMODULE_PRINT_INFORMATION);
    dims_array[0] = lra / 2;
    dims_array[1] = 2;
    cmodule_put_nd_real_array(pars_put, "NDRA", ra, dims_array, 2);
    free(ia);
    free(ra);
    free(da);
    free(sa);
    free(s);
}

