C   Open GENIE, a program for neutron scattering data analysis & display
C   ISIS facility, Rutherford Appleton Laboratory, Chilton, Didcot, OXON UK
C   Copyright (C) 1996,1997
C
C   This program is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE FNMULTI(X,Y,YW,N,PARS,NPEAKS,NPARS,TYPES)
C     -----------------------------
C
C Parameters
C   ARGUMENT  TYPE  I/O  DIMENSION  DESCRIPTION
C    N        I*4    I       -      Number of points.
C    X        R*4    I       N      Array of X-coordinates.
C    Y        R*4    O       N      Array of Y-coordinates.
C    PARS     R*4    I       5      Functional parameters.
C
C History
C-----------------------------------------------------------------------
C
    
      REAL X(N),Y(N),YW(N),PARS(NPARS,NPEAKS)
      INTEGER I, J, TYPES(NPEAKS)
      DO I=1,N
          Y(I) = 0.0
      ENDDO
      DO I=1,NPEAKS
          IF (TYPES(I) .EQ. 1) THEN
              CALL FNGAUS(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 2) THEN
              CALL FNGEXP(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 3) THEN
              CALL FNLEXP(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 4) THEN
              CALL FNLORZ(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 5) THEN
              CALL FNVOGT(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 6) THEN
              CALL FNVEXP(X,YW,N,PARS(1,I))
          ELSE IF (TYPES(I) .EQ. 7) THEN
              CALL FNPOLY(X,YW,N,PARS(1,I),NPARS)
          ENDIF
          DO J=1,N
              Y(J) = Y(J) + YW(J)
          ENDDO
      ENDDO
      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
